/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


/* Line 371 of yacc.c  */
#line 616 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     S = 282,
     MS = 283,
     US = 284,
     PORT = 285,
     LOG = 286,
     SYSLOG = 287,
     ALL = 288,
     DEBUG = 289,
     TRACE = 290,
     INFO = 291,
     REMOTE = 292,
     WARNING = 293,
     ERROR = 294,
     AUTH = 295,
     FATAL = 296,
     BUG = 297,
     STDERR = 298,
     SOFT = 299,
     TIMEFORMAT = 300,
     ISO = 301,
     OLD = 302,
     SHORT = 303,
     LONG = 304,
     BASE = 305,
     NAME = 306,
     CONFIRM = 307,
     UNDO = 308,
     CHECK = 309,
     TIMEOUT = 310,
     CONFIGURE = 311,
     DOWN = 312,
     KERNEL = 313,
     PERSIST = 314,
     SCAN = 315,
     TIME = 316,
     LEARN = 317,
     DEVICE = 318,
     ROUTES = 319,
     GRACEFUL = 320,
     RESTART = 321,
     KRT_SOURCE = 322,
     KRT_METRIC = 323,
     TABLE = 324,
     KRT_PREFSRC = 325,
     KRT_REALM = 326,
     ROUTER = 327,
     ID = 328,
     PROTOCOL = 329,
     TEMPLATE = 330,
     PREFERENCE = 331,
     DISABLED = 332,
     DIRECT = 333,
     INTERFACE = 334,
     IMPORT = 335,
     EXPORT = 336,
     FILTER = 337,
     NONE = 338,
     STATES = 339,
     FILTERS = 340,
     RECEIVE = 341,
     LIMIT = 342,
     ACTION = 343,
     WARN = 344,
     BLOCK = 345,
     DISABLE = 346,
     KEEP = 347,
     FILTERED = 348,
     PASSWORD = 349,
     FROM = 350,
     PASSIVE = 351,
     TO = 352,
     EVENTS = 353,
     PACKETS = 354,
     PROTOCOLS = 355,
     INTERFACES = 356,
     PRIMARY = 357,
     STATS = 358,
     COUNT = 359,
     FOR = 360,
     COMMANDS = 361,
     PREEXPORT = 362,
     NOEXPORT = 363,
     GENERATE = 364,
     ROA = 365,
     LISTEN = 366,
     BGP = 367,
     V6ONLY = 368,
     DUAL = 369,
     ADDRESS = 370,
     PASSWORDS = 371,
     DESCRIPTION = 372,
     SORTED = 373,
     RELOAD = 374,
     IN = 375,
     OUT = 376,
     MRTDUMP = 377,
     MESSAGES = 378,
     RESTRICT = 379,
     MEMORY = 380,
     IGP_METRIC = 381,
     CLASS = 382,
     DSCP = 383,
     WAIT = 384,
     MAX = 385,
     FLUSH = 386,
     AS = 387,
     SHOW = 388,
     STATUS = 389,
     SUMMARY = 390,
     ROUTE = 391,
     SYMBOLS = 392,
     ADD = 393,
     DELETE = 394,
     DUMP = 395,
     RESOURCES = 396,
     SOCKETS = 397,
     NEIGHBORS = 398,
     ATTRIBUTES = 399,
     EVAL = 400,
     ECHO = 401,
     ENABLE = 402,
     FUNCTION = 403,
     PRINT = 404,
     PRINTN = 405,
     UNSET = 406,
     RETURN = 407,
     ACCEPT = 408,
     REJECT = 409,
     QUITBIRD = 410,
     INT = 411,
     BOOL = 412,
     IP = 413,
     PREFIX = 414,
     PAIR = 415,
     QUAD = 416,
     EC = 417,
     SET = 418,
     STRING = 419,
     BGPMASK = 420,
     BGPPATH = 421,
     CLIST = 422,
     ECLIST = 423,
     IF = 424,
     THEN = 425,
     ELSE = 426,
     CASE = 427,
     TRUE = 428,
     FALSE = 429,
     RT = 430,
     RO = 431,
     UNKNOWN = 432,
     GENERIC = 433,
     GW = 434,
     NET = 435,
     MASK = 436,
     PROTO = 437,
     SOURCE = 438,
     SCOPE = 439,
     CAST = 440,
     DEST = 441,
     IFNAME = 442,
     IFINDEX = 443,
     LEN = 444,
     DEFINED = 445,
     CONTAINS = 446,
     RESET = 447,
     PREPEND = 448,
     FIRST = 449,
     LAST = 450,
     MATCH = 451,
     ROA_CHECK = 452,
     EMPTY = 453,
     WHERE = 454,
     BFD = 455,
     MIN = 456,
     IDLE = 457,
     RX = 458,
     TX = 459,
     INTERVAL = 460,
     MULTIPLIER = 461,
     MULTIHOP = 462,
     NEIGHBOR = 463,
     DEV = 464,
     LOCAL = 465,
     SESSIONS = 466,
     HOLD = 467,
     CONNECT = 468,
     RETRY = 469,
     KEEPALIVE = 470,
     STARTUP = 471,
     VIA = 472,
     NEXT = 473,
     HOP = 474,
     SELF = 475,
     DEFAULT = 476,
     PATH = 477,
     METRIC = 478,
     START = 479,
     DELAY = 480,
     FORGET = 481,
     AFTER = 482,
     BGP_PATH = 483,
     BGP_LOCAL_PREF = 484,
     BGP_MED = 485,
     BGP_ORIGIN = 486,
     BGP_NEXT_HOP = 487,
     BGP_ATOMIC_AGGR = 488,
     BGP_AGGREGATOR = 489,
     BGP_COMMUNITY = 490,
     BGP_EXT_COMMUNITY = 491,
     RR = 492,
     RS = 493,
     CLIENT = 494,
     CLUSTER = 495,
     AS4 = 496,
     ADVERTISE = 497,
     IPV4 = 498,
     CAPABILITIES = 499,
     PREFER = 500,
     OLDER = 501,
     MISSING = 502,
     LLADDR = 503,
     DROP = 504,
     IGNORE = 505,
     REFRESH = 506,
     INTERPRET = 507,
     COMMUNITIES = 508,
     BGP_ORIGINATOR_ID = 509,
     BGP_CLUSTER_LIST = 510,
     IGP = 511,
     GATEWAY = 512,
     RECURSIVE = 513,
     MED = 514,
     TTL = 515,
     SECURITY = 516,
     DETERMINISTIC = 517,
     SECONDARY = 518,
     ALLOW = 519,
     PATHS = 520,
     AWARE = 521,
     OSPF = 522,
     AREA = 523,
     OSPF_METRIC1 = 524,
     OSPF_METRIC2 = 525,
     OSPF_TAG = 526,
     OSPF_ROUTER_ID = 527,
     RFC1583COMPAT = 528,
     STUB = 529,
     TICK = 530,
     COST = 531,
     COST2 = 532,
     RETRANSMIT = 533,
     HELLO = 534,
     TRANSMIT = 535,
     PRIORITY = 536,
     DEAD = 537,
     TYPE = 538,
     BROADCAST = 539,
     BCAST = 540,
     NONBROADCAST = 541,
     NBMA = 542,
     POINTOPOINT = 543,
     PTP = 544,
     POINTOMULTIPOINT = 545,
     PTMP = 546,
     SIMPLE = 547,
     AUTHENTICATION = 548,
     STRICT = 549,
     CRYPTOGRAPHIC = 550,
     ELIGIBLE = 551,
     POLL = 552,
     NETWORKS = 553,
     HIDDEN = 554,
     VIRTUAL = 555,
     LINK = 556,
     ONLY = 557,
     BUFFER = 558,
     LARGE = 559,
     NORMAL = 560,
     STUBNET = 561,
     TAG = 562,
     EXTERNAL = 563,
     LSADB = 564,
     ECMP = 565,
     WEIGHT = 566,
     NSSA = 567,
     TRANSLATOR = 568,
     STABILITY = 569,
     GLOBAL = 570,
     LSID = 571,
     INSTANCE = 572,
     REAL = 573,
     NETMASK = 574,
     LENGTH = 575,
     MERGE = 576,
     TOPOLOGY = 577,
     STATE = 578,
     PIPE = 579,
     PEER = 580,
     MODE = 581,
     OPAQUE = 582,
     TRANSPARENT = 583,
     RADV = 584,
     RA = 585,
     MANAGED = 586,
     OTHER = 587,
     CONFIG = 588,
     MTU = 589,
     REACHABLE = 590,
     RETRANS = 591,
     TIMER = 592,
     CURRENT = 593,
     VALID = 594,
     PREFERRED = 595,
     MULT = 596,
     LIFETIME = 597,
     SKIP = 598,
     ONLINK = 599,
     AUTONOMOUS = 600,
     RDNSS = 601,
     DNSSL = 602,
     NS = 603,
     DOMAIN = 604,
     TRIGGER = 605,
     SENSITIVE = 606,
     LOW = 607,
     MEDIUM = 608,
     HIGH = 609,
     RIP = 610,
     INFINITY = 611,
     PERIOD = 612,
     GARBAGE = 613,
     MULTICAST = 614,
     QUIET = 615,
     NOLISTEN = 616,
     VERSION1 = 617,
     PLAINTEXT = 618,
     MD5 = 619,
     HONOR = 620,
     NEVER = 621,
     ALWAYS = 622,
     RIP_METRIC = 623,
     RIP_TAG = 624,
     STATIC = 625,
     PROHIBIT = 626,
     MULTIPATH = 627,
     BLACKHOLE = 628,
     UNREACHABLE = 629
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 544 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 1061 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1089 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2862

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  396
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  292
/* YYNRULES -- Number of rules.  */
#define YYNRULES  915
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1716

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   629

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     387,   388,    28,    26,   392,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   389,   386,
      23,    22,    24,   393,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   394,     2,   395,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   390,     2,   391,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    56,    59,    62,    64,    66,    69,
      72,    74,    76,    78,    80,    81,    86,    89,    90,    92,
      95,    97,    99,   103,   105,   109,   111,   113,   115,   117,
     119,   121,   123,   125,   127,   132,   136,   138,   140,   142,
     144,   147,   152,   156,   160,   164,   168,   172,   177,   183,
     187,   191,   196,   199,   200,   202,   203,   205,   208,   211,
     214,   218,   221,   225,   229,   232,   236,   240,   244,   249,
     255,   257,   259,   261,   266,   267,   270,   273,   276,   278,
     280,   286,   287,   289,   293,   297,   298,   307,   309,   314,
     316,   318,   319,   321,   325,   326,   329,   332,   335,   338,
     341,   344,   348,   352,   356,   361,   364,   368,   371,   374,
     376,   378,   380,   381,   384,   387,   390,   393,   396,   398,
     400,   404,   408,   409,   411,   413,   416,   417,   419,   423,
     425,   429,   431,   432,   435,   438,   441,   444,   448,   452,
     456,   457,   461,   463,   465,   469,   471,   475,   477,   479,
     481,   483,   485,   487,   489,   491,   495,   497,   501,   503,
     505,   510,   512,   513,   517,   522,   524,   527,   528,   534,
     540,   546,   552,   557,   561,   565,   570,   576,   578,   579,
     583,   588,   593,   594,   597,   601,   605,   609,   612,   615,
     618,   621,   625,   629,   632,   635,   637,   639,   641,   646,
     647,   651,   655,   659,   660,   662,   664,   669,   670,   673,
     676,   679,   682,   685,   688,   691,   692,   695,   705,   715,
     720,   724,   728,   732,   736,   740,   744,   748,   752,   757,
     759,   761,   765,   766,   768,   772,   776,   780,   784,   789,
     794,   799,   804,   807,   809,   811,   813,   815,   816,   818,
     819,   824,   827,   829,   831,   833,   835,   837,   839,   841,
     843,   845,   847,   849,   851,   854,   857,   858,   862,   864,
     868,   870,   872,   874,   877,   881,   884,   889,   890,   896,
     897,   899,   901,   904,   906,   910,   912,   914,   916,   918,
     920,   924,   926,   928,   932,   934,   936,   938,   940,   942,
     946,   948,   954,   966,   968,   970,   972,   975,   977,   985,
     995,  1003,  1005,  1007,  1009,  1013,  1015,  1017,  1019,  1023,
    1025,  1029,  1031,  1035,  1039,  1041,  1044,  1047,  1054,  1056,
    1060,  1061,  1066,  1070,  1072,  1076,  1080,  1084,  1087,  1090,
    1093,  1096,  1097,  1100,  1103,  1104,  1106,  1108,  1110,  1112,
    1114,  1116,  1118,  1122,  1126,  1128,  1130,  1136,  1144,  1145,
    1150,  1152,  1154,  1156,  1158,  1160,  1162,  1164,  1166,  1168,
    1170,  1172,  1176,  1180,  1184,  1188,  1192,  1196,  1200,  1204,
    1208,  1212,  1216,  1220,  1224,  1228,  1231,  1236,  1238,  1240,
    1242,  1244,  1247,  1250,  1254,  1258,  1265,  1269,  1273,  1277,
    1281,  1287,  1294,  1301,  1308,  1315,  1320,  1329,  1334,  1336,
    1338,  1340,  1342,  1344,  1346,  1348,  1349,  1351,  1355,  1357,
    1361,  1362,  1364,  1369,  1376,  1381,  1385,  1391,  1397,  1402,
    1409,  1413,  1416,  1422,  1428,  1437,  1446,  1455,  1464,  1467,
    1469,  1472,  1475,  1478,  1479,  1483,  1489,  1490,  1493,  1498,
    1503,  1508,  1511,  1514,  1515,  1519,  1520,  1524,  1528,  1531,
    1532,  1535,  1538,  1539,  1542,  1543,  1546,  1551,  1557,  1560,
    1564,  1568,  1574,  1581,  1590,  1597,  1602,  1607,  1613,  1620,
    1627,  1633,  1637,  1641,  1646,  1652,  1658,  1664,  1670,  1676,
    1681,  1686,  1692,  1698,  1704,  1710,  1716,  1722,  1728,  1734,
    1741,  1748,  1757,  1764,  1771,  1777,  1782,  1788,  1793,  1799,
    1804,  1810,  1815,  1821,  1827,  1833,  1839,  1846,  1852,  1858,
    1865,  1871,  1877,  1882,  1885,  1889,  1893,  1895,  1898,  1902,
    1905,  1910,  1914,  1917,  1919,  1922,  1927,  1928,  1932,  1935,
    1937,  1940,  1944,  1948,  1952,  1956,  1959,  1963,  1964,  1970,
    1971,  1977,  1980,  1983,  1985,  1990,  1992,  1994,  1995,  1999,
    2002,  2005,  2008,  2014,  2017,  2018,  2022,  2023,  2026,  2029,
    2033,  2036,  2039,  2043,  2046,  2049,  2052,  2054,  2058,  2061,
    2064,  2067,  2070,  2073,  2076,  2080,  2083,  2086,  2089,  2092,
    2095,  2098,  2101,  2104,  2108,  2112,  2116,  2119,  2123,  2126,
    2130,  2134,  2139,  2142,  2145,  2148,  2152,  2156,  2160,  2163,
    2167,  2171,  2175,  2180,  2183,  2186,  2188,  2189,  2192,  2196,
    2198,  2199,  2201,  2204,  2205,  2208,  2209,  2211,  2215,  2216,
    2217,  2220,  2221,  2225,  2226,  2230,  2231,  2235,  2239,  2241,
    2242,  2247,  2254,  2261,  2268,  2276,  2283,  2291,  2297,  2298,
    2301,  2305,  2308,  2312,  2316,  2319,  2323,  2326,  2329,  2333,
    2337,  2343,  2348,  2353,  2356,  2358,  2361,  2364,  2365,  2369,
    2370,  2374,  2377,  2378,  2382,  2388,  2389,  2394,  2399,  2403,
    2406,  2410,  2414,  2418,  2422,  2427,  2432,  2436,  2439,  2440,
    2444,  2445,  2449,  2453,  2457,  2459,  2461,  2463,  2464,  2465,
    2469,  2470,  2474,  2479,  2481,  2484,  2487,  2490,  2495,  2500,
    2501,  2502,  2506,  2507,  2511,  2515,  2517,  2518,  2519,  2522,
    2525,  2526,  2527,  2531,  2533,  2539,  2541,  2542,  2543,  2546,
    2549,  2550,  2551,  2555,  2557,  2563,  2565,  2568,  2569,  2572,
    2575,  2579,  2583,  2588,  2593,  2598,  2604,  2610,  2615,  2619,
    2624,  2629,  2634,  2639,  2641,  2643,  2645,  2647,  2649,  2651,
    2653,  2655,  2656,  2659,  2662,  2665,  2669,  2673,  2678,  2679,
    2683,  2684,  2688,  2689,  2693,  2696,  2700,  2704,  2710,  2716,
    2720,  2723,  2727,  2731,  2733,  2736,  2741,  2745,  2749,  2753,
    2756,  2759,  2762,  2765,  2768,  2773,  2775,  2777,  2779,  2781,
    2783,  2785,  2787,  2789,  2791,  2793,  2795,  2797,  2799,  2801,
    2803,  2805,  2807,  2809,  2811,  2813,  2815,  2817,  2819,  2821,
    2823,  2825,  2827,  2829,  2831,  2833,  2835,  2837,  2839,  2841,
    2843,  2845,  2847,  2849,  2851,  2853,  2855,  2857,  2859,  2861,
    2863,  2865,  2867,  2869,  2871,  2873,  2875,  2877,  2879,  2881,
    2883,  2885,  2887,  2889,  2891,  2893,  2895,  2898,  2901,  2904,
    2906,  2909,  2912,  2915,  2917,  2920,  2923,  2927,  2931,  2935,
    2939,  2943,  2947,  2951,  2953,  2955,  2957,  2959,  2961,  2963,
    2965,  2967,  2969,  2971,  2973,  2975,  2977,  2979,  2981,  2983,
    2985,  2987,  2989,  2991,  2993,  2995
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     397,     0,    -1,   398,     3,    -1,     4,   683,    -1,    -1,
     398,   682,    -1,    33,    19,    22,   563,   386,    -1,    15,
      -1,   387,   563,   388,    -1,    19,    -1,   400,    38,    -1,
     400,    39,    -1,   400,    40,    -1,   400,    -1,    34,    -1,
      36,    -1,    35,    -1,    37,    -1,    -1,    18,    -1,    19,
      -1,    -1,    30,    19,    -1,    -1,    41,   400,    -1,   403,
     408,    -1,   406,    -1,   403,    -1,    29,   400,    -1,   389,
     403,    -1,    20,    -1,    20,    -1,    19,    -1,    20,    -1,
      -1,    42,   414,   415,   386,    -1,    62,   410,    -1,    -1,
     410,    -1,    43,   413,    -1,    54,    -1,    44,    -1,   390,
     416,   391,    -1,   417,    -1,   416,   392,   417,    -1,    45,
      -1,    46,    -1,    47,    -1,    48,    -1,    49,    -1,    50,
      -1,    51,    -1,    52,    -1,    53,    -1,   133,   111,   470,
     386,    -1,   133,   410,   386,    -1,   147,    -1,    85,    -1,
      61,    -1,    42,    -1,   419,    20,    -1,   419,    20,   400,
      20,    -1,   419,    57,    59,    -1,   419,    57,    60,    -1,
     419,    58,    59,    -1,   419,    58,    60,    -1,    56,   420,
     386,    -1,    67,   428,   429,     3,    -1,    67,    55,   428,
     429,     3,    -1,    67,    63,     3,    -1,    67,    64,     3,
      -1,    67,    65,   428,     3,    -1,    68,     3,    -1,    -1,
      20,    -1,    -1,    66,    -1,    66,   400,    -1,   446,    69,
      -1,    70,   402,    -1,    71,    72,   400,    -1,    73,   402,
      -1,    74,    75,   402,    -1,    76,    77,   402,    -1,   446,
      74,    -1,    71,    72,   400,    -1,   113,   411,   407,    -1,
      69,    80,   400,    -1,    83,    84,   436,   386,    -1,    83,
      84,   106,   461,   386,    -1,    15,    -1,    17,    -1,    18,
      -1,   122,   123,   438,   386,    -1,    -1,   438,   439,    -1,
     126,   403,    -1,    41,   400,    -1,   124,    -1,   125,    -1,
      76,    77,   140,   400,   386,    -1,    -1,   129,    -1,    80,
      19,   441,    -1,   121,    80,    19,    -1,    -1,   444,   121,
     406,   141,    15,   143,    15,   386,    -1,   443,    -1,   443,
     390,   444,   391,    -1,    85,    -1,    86,    -1,    -1,    19,
      -1,    19,   106,    19,    -1,    -1,    87,   400,    -1,    88,
     402,    -1,    45,   467,    -1,   133,   470,    -1,    91,   449,
      -1,    92,   449,    -1,    97,    98,   451,    -1,    91,    98,
     451,    -1,    92,    98,   451,    -1,    91,   103,   104,   402,
      -1,    80,   452,    -1,    83,    84,   436,    -1,   128,   410,
      -1,    93,   527,    -1,   528,    -1,    44,    -1,    94,    -1,
      -1,    99,   100,    -1,    99,   101,    -1,    99,    77,    -1,
      99,   102,    -1,   400,   450,    -1,    35,    -1,    19,    -1,
      45,   111,   467,    -1,    45,   117,   400,    -1,    -1,    20,
      -1,   407,    -1,    20,   407,    -1,    -1,    27,    -1,   454,
     456,   455,    -1,   457,    -1,   458,   392,   457,    -1,   458,
      -1,    -1,   460,   458,    -1,   138,   400,    -1,   139,   400,
      -1,   446,    89,    -1,   463,   447,   390,    -1,   464,   448,
     386,    -1,   464,   466,   386,    -1,    -1,    90,   465,   458,
      -1,    44,    -1,    35,    -1,   390,   468,   391,    -1,   469,
      -1,   468,   392,   469,    -1,    95,    -1,    75,    -1,    96,
      -1,   112,    -1,   109,    -1,   110,    -1,    44,    -1,    35,
      -1,   390,   471,   391,    -1,   472,    -1,   471,   392,   472,
      -1,    95,    -1,   134,    -1,   127,   390,   474,   391,    -1,
     475,    -1,    -1,   475,   386,   474,    -1,   476,   390,   477,
     391,    -1,   476,    -1,   105,   410,    -1,    -1,   120,   106,
     409,   386,   477,    -1,   120,   108,   409,   386,   477,    -1,
     164,   106,   409,   386,   477,    -1,   164,   108,   409,   386,
     477,    -1,    84,   400,   386,   477,    -1,   144,   145,     3,
      -1,   144,   136,     3,    -1,   144,   111,   518,     3,    -1,
     144,   111,    44,   518,     3,    -1,    19,    -1,    -1,   144,
     112,     3,    -1,   144,   112,   146,     3,    -1,   144,   147,
     486,     3,    -1,    -1,   486,   406,    -1,   486,   116,   407,
      -1,   486,    80,    19,    -1,   486,    93,   527,    -1,   486,
     528,    -1,   486,    44,    -1,   486,   113,    -1,   486,   104,
      -1,   486,   487,    19,    -1,   486,    85,    19,    -1,   486,
     114,    -1,   486,   115,    -1,   118,    -1,    92,    -1,   119,
      -1,   144,   121,   489,     3,    -1,    -1,   489,   490,   406,
      -1,   489,   143,    15,    -1,   489,    80,    19,    -1,    -1,
     131,    -1,   116,    -1,   144,   148,   492,     3,    -1,    -1,
     492,    80,    -1,   492,   159,    -1,   492,    93,    -1,   492,
      85,    -1,   492,    86,    -1,   492,   121,    -1,   492,    19,
      -1,    -1,    80,    19,    -1,   149,   121,   406,   141,    15,
     143,    15,   493,     3,    -1,   150,   121,   406,   141,    15,
     143,    15,   493,     3,    -1,   142,   121,   493,     3,    -1,
     151,   152,     3,    -1,   151,   153,     3,    -1,   151,   112,
       3,    -1,   151,   154,     3,    -1,   151,   155,     3,    -1,
     151,    75,     3,    -1,   151,   111,     3,    -1,   156,   563,
       3,    -1,   157,   506,   507,     3,    -1,    44,    -1,    35,
      -1,   390,   416,   391,    -1,    -1,    15,    -1,   102,   517,
       3,    -1,   158,   517,     3,    -1,    77,   517,     3,    -1,
     130,   517,     3,    -1,   130,   131,   517,     3,    -1,   130,
     132,   517,     3,    -1,    45,   517,   467,     3,    -1,   133,
     517,   470,     3,    -1,   135,     3,    -1,    19,    -1,    44,
      -1,    20,    -1,    19,    -1,    -1,    20,    -1,    -1,    93,
      19,   520,   526,    -1,   156,   563,    -1,   167,    -1,   168,
      -1,   169,    -1,   170,    -1,   171,    -1,   172,    -1,   173,
      -1,   175,    -1,   176,    -1,   177,    -1,   178,    -1,   179,
      -1,   522,   174,    -1,   522,    19,    -1,    -1,   523,   386,
     524,    -1,   523,    -1,   523,   386,   525,    -1,   530,    -1,
      19,    -1,   526,    -1,   210,   563,    -1,   387,   525,   388,
      -1,   387,   388,    -1,   524,   390,   533,   391,    -1,    -1,
     159,    19,   532,   529,   530,    -1,    -1,   534,    -1,   569,
      -1,   534,   569,    -1,   569,    -1,   390,   533,   391,    -1,
      18,    -1,    15,    -1,    17,    -1,   536,    -1,    16,    -1,
     387,   563,   388,    -1,    19,    -1,    15,    -1,   387,   563,
     388,    -1,    17,    -1,   536,    -1,    16,    -1,   563,    -1,
     539,    -1,   539,     7,   539,    -1,    28,    -1,   387,   540,
     392,   540,   388,    -1,   387,   540,   392,   540,   388,     7,
     387,   539,   392,   539,   388,    -1,   563,    -1,   186,    -1,
     187,    -1,   188,    15,    -1,   189,    -1,   387,   543,   392,
     542,   392,   542,   388,    -1,   387,   543,   392,   542,   392,
     542,     7,   542,   388,    -1,   387,   543,   392,   542,   392,
      28,   388,    -1,   541,    -1,   544,    -1,   537,    -1,   537,
       7,   537,    -1,   541,    -1,   544,    -1,   538,    -1,   538,
       7,   538,    -1,   545,    -1,   547,   392,   545,    -1,   546,
      -1,   548,   392,   546,    -1,    18,    29,    15,    -1,   549,
      -1,   549,    26,    -1,   549,    27,    -1,   549,   390,    15,
     392,    15,   391,    -1,   550,    -1,   551,   392,   550,    -1,
      -1,   552,   548,   389,   533,    -1,   552,     6,   533,    -1,
     561,    -1,   387,   563,   388,    -1,    13,   555,    14,    -1,
      29,   556,    29,    -1,    15,   555,    -1,    28,   555,    -1,
     393,   555,    -1,   553,   555,    -1,    -1,    15,   556,    -1,
     393,   556,    -1,    -1,    15,    -1,   184,    -1,   185,    -1,
      20,    -1,   536,    -1,   549,    -1,    17,    -1,   394,   547,
     395,    -1,   394,   551,   395,    -1,    16,    -1,   554,    -1,
     387,   563,   392,   563,   388,    -1,   387,   543,   392,   563,
     392,   563,   388,    -1,    -1,    19,   387,   568,   388,    -1,
      19,    -1,   106,    -1,   190,    -1,   191,    -1,   193,    -1,
     194,    -1,   195,    -1,   196,    -1,   197,    -1,   198,    -1,
     199,    -1,   387,   563,   388,    -1,   563,    26,   563,    -1,
     563,    27,   563,    -1,   563,    28,   563,    -1,   563,    29,
     563,    -1,   563,    11,   563,    -1,   563,    12,   563,    -1,
     563,    22,   563,    -1,   563,    10,   563,    -1,   563,    23,
     563,    -1,   563,     9,   563,    -1,   563,    24,   563,    -1,
     563,     8,   563,    -1,   563,    25,   563,    -1,    31,   563,
      -1,   201,   387,   563,   388,    -1,   561,    -1,   557,    -1,
     558,    -1,    87,    -1,   559,   562,    -1,   559,   687,    -1,
     563,    32,   169,    -1,   563,    32,   200,    -1,   563,    32,
     192,   387,   563,   388,    -1,   563,    32,   205,    -1,   563,
      32,   206,    -1,    26,   209,    26,    -1,    27,   209,    27,
      -1,    27,    27,   209,    27,    27,    -1,   204,   387,   563,
     392,   563,   388,    -1,   149,   387,   563,   392,   563,   388,
      -1,   150,   387,   563,   392,   563,   388,    -1,    93,   387,
     563,   392,   563,   388,    -1,   208,   387,    19,   388,    -1,
     208,   387,    19,   392,   563,   392,   563,   388,    -1,    19,
     387,   568,   388,    -1,   166,    -1,   164,    -1,   165,    -1,
      50,    -1,   160,    -1,   161,    -1,   563,    -1,    -1,   565,
      -1,   565,   392,   566,    -1,   563,    -1,   563,   392,   567,
      -1,    -1,   567,    -1,   180,   563,   181,   535,    -1,   180,
     563,   181,   535,   182,   535,    -1,    19,    22,   563,   386,
      -1,   163,   563,   386,    -1,   559,   687,    22,   563,   386,
      -1,   559,   562,    22,   563,   386,    -1,    87,    22,   563,
     386,    -1,   162,   387,   559,   687,   388,   386,    -1,   564,
     566,   386,    -1,   560,   386,    -1,   183,   563,   390,   552,
     391,    -1,   559,   687,    32,   209,   386,    -1,   559,   687,
      32,   204,   387,   563,   388,   386,    -1,   559,   687,    32,
     149,   387,   563,   388,   386,    -1,   559,   687,    32,   150,
     387,   563,   388,   386,    -1,   559,   687,    32,    93,   387,
     563,   388,   386,    -1,   446,   211,    -1,   448,    -1,    90,
     578,    -1,   218,   579,    -1,   219,   583,    -1,    -1,   572,
     571,   386,    -1,   570,   447,   390,   572,   391,    -1,    -1,
     216,   401,    -1,   212,   214,   216,   401,    -1,   212,   215,
     216,   401,    -1,   213,   215,   216,   401,    -1,   217,   400,
      -1,   107,   402,    -1,    -1,   576,   575,   386,    -1,    -1,
     390,   576,   391,    -1,   574,   459,   577,    -1,   574,   577,
      -1,    -1,    30,    19,    -1,   220,   410,    -1,    -1,   221,
     403,    -1,    -1,   218,   402,    -1,   403,   580,   581,   582,
      -1,   144,   211,   222,   482,     3,    -1,   446,   123,    -1,
     585,   447,   390,    -1,   586,   448,   386,    -1,   586,   221,
     143,   400,   386,    -1,   586,   221,   403,   143,   400,   386,
      -1,   586,   219,   403,   404,   405,   143,   400,   386,    -1,
     586,   248,   251,    84,   436,   386,    -1,   586,   248,   250,
     386,    -1,   586,   249,   250,   386,    -1,   586,   223,    72,
     400,   386,    -1,   586,   227,   223,    72,   400,   386,    -1,
     586,   224,   225,    72,   400,   386,    -1,   586,   226,    72,
     400,   386,    -1,   586,    89,   386,    -1,   586,   218,   386,
      -1,   586,   218,   400,   386,    -1,   586,   229,   230,   231,
     386,    -1,   586,   229,   230,   103,   386,    -1,   586,   258,
     259,   231,   386,    -1,   586,   258,   259,   260,   386,    -1,
     586,   258,   259,   261,   386,    -1,   586,   268,    89,   386,
      -1,   586,   268,   269,   386,    -1,   586,   233,   234,   402,
     386,    -1,   586,   270,   234,   402,   386,    -1,   586,   267,
     234,   402,   386,    -1,   586,   256,   257,   402,   386,    -1,
     586,   273,   270,   402,   386,    -1,   586,   232,   241,   400,
     386,    -1,   586,   232,   240,   400,   386,    -1,   586,   194,
     126,   403,   386,    -1,   586,   235,   236,    72,   400,   386,
      -1,   586,    50,   237,    72,   400,   386,    -1,   586,    50,
     140,    72,   400,   392,   400,   386,    -1,   586,   102,   238,
      50,   402,   386,    -1,   586,   158,   147,   262,   402,   386,
      -1,   586,   158,   252,   402,   386,    -1,   586,   255,   402,
     386,    -1,   586,   253,   254,   402,   386,    -1,   586,   105,
     410,   386,    -1,   586,   147,    98,   400,   386,    -1,   586,
     107,   402,   386,    -1,   586,   263,   264,   402,   386,    -1,
     586,   274,   402,   386,    -1,   586,   149,   276,   214,   386,
      -1,   586,   149,   276,   215,   386,    -1,   586,   149,   276,
     402,   386,    -1,   586,   275,   221,   143,   386,    -1,   586,
     275,   221,   143,   400,   386,    -1,   586,    76,    77,   402,
     386,    -1,   586,    76,    77,   277,   386,    -1,   586,    76,
      77,    72,   400,   386,    -1,   586,   267,    80,   452,   386,
      -1,   586,   271,   272,   402,   386,    -1,   586,   211,   402,
     386,    -1,   446,   278,    -1,   587,   447,   390,    -1,   588,
     589,   386,    -1,   448,    -1,   284,   402,    -1,   285,    83,
     402,    -1,   321,   402,    -1,   321,   402,    98,   400,    -1,
     332,   319,   402,    -1,   286,   400,    -1,   591,    -1,   279,
     436,    -1,   590,   390,   592,   391,    -1,    -1,   592,   593,
     386,    -1,   285,   402,    -1,   323,    -1,   146,   402,    -1,
     232,   323,   402,    -1,   232,   287,   400,    -1,   232,   288,
     400,    -1,   285,   287,   400,    -1,   324,   402,    -1,   324,
     325,   400,    -1,    -1,   309,   594,   390,   605,   391,    -1,
      -1,   319,   595,   390,   605,   391,    -1,   317,   596,    -1,
      90,   618,    -1,   600,    -1,   597,   390,   598,   391,    -1,
     597,    -1,   406,    -1,    -1,   598,   599,   386,    -1,   310,
     402,    -1,   146,   402,    -1,   287,   400,    -1,   603,   613,
     390,   601,   391,    -1,   603,   613,    -1,    -1,   601,   602,
     386,    -1,    -1,   290,   400,    -1,   289,   400,    -1,   291,
     236,   400,    -1,   140,   400,    -1,   293,   400,    -1,   293,
     115,   400,    -1,   304,    94,    -1,   304,   303,    -1,   304,
     306,    -1,   473,    -1,   311,   312,   436,    -1,   287,   400,
      -1,   290,   400,    -1,   308,   400,    -1,   289,   400,    -1,
     140,   400,    -1,   293,   400,    -1,   293,   115,   400,    -1,
     294,   295,    -1,   294,   296,    -1,   294,   297,    -1,   294,
     298,    -1,   294,   299,    -1,   294,   300,    -1,   294,   301,
      -1,   294,   302,    -1,   329,   295,   402,    -1,   300,   330,
     402,    -1,   291,   236,   400,    -1,   292,   400,    -1,   305,
     297,   402,    -1,   285,   402,    -1,    65,   312,   402,    -1,
     321,   322,   400,    -1,   154,   390,   609,   391,    -1,   304,
      94,    -1,   304,   303,    -1,   304,   306,    -1,   214,   314,
     316,    -1,   214,   314,   315,    -1,   214,   314,   400,    -1,
     215,   462,    -1,   215,   292,   400,    -1,   215,   331,   400,
      -1,   271,   272,   402,    -1,   271,   272,   215,   313,    -1,
     211,   402,    -1,   274,   402,    -1,   473,    -1,    -1,   605,
     606,    -1,   607,   608,   386,    -1,   406,    -1,    -1,   310,
      -1,   318,   400,    -1,    -1,   609,   611,    -1,    -1,   307,
      -1,    18,   610,   386,    -1,    -1,    -1,   328,   400,    -1,
      -1,   458,   615,   613,    -1,    -1,   616,   604,   386,    -1,
      -1,   390,   616,   391,    -1,   612,   614,   617,    -1,    20,
      -1,    -1,   144,   278,   482,     3,    -1,   144,   278,   154,
     482,   619,     3,    -1,   144,   278,    90,   482,   619,     3,
      -1,   144,   278,   333,   482,   619,     3,    -1,   144,   278,
     333,    44,   482,   619,     3,    -1,   144,   278,   334,   482,
     619,     3,    -1,   144,   278,   334,    44,   482,   619,     3,
      -1,   144,   278,   320,   628,     3,    -1,    -1,   628,   326,
      -1,   628,   279,   436,    -1,   628,   312,    -1,   628,   294,
      15,    -1,   628,   327,   436,    -1,   628,   231,    -1,   628,
      83,   436,    -1,   628,    19,    -1,   446,   335,    -1,   629,
     447,   390,    -1,   630,   448,   386,    -1,   630,   336,    80,
      19,   386,    -1,   630,   337,   338,   386,    -1,   630,   337,
     339,   386,    -1,   446,   340,    -1,   448,    -1,    90,   645,
      -1,   170,   651,    -1,    -1,   357,   633,   657,    -1,    -1,
     358,   634,   663,    -1,   361,   406,    -1,    -1,   635,   632,
     386,    -1,   631,   447,   390,   635,   391,    -1,    -1,   212,
     341,   216,   400,    -1,   141,   341,   216,   400,    -1,   212,
     236,   400,    -1,   342,   402,    -1,   343,   344,   402,    -1,
     312,   345,   400,    -1,   346,    72,   400,    -1,   347,   348,
     400,    -1,   349,   230,    98,   400,    -1,   232,   353,   400,
     665,    -1,   232,    87,   641,    -1,   170,   651,    -1,    -1,
     357,   639,   657,    -1,    -1,   358,   640,   663,    -1,   357,
     221,   402,    -1,   358,   221,   402,    -1,   363,    -1,   364,
      -1,   365,    -1,    -1,    -1,   643,   638,   386,    -1,    -1,
     390,   643,   391,    -1,   637,   459,   644,   642,    -1,   406,
      -1,   354,   402,    -1,   355,   402,    -1,   356,   402,    -1,
     350,   353,   400,   665,    -1,   351,   353,   400,   665,    -1,
      -1,    -1,   649,   647,   386,    -1,    -1,   390,   649,   391,
      -1,   646,   650,   648,    -1,   403,    -1,    -1,    -1,   359,
     652,    -1,   353,   664,    -1,    -1,    -1,   656,   654,   386,
      -1,   652,    -1,   390,   653,   656,   391,   655,    -1,    20,
      -1,    -1,    -1,   360,   658,    -1,   353,   664,    -1,    -1,
      -1,   662,   660,   386,    -1,   658,    -1,   390,   659,   662,
     391,   661,    -1,   400,    -1,   352,   400,    -1,    -1,   362,
     402,    -1,   446,   366,    -1,   666,   447,   390,    -1,   667,
     448,   386,    -1,   667,   367,   400,   386,    -1,   667,    41,
     400,   386,    -1,   667,   368,   400,   386,    -1,   667,   369,
      72,   400,   386,    -1,   667,    66,    72,   400,   386,    -1,
     667,   304,   668,   386,    -1,   667,   473,   386,    -1,   667,
     376,   378,   386,    -1,   667,   376,   219,   386,    -1,   667,
     376,   377,   386,    -1,   667,    90,   674,   386,    -1,   374,
      -1,   375,    -1,    94,    -1,   295,    -1,   370,    -1,   371,
      -1,   372,    -1,   373,    -1,    -1,   234,   400,    -1,   337,
     669,    -1,   215,   462,    -1,   215,   292,   400,    -1,   271,
     272,   402,    -1,   271,   272,   215,   313,    -1,    -1,   671,
     670,   386,    -1,    -1,   390,   671,   391,    -1,    -1,   673,
     458,   672,    -1,   446,   381,    -1,   675,   447,   390,    -1,
     676,   448,   386,    -1,   676,    65,   312,   402,   386,    -1,
     676,   267,    80,   452,   386,    -1,   676,   680,   386,    -1,
     147,   406,    -1,   228,   403,   404,    -1,   678,   322,   400,
      -1,   678,    -1,   679,   678,    -1,   677,   228,   403,   404,
      -1,   677,   228,    20,    -1,   677,   383,   679,    -1,   677,
     269,   403,    -1,   677,   260,    -1,   677,   165,    -1,   677,
     384,    -1,   677,   385,    -1,   677,   382,    -1,   144,   381,
     482,     3,    -1,   386,    -1,   399,    -1,   412,    -1,   418,
      -1,   421,    -1,   435,    -1,   437,    -1,   440,    -1,   442,
      -1,   445,    -1,   684,    -1,   453,    -1,   519,    -1,   521,
      -1,   531,    -1,   422,    -1,   423,    -1,   424,    -1,   425,
      -1,   426,    -1,   427,    -1,   478,    -1,   479,    -1,   480,
      -1,   481,    -1,   483,    -1,   484,    -1,   485,    -1,   488,
      -1,   491,    -1,   494,    -1,   495,    -1,   496,    -1,   497,
      -1,   498,    -1,   499,    -1,   500,    -1,   501,    -1,   502,
      -1,   503,    -1,   504,    -1,   505,    -1,   508,    -1,   509,
      -1,   510,    -1,   511,    -1,   512,    -1,   513,    -1,   514,
      -1,   515,    -1,   516,    -1,   584,    -1,   620,    -1,   621,
      -1,   622,    -1,   623,    -1,   624,    -1,   625,    -1,   626,
      -1,   627,    -1,   681,    -1,   685,   391,    -1,   686,   391,
      -1,   464,   391,    -1,   573,    -1,   586,   391,    -1,   588,
     391,    -1,   630,   391,    -1,   636,    -1,   667,   391,    -1,
     676,   391,    -1,   430,   447,   390,    -1,   685,   448,   386,
      -1,   685,   431,   386,    -1,   685,   434,   386,    -1,   432,
     447,   390,    -1,   686,   448,   386,    -1,   686,   433,   386,
      -1,    78,    -1,    79,    -1,    81,    -1,    82,    -1,   137,
      -1,     5,    -1,   242,    -1,   239,    -1,   243,    -1,   241,
      -1,   240,    -1,   244,    -1,   245,    -1,   246,    -1,   265,
      -1,   266,    -1,   247,    -1,   280,    -1,   281,    -1,   282,
      -1,   283,    -1,   379,    -1,   380,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   739,   739,   740,   743,   745,   753,   762,   763,   764,
     771,   772,   773,   781,   782,   783,   784,   785,   786,   792,
     793,   800,   801,   805,   806,   813,   820,   821,   825,   829,
     836,   844,   845,   852,   853,   859,   868,   869,   873,   878,
     879,   883,   884,   888,   889,   893,   894,   895,   896,   897,
     898,   899,   900,   901,   907,   908,   917,   918,   919,   920,
     923,   924,   925,   926,   927,   928,   932,   939,   942,   949,
     952,   955,   958,   962,   963,   967,   968,   969,   977,   982,
     983,   987,   994,   995,  1001,  1006,  1010,  1024,  1038,  1039,
    1043,  1044,  1045,  1056,  1058,  1060,  1064,  1065,  1066,  1067,
    1072,  1078,  1079,  1083,  1091,  1095,  1097,  1103,  1104,  1111,
    1112,  1116,  1122,  1126,  1136,  1138,  1142,  1143,  1144,  1145,
    1146,  1147,  1148,  1149,  1150,  1151,  1152,  1153,  1157,  1158,
    1159,  1160,  1164,  1165,  1166,  1167,  1168,  1172,  1178,  1182,
    1190,  1191,  1199,  1207,  1208,  1209,  1213,  1214,  1218,  1223,
    1224,  1228,  1230,  1238,  1242,  1243,  1249,  1256,  1257,  1258,
    1262,  1270,  1276,  1277,  1278,  1282,  1283,  1287,  1288,  1289,
    1290,  1291,  1292,  1298,  1299,  1300,  1304,  1305,  1309,  1310,
    1316,  1317,  1320,  1322,  1326,  1327,  1331,  1349,  1350,  1351,
    1352,  1353,  1354,  1362,  1365,  1368,  1371,  1375,  1376,  1379,
    1382,  1386,  1390,  1395,  1401,  1408,  1413,  1418,  1423,  1427,
    1431,  1435,  1444,  1452,  1456,  1463,  1464,  1465,  1470,  1474,
    1481,  1488,  1492,  1500,  1501,  1502,  1507,  1511,  1514,  1515,
    1516,  1517,  1518,  1519,  1520,  1525,  1530,  1538,  1545,  1552,
    1560,  1562,  1564,  1566,  1568,  1570,  1572,  1575,  1579,  1585,
    1586,  1587,  1591,  1592,  1598,  1600,  1602,  1604,  1606,  1608,
    1612,  1616,  1619,  1623,  1624,  1625,  1629,  1630,  1631,  1639,
    1639,  1649,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,
    1661,  1662,  1663,  1664,  1665,  1686,  1697,  1698,  1705,  1706,
    1713,  1722,  1726,  1730,  1754,  1755,  1759,  1772,  1772,  1788,
    1789,  1792,  1793,  1797,  1800,  1809,  1822,  1823,  1824,  1825,
    1826,  1830,  1838,  1839,  1840,  1841,  1842,  1846,  1849,  1850,
    1851,  1855,  1858,  1867,  1870,  1871,  1872,  1873,  1877,  1878,
    1879,  1883,  1884,  1885,  1886,  1890,  1891,  1892,  1893,  1897,
    1898,  1902,  1903,  1907,  1914,  1915,  1916,  1917,  1924,  1925,
    1928,  1929,  1936,  1948,  1949,  1953,  1954,  1958,  1959,  1960,
    1961,  1962,  1966,  1967,  1968,  1972,  1973,  1974,  1975,  1976,
    1977,  1978,  1979,  1980,  1981,  1982,  1986,  1987,  1997,  2001,
    2024,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,
    2047,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2068,  2069,  2070,
    2072,  2074,  2076,  2078,  2079,  2080,  2081,  2082,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2100,  2101,  2106,  2129,  2130,
    2131,  2132,  2133,  2134,  2138,  2141,  2142,  2143,  2151,  2158,
    2167,  2168,  2172,  2178,  2188,  2197,  2203,  2208,  2215,  2220,
    2226,  2227,  2228,  2236,  2237,  2238,  2239,  2240,  2246,  2258,
    2259,  2260,  2261,  2264,  2266,  2270,  2274,  2285,  2286,  2287,
    2288,  2289,  2290,  2293,  2295,  2298,  2300,  2303,  2306,  2311,
    2312,  2313,  2317,  2318,  2322,  2323,  2326,  2345,  2351,  2375,
    2376,  2377,  2378,  2379,  2390,  2391,  2392,  2393,  2394,  2395,
    2396,  2397,  2398,  2399,  2400,  2401,  2402,  2403,  2404,  2405,
    2406,  2407,  2408,  2409,  2410,  2411,  2412,  2413,  2414,  2415,
    2416,  2417,  2418,  2419,  2420,  2421,  2422,  2423,  2424,  2429,
    2430,  2431,  2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,
    2440,  2441,  2442,  2453,  2463,  2464,  2468,  2469,  2470,  2471,
    2472,  2473,  2474,  2475,  2478,  2493,  2496,  2498,  2502,  2503,
    2504,  2505,  2506,  2507,  2508,  2509,  2510,  2511,  2511,  2512,
    2512,  2513,  2514,  2515,  2519,  2520,  2524,  2532,  2534,  2538,
    2539,  2540,  2544,  2545,  2548,  2550,  2553,  2554,  2555,  2556,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2566,  2588,  2589,
    2590,  2591,  2592,  2593,  2594,  2595,  2596,  2597,  2598,  2599,
    2600,  2601,  2602,  2603,  2604,  2605,  2606,  2607,  2608,  2609,
    2610,  2611,  2612,  2613,  2614,  2615,  2616,  2617,  2618,  2619,
    2620,  2621,  2622,  2623,  2624,  2625,  2628,  2630,  2633,  2635,
    2644,  2646,  2647,  2650,  2652,  2656,  2657,  2660,  2670,  2693,
    2695,  2699,  2699,  2702,  2704,  2707,  2709,  2713,  2717,  2718,
    2723,  2726,  2729,  2734,  2737,  2742,  2745,  2749,  2753,  2756,
    2757,  2758,  2759,  2760,  2761,  2762,  2763,  2769,  2776,  2777,
    2778,  2783,  2784,  2790,  2800,  2801,  2802,  2803,  2803,  2804,
    2804,  2805,  2812,  2814,  2818,  2822,  2840,  2841,  2842,  2843,
    2844,  2845,  2846,  2847,  2848,  2849,  2854,  2855,  2856,  2856,
    2857,  2857,  2858,  2859,  2863,  2864,  2865,  2868,  2886,  2888,
    2891,  2893,  2897,  2900,  2913,  2914,  2915,  2916,  2921,  2929,
    2937,  2939,  2942,  2944,  2948,  2952,  2962,  2967,  2968,  2969,
    2973,  2985,  2987,  2991,  2992,  2996,  3009,  3014,  3015,  3016,
    3020,  3032,  3034,  3038,  3039,  3044,  3045,  3049,  3050,  3056,
    3063,  3064,  3065,  3066,  3067,  3068,  3069,  3070,  3071,  3072,
    3073,  3074,  3075,  3079,  3080,  3081,  3086,  3087,  3088,  3089,
    3090,  3093,  3094,  3095,  3096,  3097,  3098,  3099,  3102,  3104,
    3107,  3109,  3113,  3125,  3132,  3139,  3140,  3141,  3142,  3143,
    3146,  3155,  3163,  3170,  3171,  3175,  3180,  3186,  3189,  3194,
    3195,  3196,  3197,  3198,  3201,  3208,  3208,  3208,  3208,  3208,
    3208,  3208,  3208,  3208,  3208,  3208,  3208,  3208,  3208,  3208,
    3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,
    3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,
    3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,
    3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,  3209,
    3209,  3209,  3209,  3209,  3209,  3209,  3210,  3210,  3210,  3210,
    3210,  3210,  3210,  3210,  3210,  3210,  3211,  3211,  3211,  3211,
    3212,  3212,  3212,  3213,  3213,  3213,  3213,  3213,  3214,  3214,
    3215,  3216,  3217,  3218,  3219,  3220,  3221,  3222,  3223,  3224,
    3225,  3225,  3225,  3225,  3225,  3225
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG", "SYSLOG",
  "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH",
  "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT",
  "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ROUTES", "GRACEFUL", "RESTART", "KRT_SOURCE", "KRT_METRIC",
  "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD",
  "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT",
  "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "WAIT",
  "MAX", "FLUSH", "AS", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS", "AWARE",
  "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2",
  "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "LINK", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "MERGE",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RADV", "RA", "MANAGED", "OTHER", "CONFIG", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "RIP", "INFINITY",
  "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN", "VERSION1",
  "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC", "RIP_TAG",
  "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "';'",
  "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "definition", "expr", "expr_us", "bool", "ipa",
  "ipa_scope", "ipa_port", "prefix", "prefix_or_ipa", "pxlen", "datetime",
  "text", "text_or_none", "log_config", "syslog_name", "log_file",
  "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_mode", "cmd_SHOW_ROA", "roa_args",
  "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_item", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,    59,    40,    41,    58,
     123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   396,   397,   397,   398,   398,   399,   400,   400,   400,
     401,   401,   401,   402,   402,   402,   402,   402,   402,   403,
     403,   404,   404,   405,   405,   406,   407,   407,   408,   408,
     409,   410,   410,   411,   411,   412,   413,   413,   414,   414,
     414,   415,   415,   416,   416,   417,   417,   417,   417,   417,
     417,   417,   417,   417,   418,   418,   419,   419,   419,   419,
     420,   420,   420,   420,   420,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   428,   429,   429,   429,   430,   431,
     431,   431,   431,   431,   432,   433,   433,   434,   435,   435,
     436,   436,   436,   437,   438,   438,   439,   439,   439,   439,
     440,   441,   441,   442,   443,   444,   444,   445,   445,   446,
     446,   447,   447,   447,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   448,   449,   449,
     449,   449,   450,   450,   450,   450,   450,   451,   451,   452,
     453,   453,   454,   455,   455,   455,   456,   456,   457,   458,
     458,   459,   460,   461,   462,   462,   463,   464,   464,   464,
     465,   466,   467,   467,   467,   468,   468,   469,   469,   469,
     469,   469,   469,   470,   470,   470,   471,   471,   472,   472,
     473,   473,   474,   474,   475,   475,   476,   477,   477,   477,
     477,   477,   477,   478,   479,   480,   481,   482,   482,   483,
     484,   485,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   487,   487,   487,   488,   489,
     489,   489,   489,   490,   490,   490,   491,   492,   492,   492,
     492,   492,   492,   492,   492,   493,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     506,   506,   507,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   517,   517,   518,   518,   518,   520,
     519,   521,   522,   522,   522,   522,   522,   522,   522,   522,
     522,   522,   522,   522,   522,   523,   524,   524,   525,   525,
     526,   527,   527,   528,   529,   529,   530,   532,   531,   533,
     533,   534,   534,   535,   535,   536,   537,   537,   537,   537,
     537,   537,   538,   538,   538,   538,   538,   539,   540,   540,
     540,   541,   541,   542,   543,   543,   543,   543,   544,   544,
     544,   545,   545,   545,   545,   546,   546,   546,   546,   547,
     547,   548,   548,   549,   550,   550,   550,   550,   551,   551,
     552,   552,   552,   553,   553,   554,   554,   555,   555,   555,
     555,   555,   556,   556,   556,   557,   557,   557,   557,   557,
     557,   557,   557,   557,   557,   557,   558,   558,   559,   560,
     561,   562,   562,   562,   562,   562,   562,   562,   562,   562,
     562,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   564,   564,
     564,   564,   564,   564,   565,   566,   566,   566,   567,   567,
     568,   568,   569,   569,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   569,   569,   570,   571,
     571,   571,   571,   572,   572,   573,   574,   575,   575,   575,
     575,   575,   575,   576,   576,   577,   577,   578,   579,   580,
     580,   580,   581,   581,   582,   582,   583,   584,   585,   586,
     586,   586,   586,   586,   586,   586,   586,   586,   586,   586,
     586,   586,   586,   586,   586,   586,   586,   586,   586,   586,
     586,   586,   586,   586,   586,   586,   586,   586,   586,   586,
     586,   586,   586,   586,   586,   586,   586,   586,   586,   586,
     586,   586,   586,   586,   586,   586,   586,   586,   586,   586,
     586,   586,   586,   587,   588,   588,   589,   589,   589,   589,
     589,   589,   589,   589,   590,   591,   592,   592,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   594,   593,   595,
     593,   593,   593,   593,   596,   596,   597,   598,   598,   599,
     599,   599,   600,   600,   601,   601,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   603,   604,   604,
     604,   604,   604,   604,   604,   604,   604,   604,   604,   604,
     604,   604,   604,   604,   604,   604,   604,   604,   604,   604,
     604,   604,   604,   604,   604,   604,   604,   604,   604,   604,
     604,   604,   604,   604,   604,   604,   605,   605,   606,   607,
     608,   608,   608,   609,   609,   610,   610,   611,   612,   613,
     613,   615,   614,   616,   616,   617,   617,   618,   619,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   629,   630,   630,
     630,   630,   630,   631,   632,   632,   632,   633,   632,   634,
     632,   632,   635,   635,   636,   637,   638,   638,   638,   638,
     638,   638,   638,   638,   638,   638,   638,   638,   639,   638,
     640,   638,   638,   638,   641,   641,   641,   642,   643,   643,
     644,   644,   645,   646,   647,   647,   647,   647,   647,   648,
     649,   649,   650,   650,   651,   652,   653,   654,   654,   654,
     655,   656,   656,   657,   657,   658,   659,   660,   660,   660,
     661,   662,   662,   663,   663,   664,   664,   665,   665,   666,
     667,   667,   667,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   668,   668,   668,   669,   669,   669,   669,
     669,   670,   670,   670,   670,   670,   670,   670,   671,   671,
     672,   672,   673,   674,   675,   676,   676,   676,   676,   676,
     677,   678,   678,   679,   679,   680,   680,   680,   680,   680,
     680,   680,   680,   680,   681,   682,   682,   682,   682,   682,
     682,   682,   682,   682,   682,   682,   682,   682,   682,   682,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   684,   684,   684,   684,
     684,   684,   684,   684,   684,   684,   685,   685,   685,   685,
     686,   686,   686,   687,   687,   687,   687,   687,   687,   687,
     687,   687,   687,   687,   687,   687,   687,   687,   687,   687,
     687,   687,   687,   687,   687,   687
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     0,     2,     2,     1,     1,     2,     2,
       1,     1,     1,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     4,     5,     3,
       3,     4,     2,     0,     1,     0,     1,     2,     2,     2,
       3,     2,     3,     3,     2,     3,     3,     3,     4,     5,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     3,     0,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     4,     2,     3,     2,     2,     1,
       1,     1,     0,     2,     2,     2,     2,     2,     1,     1,
       3,     3,     0,     1,     1,     2,     0,     1,     3,     1,
       3,     1,     0,     2,     2,     2,     2,     3,     3,     3,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       4,     1,     0,     3,     4,     1,     2,     0,     5,     5,
       5,     5,     4,     3,     3,     4,     5,     1,     0,     3,
       4,     4,     0,     2,     3,     3,     3,     2,     2,     2,
       2,     3,     3,     2,     2,     1,     1,     1,     4,     0,
       3,     3,     3,     0,     1,     1,     4,     0,     2,     2,
       2,     2,     2,     2,     2,     0,     2,     9,     9,     4,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     1,
       1,     3,     0,     1,     3,     3,     3,     3,     4,     4,
       4,     4,     2,     1,     1,     1,     1,     0,     1,     0,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     3,     1,     3,
       1,     1,     1,     2,     3,     2,     4,     0,     5,     0,
       1,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     5,    11,     1,     1,     1,     2,     1,     7,     9,
       7,     1,     1,     1,     3,     1,     1,     1,     3,     1,
       3,     1,     3,     3,     1,     2,     2,     6,     1,     3,
       0,     4,     3,     1,     3,     3,     3,     2,     2,     2,
       2,     0,     2,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     1,     5,     7,     0,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     4,     1,     1,     1,
       1,     2,     2,     3,     3,     6,     3,     3,     3,     3,
       5,     6,     6,     6,     6,     4,     8,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     8,     2,     1,
       2,     2,     2,     0,     3,     5,     0,     2,     4,     4,
       4,     2,     2,     0,     3,     0,     3,     3,     2,     0,
       2,     2,     0,     2,     0,     2,     4,     5,     2,     3,
       3,     5,     6,     8,     6,     4,     4,     5,     6,     6,
       5,     3,     3,     4,     5,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     8,     6,     6,     5,     4,     5,     4,     5,     4,
       5,     4,     5,     5,     5,     5,     6,     5,     5,     6,
       5,     5,     4,     2,     3,     3,     1,     2,     3,     2,
       4,     3,     2,     1,     2,     4,     0,     3,     2,     1,
       2,     3,     3,     3,     3,     2,     3,     0,     5,     0,
       5,     2,     2,     1,     4,     1,     1,     0,     3,     2,
       2,     2,     5,     2,     0,     3,     0,     2,     2,     3,
       2,     2,     3,     2,     2,     2,     1,     3,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     2,     3,     2,     3,
       3,     4,     2,     2,     2,     3,     3,     3,     2,     3,
       3,     3,     4,     2,     2,     1,     0,     2,     3,     1,
       0,     1,     2,     0,     2,     0,     1,     3,     0,     0,
       2,     0,     3,     0,     3,     0,     3,     3,     1,     0,
       4,     6,     6,     6,     7,     6,     7,     5,     0,     2,
       3,     2,     3,     3,     2,     3,     2,     2,     3,     3,
       5,     4,     4,     2,     1,     2,     2,     0,     3,     0,
       3,     2,     0,     3,     5,     0,     4,     4,     3,     2,
       3,     3,     3,     3,     4,     4,     3,     2,     0,     3,
       0,     3,     3,     3,     1,     1,     1,     0,     0,     3,
       0,     3,     4,     1,     2,     2,     2,     4,     4,     0,
       0,     3,     0,     3,     3,     1,     0,     0,     2,     2,
       0,     0,     3,     1,     5,     1,     0,     0,     2,     2,
       0,     0,     3,     1,     5,     1,     2,     0,     2,     2,
       3,     3,     4,     4,     4,     5,     5,     4,     3,     4,
       4,     4,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     2,     2,     2,     3,     3,     4,     0,     3,
       0,     3,     0,     3,     2,     3,     3,     5,     5,     3,
       2,     3,     3,     1,     2,     4,     3,     3,     3,     2,
       2,     2,     2,     2,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     1,
       2,     2,     2,     1,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    73,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   378,     0,     0,
     830,   831,   832,   833,   834,   835,   836,   837,   838,   839,
     840,   841,   842,   843,   844,   845,   846,   847,   848,   849,
     850,   851,   852,   853,   854,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,   872,   873,   874,   875,     3,     1,     2,     0,
       0,     0,     0,     0,     0,     0,   109,   110,     0,     0,
       0,     0,   378,     0,   815,   816,   817,   818,   819,   111,
     111,   820,   821,   822,   823,   107,   824,     0,   826,   111,
     114,   827,   828,   829,   111,   879,   111,   114,   111,   114,
     111,   114,   111,   883,   111,   114,   111,   114,     5,   825,
     114,   114,   263,   265,   264,     0,    74,    73,     0,     0,
      73,    75,    72,     0,     0,     0,     0,     0,     0,   262,
     235,   267,     0,   219,     0,     0,   202,   227,     0,   198,
     198,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     361,   365,   374,   371,   305,   380,   368,     0,     0,   364,
     378,   410,     0,     0,     0,   366,   367,     0,     0,     0,
     378,     0,   369,   370,   375,   408,   409,     0,   407,     0,
     250,   249,     0,   252,     0,     0,    32,    31,    37,    40,
      38,     0,     0,     0,    59,    58,    57,    56,     0,     0,
       0,   101,     0,   269,     0,    94,     0,     0,   271,   297,
     112,     0,     0,   105,    78,    84,   156,   488,   458,   543,
     677,   683,   759,   794,     0,     0,     0,     0,     0,    18,
     160,     0,     0,     0,     0,     0,   878,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    18,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,   880,     0,     0,
       0,    18,     0,     0,    18,     0,   881,   546,     0,     0,
     553,     0,     0,     0,   882,     0,     0,     0,     0,     0,
     792,     0,     0,     0,     0,     0,     0,     0,   884,     0,
       0,   181,   185,     0,     0,     0,     0,   885,     0,     0,
       0,     0,    18,     0,    18,     0,     0,   876,     0,     0,
       0,     0,    34,   877,     0,     0,   163,   162,     0,     0,
      75,    69,    70,     0,    76,     0,   256,   254,     0,     0,
     257,   174,   173,     0,     0,     0,     0,   266,   268,   267,
       0,   199,     0,   223,   194,   193,     0,     0,   198,   197,
     198,   198,   668,   198,   198,     0,     0,    19,    20,     0,
       0,     0,   245,   246,   242,   240,   241,   243,   244,   361,
     380,   361,   378,   361,   361,     0,   353,     0,   378,     0,
       0,     0,   364,   364,     0,   405,   378,   378,   378,   378,
     378,     0,   324,   325,     0,   327,     0,     0,   306,   309,
     307,   311,   378,   308,   333,   331,   332,   339,     0,   344,
     348,     0,   898,   893,   894,   895,   896,   381,   897,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   900,   903,
     902,   899,   901,   904,   905,   906,   909,   907,   908,   910,
     911,   912,   913,   914,   915,   411,   412,   247,   378,   378,
     378,   378,   378,   378,   378,   378,   378,   378,   378,   378,
     378,     0,    45,    46,    47,    48,    49,    50,    51,    52,
      53,     0,    43,   253,     0,   255,   378,     0,    39,    41,
       0,     0,   140,     7,     9,   378,   141,    60,     0,     0,
      66,     0,   102,   103,    90,    91,    92,   152,     0,   286,
     104,     0,     0,    55,     0,     0,   886,   890,     0,   157,
     117,   139,   125,     0,   115,    14,    16,    15,    17,    13,
     116,   142,   130,   286,   131,     0,     0,   378,   119,   129,
       0,   120,     0,   127,   118,   158,   159,   463,   489,     0,
       0,    18,   501,     0,     0,     0,     0,    18,     0,    18,
       0,     0,   502,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,     0,     0,     0,    18,
       0,    18,     0,    18,     0,    18,     0,     0,    18,    18,
      18,     0,     0,   490,   544,   554,   547,    18,   552,   549,
      18,   545,   556,   678,     0,     0,     0,   679,   692,   760,
       0,     0,   142,     0,   186,   182,   775,   773,   774,     0,
       0,     0,     0,     0,     0,     0,   761,   768,   187,   795,
      18,   800,     0,   796,   810,     0,   809,     0,   813,     0,
     811,   812,   799,     0,    79,     0,    81,    18,    18,   888,
     889,   887,     0,    33,     0,   892,   891,   168,   167,   169,
     171,   172,   170,     0,   165,   260,     0,    71,    77,    67,
     258,   259,   178,   179,     0,   176,   261,   236,   239,     0,
     195,   200,   218,     0,   225,   224,     0,     0,   201,   208,
       0,     0,   216,   286,   210,   209,   213,   214,     0,   215,
     217,   203,     0,   207,   226,   234,   228,   231,   232,   230,
     233,   229,     0,   659,   659,     0,   198,   659,   198,   659,
     660,   814,     0,     0,    25,     0,     0,   357,   358,     0,
     359,   360,   355,   343,   438,   441,     0,   418,     0,   419,
     362,   363,   356,     0,     0,     0,     0,     0,     0,   326,
     378,   391,   378,   320,   318,     0,     0,   317,     0,     0,
     372,   345,   346,     0,     0,   373,   403,   401,   399,   396,
     397,   398,   400,   402,   404,   392,   393,   394,   395,   413,
       0,   414,   416,   417,   251,     0,   248,     0,    36,     0,
      35,     0,     0,    62,    63,    64,    65,     0,   142,     0,
      88,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,     0,     0,     0,   270,   290,     0,    98,
      99,     0,    93,    95,    54,     0,   286,   113,     0,   108,
     126,   146,   149,   161,   291,   292,   128,   138,   132,   122,
      18,   293,   123,   121,   114,     0,     0,     0,     0,     0,
      18,   527,   529,     0,     0,     0,     0,    18,     0,     0,
     542,   503,     0,    23,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   495,     0,   496,     0,
     525,     0,     0,     0,     0,     0,     0,     0,   509,   510,
       0,     0,     0,   531,     0,   548,     0,   551,     0,     0,
     681,   682,   114,   763,     0,   790,   772,     0,     0,   767,
     762,   764,     0,   770,   771,   769,     0,     0,     0,     0,
       0,     0,   806,    21,   808,     0,   803,   807,    87,    80,
      82,    83,    85,    27,    26,    86,   164,     0,    68,   175,
       0,   196,   222,   221,   220,   205,   212,   206,   204,   211,
     487,   658,     0,     0,   667,   676,     0,   674,     0,     0,
     671,   669,     0,   659,     0,   659,     0,    28,    29,     0,
       0,   354,   378,   427,     0,   378,   378,   378,   406,   378,
     425,   378,     0,     0,   378,   378,   378,   310,   305,   378,
     334,   340,     0,     0,   349,   378,    44,     6,    42,     8,
      61,   100,   153,    89,   285,   284,   286,   378,    97,    96,
     295,   288,     0,   298,     0,   147,     0,   142,     0,   137,
     124,   466,   466,     0,   465,   459,     0,     0,     0,     0,
     538,   537,     0,   528,   532,   533,   534,     0,   524,   518,
      22,     0,     0,   491,     0,   497,     0,   500,     0,   505,
     504,   517,   516,   511,     0,     0,   526,   514,   506,   507,
     508,   530,   540,   513,   512,   541,   515,   535,     0,   550,
     648,    18,     0,    18,   567,     0,     0,   569,   559,    18,
     555,     0,   573,   649,   680,   695,     0,   687,   689,     0,
     694,   684,     0,   766,   788,   793,   180,   182,   765,     0,
       0,     0,     0,     0,   184,   797,   798,   805,    21,     0,
     804,   166,   177,   662,   661,   675,   670,   672,   673,     0,
     663,     0,   665,     0,     0,   439,   420,     0,     0,     0,
       0,     0,   378,   376,   319,   317,     0,     0,   323,     0,
       0,     0,   287,     0,   431,     0,   432,   433,     0,   378,
     429,   430,   428,   378,   378,     0,   378,     0,     0,   378,
     301,     0,   294,     0,   143,   144,   148,   150,   135,   133,
     134,   136,   142,   460,   475,   461,   479,   462,   464,     0,
     520,   539,   522,   523,    24,     0,   492,   499,   498,   519,
     494,   536,   142,   572,   560,     0,     0,    18,     0,   558,
       0,     0,   576,   571,   575,     0,     0,   565,   557,     0,
     583,   142,   685,   723,   732,   686,     0,     0,   691,   693,
     781,   183,   187,    30,     0,     0,     0,     0,   801,   802,
     664,   666,   235,   235,   424,   422,   423,   421,   378,     0,
     321,   378,     0,   415,   378,   378,   378,   378,     0,     0,
       0,   296,   302,     0,     0,   451,   434,   436,     0,   289,
       0,   145,   151,   475,   473,   478,     0,     0,   482,     0,
       0,   651,   655,   562,   563,   561,   564,   636,   597,   577,
     636,   566,   650,   584,   720,   730,   729,   736,   735,   743,
     688,   745,   746,   753,   690,     0,     0,     0,     0,   791,
       0,   192,   187,   187,   187,   187,     0,     0,     0,   377,
       0,     0,     0,   347,     0,     0,     0,     0,   445,   378,
     350,   378,   378,     0,   378,   450,     0,   477,     0,   480,
     481,     0,   484,   521,   493,   649,   653,   657,     0,     0,
       0,   586,   718,   717,     0,   734,   741,   751,     0,     0,
       0,   784,   782,    18,   776,   777,   778,   779,   780,   783,
     789,   188,   189,   190,   191,   237,   238,   426,   378,   330,
     378,   328,   444,   379,   448,     0,   378,   442,   303,     0,
       0,     0,     0,     0,     0,     0,     0,   437,     0,    18,
       0,     0,     0,     0,   476,     0,   483,    18,   486,   652,
       0,   568,   639,   637,   640,    18,     0,    18,   574,     0,
     570,     0,     0,     0,     0,     0,     0,   582,   596,     0,
       0,   722,     0,     0,    18,    18,    18,   733,     0,   737,
     747,   154,   155,   785,     0,   786,     0,     0,     0,     0,
     378,   378,   312,   316,   314,   378,   452,   315,   337,   335,
     336,   341,     0,   447,   446,   378,   378,   378,   378,   453,
     106,   472,     0,     0,     0,     0,   467,   471,   474,   485,
       0,     0,     0,    18,     0,     0,     0,    18,    18,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   656,   635,     0,   641,     0,     0,   580,   581,
     579,   578,   590,   588,   587,     0,     0,   591,   593,   594,
     595,   585,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,   708,   710,   721,     0,     0,     0,   724,   725,
     726,   731,     0,     0,   740,     0,     0,     0,   750,     0,
     787,   378,   329,   449,   304,   443,   352,   317,     0,   378,
       0,     0,     0,     0,     0,     0,     0,     0,    10,    11,
      12,    18,   602,   643,   633,     0,     0,     0,   628,    18,
     634,   618,   598,   601,   599,     0,   616,     0,   603,   605,
     606,   607,   608,   609,   610,   611,   612,    18,   622,   623,
     624,    18,   600,     0,    18,   654,   642,   638,   589,   592,
       0,   707,     0,     0,     0,     0,     0,   699,    18,     0,
       0,     0,    18,     0,    18,     0,   719,   757,   757,     0,
     755,   739,   738,   744,   742,   749,   748,   754,   752,     0,
     313,   378,   338,   351,   342,     0,     0,     0,     0,   468,
     469,   470,   619,     0,   626,   625,   627,   629,   630,     0,
     631,   615,   604,   614,   617,   620,   613,     0,   698,     0,
     714,   715,   716,   706,   757,   701,   700,   702,   703,     0,
     712,   709,   713,   711,    18,   727,   728,   756,   322,     0,
     457,   455,   456,   454,   645,   621,   644,   632,   697,   696,
     705,   704,   758,   646,     0,   647
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    85,   549,  1486,   550,   389,   883,  1062,
     954,   955,   744,  1244,   200,   674,    86,   508,   201,   511,
     501,   502,    87,   208,   209,    88,    20,    21,    22,    23,
      24,    25,   131,   355,    89,   338,    90,   344,   339,    91,
     528,    92,   531,   843,    93,   523,    94,    95,   538,    96,
      97,   221,   247,   558,  1039,   859,   542,    98,   851,  1186,
    1036,   852,  1282,  1283,   818,   819,  1371,    99,   100,   551,
     248,   349,   683,   684,   364,   694,   695,   320,   927,   321,
     322,   939,    26,    27,    28,    29,   385,    30,    31,    32,
     376,   722,    33,   373,   707,    34,   377,   366,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
     193,   504,    47,    48,    49,    50,    51,    52,    53,    54,
      55,   125,   370,   101,   529,   102,   833,   834,   835,  1032,
     855,   856,   559,   846,   837,   103,   534,  1175,  1176,  1397,
     182,   434,  1468,   774,   775,   435,  1157,   776,   436,   437,
    1471,   438,  1472,   183,   440,   441,  1399,   404,   184,   405,
     414,   185,   186,   187,  1178,   188,   475,  1155,  1179,  1277,
    1278,   755,   756,  1180,   104,  1046,   864,   105,  1192,  1415,
    1348,  1285,  1193,  1195,  1288,  1352,  1418,  1197,    56,   106,
     107,   108,   109,   298,   299,   300,   918,  1101,  1220,  1225,
    1223,  1224,  1359,  1429,  1102,  1361,  1439,  1103,  1514,  1358,
    1423,  1424,  1517,  1663,  1714,  1706,  1212,  1230,  1292,  1355,
    1420,  1357,  1213,   972,    57,    58,    59,    60,    61,    62,
      63,    64,   735,   110,   111,   112,  1112,  1236,  1237,   922,
     113,  1231,  1545,  1633,  1635,  1683,  1441,  1440,  1363,  1232,
    1234,  1448,  1365,  1364,  1306,  1235,  1309,  1366,  1555,  1643,
    1449,  1310,  1313,  1367,  1559,  1647,  1450,  1314,  1641,  1695,
     114,   115,   639,  1379,  1320,  1240,  1115,   632,   633,   116,
     117,   329,   946,   947,   330,    65,   118,    66,   119,   120,
     121,   476
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1438
static const yytype_int16 yypact[] =
{
     134,  2601,   159,   640,   577,   854,   151,   577,   577,   725,
     577,   165,    59,  1619,    74,    87,   930,  1561,    63,   577,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,   193,
     462,   310,   553,   155,   219,   242, -1438, -1438,   312,   277,
     256,   278,  1561,   364, -1438, -1438, -1438, -1438, -1438,   386,
     386, -1438, -1438, -1438, -1438,   119, -1438,   709, -1438,   386,
    2008, -1438, -1438, -1438,   386, -1438,   386,  2190,   386,  2089,
     386,  2218,   386, -1438,   386,  2065,   386,  2279, -1438, -1438,
    2399,  2123, -1438, -1438, -1438,    64, -1438,   399,   485,   554,
     399,   471, -1438,   597,   606,   577,   577,   619,   102, -1438,
     547,   712,   144, -1438,   646,   652, -1438, -1438,   423,   533,
     679,   717,   717,   740,   749,   767,   769,   771,   787,   800,
      56, -1438, -1438, -1438,   793,   429, -1438,   617,    79,     4,
    1561, -1438,   442,   444,   446, -1438, -1438,   448,   450,   488,
     909,    70, -1438, -1438, -1438, -1438, -1438,  1878, -1438,  2769,
   -1438, -1438,  1270,   865,   879,   867, -1438, -1438,   844, -1438,
   -1438,   -18,    64,   177, -1438, -1438, -1438, -1438,   373,   512,
     768,   794,   199, -1438,   893, -1438,   102,   551,  2794, -1438,
     824,   549,   564, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438,   566,    64,   932,   875,   177,   673,
   -1438,   117,   686,   864,   738,   102, -1438,   578,   588,   593,
     596,   -30,   922,   615,   778,   738,   673,   908,   756,    62,
     899,   673,   109,   717,   432,   994,   846,  1001,   851,   847,
     536,   845,   850,   563,   830,   833,   673,   831,   832,   825,
       2,     6,   858,   827,   839,   673,   880, -1438,   714,   713,
     611,   673,  1019,   177,   673,   792, -1438, -1438,   728,   726,
   -1438,   736,  1035,   534, -1438,   741,   739,   763,   177,  1086,
   -1438,   738,   770,   -21,   177,   177,  1087,   -22, -1438,   775,
     784, -1438,   779,   785,   860,   717,  1093, -1438,   790,   494,
     799,  1106,   673,  1116,   673,  1114,  1115, -1438,   808,   809,
     813,  1119,  1183, -1438,   818,   819, -1438, -1438,   795,  1203,
     471, -1438, -1438,  1205,   177,  1206, -1438, -1438,  1208,  1212,
   -1438, -1438, -1438,   150,  1213,  1199,  1220, -1438, -1438,   895,
    1222, -1438,  1223,   644, -1438, -1438,  2503,  1274,   679, -1438,
     679,   679, -1438,   298,   440,  1224,  1227, -1438, -1438,    -9,
    1094,  1095, -1438, -1438, -1438, -1438, -1438, -1438, -1438,    56,
   -1438,    56,  1561,    56,    56,  1225, -1438,  1230,   868,  1211,
    1031,  1215,     4,     4,  1217,  1218,  1561,  1561,  1561,  1561,
    1561,  1232, -1438, -1438,  1237, -1438,   862,    34, -1438, -1438,
   -1438, -1438,   823, -1438,  1250, -1438, -1438, -1438,    98,    65,
   -1438,   130, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,  1561,  1561,
    1561,  1561,  1561,  1561,  1561,  1561,  1561,  1561,  1561,  1561,
    1561,   752, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438,   541, -1438, -1438,  1255, -1438,  1561,   738, -1438, -1438,
    1270,   873, -1438, -1438, -1438,  1561, -1438,   177,   889,   917,
   -1438,   177, -1438, -1438, -1438, -1438, -1438, -1438,   874,  2518,
   -1438,    52,   877, -1438,   881,  1242, -1438, -1438,   -24, -1438,
   -1438, -1438, -1438,   611, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438,  2539, -1438,   154,  1163,  1561, -1438, -1438,
     154, -1438,   154, -1438, -1438, -1438, -1438, -1438, -1438,  1198,
    1200,   121, -1438,  1221,   887,   888,   177,   115,  1013,   673,
     717,   890, -1438,   894,  1249,   177,  1138,   177,  1210,   177,
    1214,     9,   177,   177,   673,  1216,   903,  1207,   904,   673,
     906,   673,   266,   673,   932,   673,   918,   919,   673,   673,
     673,   920,  1151, -1438, -1438, -1438, -1438,   673, -1438,  1209,
     673, -1438, -1438, -1438,  1293,   940,   945, -1438, -1438, -1438,
     947,   177, -1438,   954, -1438,  1236, -1438, -1438, -1438,   956,
     958,   961,   177,   963,   971,   972, -1438, -1438,   574, -1438,
     673, -1438,   932, -1438, -1438,   782, -1438,   717, -1438,  1134,
   -1438, -1438, -1438,   177, -1438,   177, -1438,   673,   673, -1438,
   -1438, -1438,   177, -1438,   717, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438,   599, -1438, -1438,  1360, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438,   612, -1438, -1438, -1438, -1438,  1361,
   -1438, -1438, -1438,  1346, -1438, -1438,  1355,   717, -1438, -1438,
    1352,  1353, -1438,  2539, -1438, -1438, -1438, -1438,   717, -1438,
   -1438, -1438,  1357, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438,  1376,  1363,  1363,   455,   679,  1363,   679,  1363,
   -1438, -1438,   177,   717, -1438,  1365,  1366, -1438, -1438,   642,
   -1438, -1438, -1438, -1438,    93, -1438,   997, -1438,  1359, -1438,
   -1438, -1438, -1438,   254,   284,   311,   783,   336,  -138, -1438,
    1561, -1438,  1561, -1438,  1382,   999,  1000,   836,   255,   285,
   -1438, -1438, -1438,  1378,  1387, -1438,  2805,  2805,  2805,  2830,
    2830,  2805,  2805,  2805,  2805,   757,   757,  1218,  1218, -1438,
    1009, -1438, -1438, -1438, -1438,  1270, -1438,  1011, -1438,   637,
   -1438,  1096,  1380, -1438, -1438, -1438, -1438,  1021, -1438,  1023,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438,    94,  1024,  1028, -1438, -1438,   177, -1438,
   -1438,   717, -1438, -1438, -1438,  2366,  2518, -1438,   717, -1438,
   -1438,  1384, -1438,  1022, -1438, -1438, -1438, -1438,  1314, -1438,
     673,  2794, -1438, -1438,  1110,   177,   177,   177,  1034,  1036,
     673, -1438, -1438,  1037,  1038,  1039,  1040,   673,  1048,  1049,
   -1438, -1438,  1402,  1395,  1054,   177,  1055,   177,  1056,   177,
    1057,  1058,  1059,  1060,  1065,   177, -1438,   611, -1438,  1066,
   -1438,  1067,  1070,  1071,  1076,  1077,  1078,  1084, -1438, -1438,
    1085,  1089,  1090, -1438,   114, -1438,   177, -1438,  2186,  1099,
   -1438, -1438,  1969, -1438,  1101,   309, -1438,  1081,  1102, -1438,
   -1438, -1438,  1103, -1438, -1438, -1438,   177,   569,   621,  1082,
    1127,  1129, -1438,  1249, -1438,   717,  1157,  1134, -1438, -1438,
   -1438, -1438, -1438,    -9, -1438, -1438, -1438,   795, -1438, -1438,
     150, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438,  1477,  1489, -1438, -1438,   611, -1438,   611,  1487,
   -1438, -1438,   611,  1363,  1502,  1363,  1509, -1438, -1438,  1373,
    1375, -1438,  1561, -1438,  1492,  1561,  1561,  1561, -1438,  1561,
   -1438,  1561,   561,  1122,  1561,  1282,  1561, -1438, -1438,  1561,
   -1438, -1438,  1130,   793, -1438,  1561, -1438, -1438, -1438, -1438,
   -1438, -1438,  1022, -1438, -1438, -1438,  2518,   805, -1438, -1438,
   -1438,  1135,  1136, -1438,  1385, -1438,   923, -1438,   410, -1438,
   -1438, -1438, -1438,   717, -1438, -1438,  1139,  1140,  1142,  1144,
   -1438, -1438,  1153, -1438, -1438, -1438, -1438,  1154, -1438, -1438,
   -1438,   177,  1399, -1438,  1158, -1438,  1169, -1438,  1170, -1438,
   -1438, -1438, -1438, -1438,  1172,  1173, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,  1174, -1438,
   -1438,   673,    88,   484, -1438,  1251,   717, -1438, -1438,   544,
   -1438,  1175, -1438,  1234, -1438, -1438,   717, -1438, -1438,   717,
   -1438, -1438,  1179, -1438, -1438, -1438, -1438,  1236, -1438,  1180,
    1549,  1549,  1549,  1549, -1438, -1438, -1438, -1438,  1249,   177,
    1157, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,  1567,
   -1438,  1569, -1438,  1560,  1568, -1438, -1438,  1155,  1525,  1585,
    1613,   608,  1561, -1438, -1438,  2794,  1196,  1194,  2794,   836,
    1583,  1692, -1438,     7, -1438,  1577, -1438, -1438,  1219,  1561,
   -1438, -1438, -1438,  1561,  1561,  1228,    22,  1878,  1229,  1319,
   -1438,  2518, -1438,  1586,   717, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438,  1226, -1438,    39, -1438, -1438,   177,
   -1438, -1438, -1438, -1438, -1438,   177, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438,   177,   177,   673,   177, -1438,
    1238,   611, -1438, -1438,  1241,  1243,   177, -1438, -1438,   177,
    1253, -1438, -1438, -1438,  1254, -1438,    35,    16, -1438, -1438,
     320, -1438,   574, -1438,  1240,  1246,  1260,  1261, -1438, -1438,
   -1438, -1438,   547,   547, -1438, -1438, -1438, -1438,  1561,  1725,
    1593,  1480,  1258, -1438,  1561,   868,  1561, -1438,  1917,  2602,
     521, -1438, -1438,  1580,   560, -1438,  2794,  1235,  1264, -1438,
    1460, -1438,  1022,  1226, -1438, -1438,  1599,   738,  1383,  1266,
    1267,  1022,  1272, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438,  1273, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438,    36,   177,  1333,   530, -1438,
    1280, -1438,   574,   574,   574,   574,  1617,  1664,  1762, -1438,
    1281,  1284,     8, -1438,  1942,  1285,  1967,  2003, -1438,  1495,
   -1438,  1561,  1561,   555,  1319, -1438,  1655, -1438,   -13, -1438,
   -1438,   717,  1456, -1438, -1438,  1234, -1438, -1438,    29,   100,
      32,  1126, -1438, -1438,   878, -1438, -1438, -1438,   177,   177,
     177, -1438, -1438,   441, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,  1561, -1438,
    1561, -1438, -1438, -1438, -1438,  1289,   805,  1497, -1438,    17,
    1994,  2019,  1295,  1296,  1299,  1303,  1306, -1438,  1308,   673,
     840,  1481,   177,   177, -1438,  1312, -1438,   673, -1438, -1438,
    2371, -1438, -1438, -1438,   196,   673,   177,   673, -1438,  1313,
   -1438,   177,   177,   177,  1471,    49,    71, -1438, -1438,  1322,
    2217, -1438,  1356,  1369,   673,   673,   673, -1438,  1326,    33,
     248, -1438, -1438, -1438,  1410, -1438,  1334,  1337,  1341,  1338,
    1495,    61, -1438, -1438, -1438,   823, -1438, -1438,  1721, -1438,
   -1438, -1438,   252, -1438, -1438,  1561,  1561,  1561,  1561, -1438,
   -1438, -1438,  1516,  1522,  1523,   622, -1438, -1438, -1438, -1438,
    1429,   177,  1354,   673,  1428,    -7,  1484,   673,   673,   177,
     177,   177,  1507,   177,   120,   841,  1430,    78,  1461,   177,
    1437,  1466, -1438, -1438,  1377, -1438,   177,  1389, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438,   177,   177, -1438, -1438, -1438,
   -1438, -1438,  1427,   717,  -113,   -35,  1431,   673,  1433,  1706,
    1432,  1551,  1558,  1562, -1438,  1396,   177,   177, -1438, -1438,
   -1438, -1438,   224,   717, -1438,  1406,   224,  1773, -1438,  1414,
   -1438,  1561, -1438, -1438, -1438, -1438, -1438,  1787,   126,    61,
     334,  1812,  1837,  1867,  1892,   177,   177,   177, -1438, -1438,
   -1438,   673, -1438, -1438, -1438,    55,   177,   177, -1438,   678,
   -1438, -1438, -1438, -1438, -1438,   177, -1438,   177, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438,   673, -1438, -1438,
   -1438,   673, -1438,   177,   673, -1438, -1438, -1438, -1438, -1438,
    1587, -1438,   177,  1588,   630,   177,   177, -1438,   673,   177,
     177,  1703,   673,    35,   673,    16, -1438,  1440,  1440,   177,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,  1417,
   -1438,  1561, -1438, -1438, -1438,  1420,  1421,  1422,  1439, -1438,
   -1438, -1438, -1438,    -1, -1438, -1438, -1438, -1438, -1438,  1504,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438,   177, -1438,   177,
   -1438, -1438, -1438, -1438,  1440, -1438, -1438, -1438, -1438,   177,
   -1438, -1438, -1438, -1438,   673, -1438, -1438, -1438, -1438,  1787,
   -1438, -1438, -1438, -1438,  1511, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438,  1441, -1438
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1438, -1438, -1438, -1438,  -148,  -562,   -43,  -239,  -894, -1438,
    -146,  -704, -1438,   -76,   -74, -1438, -1438, -1438, -1438, -1438,
    1316,  1026, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438,   412,  1478, -1438, -1438, -1438, -1438, -1438, -1438,
    -287, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438,  1581,   -99,  1590, -1438,   180,  -433, -1438, -1438, -1438,
   -1438,   796,  -549,   598, -1438, -1438,   348, -1438, -1438, -1438,
   -1438,    -4, -1438,   885,   172, -1438,   891, -1171,   733,  -631,
   -1438,  -719, -1438, -1438, -1438, -1438,  -123, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438,  -191, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438,   811,  1483, -1438, -1438, -1438, -1438,  -815,   828,   672,
    1327,  1145,  1479, -1438,  1025, -1438, -1438, -1270, -1438,   397,
    -180,  1092,   300,  -993,   876, -1318, -1161,  1693, -1303,  1105,
     302, -1438, -1438,  -172,  1098, -1438, -1438, -1438, -1438,   347,
     651, -1438, -1438, -1014, -1438,   280,   703,   -17, -1438, -1438,
     542,   896,   633, -1145, -1438, -1438, -1438, -1438,   863, -1438,
   -1438,   604, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,   607,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438,   556, -1438, -1438,
   -1438, -1438, -1438,  -305, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438, -1438, -1438, -1438,   375,   353, -1438, -1438, -1438,
   -1438,   276,   355, -1438, -1438, -1438, -1438,   275,   366, -1437,
   -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1438,   976, -1438, -1438, -1438, -1438, -1438, -1438, -1438,
   -1438, -1050
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -441
static const yytype_int16 yytable[] =
{
     189,   433,   853,   615,   928,   390,   391,   217,   288,   439,
     297,  1154,   305,  1177,   968,  1390,   319,  1704,   328,   412,
     742,   340,   345,  1461,   584,   586,   509,   386,  -300,  1264,
    1031,  1272,  1462,  1463,  1464,  1008,  1311,  -300,  -300,  -300,
    -300,  1163,   478,   479,   480,   481,   482,   387,   388,  1127,
     387,   388,  1624,   387,   388,   516,   483,   484,   485,   486,
     487,   488,   489,   490,   513,   218,   491,  -299,   514,  1286,
     513,   399,  1164,   636,   514,   400,  -299,  -299,  -299,  -299,
    1163,  1469,   604,   925,   401,   428,   429,   430,   164,   431,
     544,   781,   782,   838,  1409,   606,  1470,   848,   190,   346,
    1332,   478,   479,   480,   481,   482,   410,   191,   347,  1165,
     569,  1164,   890,  1024,   583,   483,   484,   485,   486,   487,
     488,   489,   490,  1622,   513,   491,  1459,  1274,   514,   513,
     513,  1368,  1369,   514,   514,   513,   513,   361,     1,   514,
     514,  1462,  1463,  1464,  1008,   618,   362,   371,  1165,   545,
     546,   547,   548,   415,   132,   545,   546,   547,   548,    67,
     630,   552,  1177,   427,  1526,  1528,   640,   641,   139,   513,
     563,   906,  1608,   514,  1368,  1369,   839,   840,   841,   651,
     140,   574,  1166,  1167,  1168,  1169,  1170,  1171,  1172,   857,
    1438,  1566,   513,   867,  1398,   151,   514,   643,   512,  1410,
    1411,  1696,  1173,  1412,  1413,  1174,   688,   570,   152,   578,
     553,   554,   195,   575,   524,   555,   525,   526,   581,   941,
     556,  1166,  1167,  1168,  1169,  1170,  1171,  1172,  1623,  1457,
     721,   540,   210,   600,  1248,  1597,   605,   634,   211,   513,
     891,  1173,   611,   514,  1174,   692,  1425,  1710,   616,  1513,
    1000,   619,  1469,  1337,  1001,   732,   850,   733,   734,  1287,
     737,   739,   478,   479,   480,   481,   482,  1470,  1025,  1022,
     428,   429,   430,  1008,   431,   607,   483,   484,   485,   486,
     487,   488,   489,   490,   693,  1586,   491,  1395,   411,   664,
     372,   666,   478,   479,   480,   481,   482,   196,   197,  1653,
     428,   429,   430,  1008,   431,   527,   483,   484,   485,   486,
     487,   488,   489,   490,   579,  1398,   491,   379,  1625,   478,
     479,   480,   481,   482,  1587,  1177,   212,   557,  1370,   874,
     875,   213,  1185,   483,   484,   485,   486,   487,   488,   489,
     490,   879,   736,   491,   478,   479,   480,   481,   482,  1462,
    1463,  1464,  1008,   637,   638,   644,   645,   214,   483,   484,
     485,   486,   487,   488,   489,   490,  1031,   849,   491,   812,
    1664,  1665,   510,   817,  1529,  1215,  1216,  1530,  1414,   215,
     743,  1609,  1177,   219,  1610,   749,  1552,  1426,   532,   216,
    1705,   754,  1553,   517,  1265,  1456,  1391,   413,   868,   763,
     764,   765,   766,   767,  1465,   220,  1312,   858,  1466,  -300,
    1427,  1217,   858,  -300,   858,   777,   943,   564,   944,   126,
    1421,   202,   771,  1430,  1554,  1307,   772,   203,   873,   973,
     518,   519,   984,   808,   986,   953,   515,   884,   842,   886,
     406,   888,   515,   402,   892,   893,  1177,  1177,  -299,   403,
     387,   388,  -299,   192,   348,   783,   513,   432,   974,   379,
     514,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   975,   545,   546,   547,   548,   953,
    1281,   196,   197,   924,   738,   992,   928,  1188,   351,   807,
     779,  1428,   363,   780,   932,   582,   515,   902,   811,   513,
    1087,   515,   515,   514,   988,   198,  1515,   515,   515,   223,
    1189,  1190,  1191,  1651,  1516,   948,   199,   949,   545,   546,
     547,   548,   784,  1321,   952,   785,   903,   904,   869,   478,
     479,   480,   481,   482,   876,  1315,   878,   354,   976,   350,
     861,   515,   353,   483,   484,   485,   486,   487,   488,   489,
     490,   894,   379,   491,  1316,  1177,   899,   352,   901,   513,
     905,   964,   907,   514,   515,   910,   911,   912,  1649,   478,
     479,   480,   481,   482,   915,   585,  1639,   917,   545,   546,
     547,   548,  1342,   483,   484,   485,   486,   487,   488,   489,
     490,  1317,  1343,   491,   987,   204,   122,   123,   433,   433,
     356,  1556,  1029,  1381,  1382,  1383,  1384,   940,  1557,   357,
    1075,   515,   439,   983,   205,   985,   478,   479,   480,   481,
     482,   124,   360,   380,   950,   951,   524,   365,   525,   526,
     483,   484,   485,   486,   487,   488,   489,   490,   206,  1558,
     491,  1569,  1009,    68,  1570,   378,   995,   702,  1402,   374,
     478,   479,   480,   481,   482,   375,  1454,  1318,   936,   654,
    1578,  1579,  1580,  1291,   483,   484,   485,   486,   487,   488,
     489,   490,   432,    69,   491,  1120,   996,  1121,  1139,   406,
    1141,   406,    70,   406,   406,    71,   977,   381,   513,  1135,
    1028,  1136,   514,   513,   937,  1138,    72,   514,   379,  1114,
     207,  1037,  1034,   997,  1403,  1404,  1128,   545,   546,   547,
     548,  1319,   545,   546,   547,   548,    73,  1047,  1048,  1049,
      74,  1465,   655,    75,   703,    76,    77,  1122,   999,  1123,
     552,   367,   368,    78,   978,   387,   388,  1064,   938,  1066,
     862,  1068,   863,   392,   122,   123,   747,  1074,   748,   979,
     750,   751,   393,  1002,   656,  1003,   369,   196,   197,  1405,
     704,    79,    80,   657,  1406,  1045,  1088,   980,  1089,   124,
     394,  1218,   395,    81,   396,   705,   592,   593,   224,   553,
     554,   981,   982,   225,   560,   489,   490,   706,  1119,   491,
     397,   478,   479,   480,   481,   482,    82,   953,   226,    83,
     387,   388,   942,   398,  1196,   483,   484,   485,   486,   487,
     488,   489,   490,   596,   597,   491,   408,  1040,   133,   134,
     137,   138,   407,  1111,  1163,  1374,   409,  1052,   515,   416,
     194,   417,   227,   418,  1057,   419,   160,   420,   161,   162,
     163,   164,   165,   166,   478,   479,   480,   481,   482,   167,
     168,   773,   169,   382,   170,  1164,   135,   136,   483,   484,
     485,   486,   487,   488,   489,   490,   383,   384,   491,  1226,
     677,   515,   625,   626,   126,   421,   658,   659,   660,   661,
     503,   160,   505,   161,   162,   163,   164,   165,   166,   506,
     678,   679,  1165,  1669,   167,   168,   557,   169,   520,   170,
    1375,  1376,  1377,  1378,   680,   681,   507,   682,   521,   127,
     171,  1340,   530,  1204,   367,   368,   172,   128,   129,   130,
     228,   799,   160,   522,   161,   162,   163,   164,   165,   166,
     535,   515,   804,   805,  1298,   167,   168,   533,   169,   536,
     170,   387,   388,  1184,   800,   953,   358,   359,   813,   814,
    1222,   541,   801,  1152,   537,   171,   539,   802,   803,   543,
    1233,   172,   562,  1238,   565,  1166,  1167,  1168,  1169,  1170,
    1171,  1172,   173,   174,   566,   754,   815,   816,  1147,  1148,
    1149,  1249,  1150,   567,  1151,  1173,   568,   229,  1174,  1158,
     956,   957,  1159,  1680,  1681,  1682,   171,  1308,  1161,   571,
    1258,   572,   172,   959,   960,   153,   576,   175,   176,   422,
     423,   424,   425,  1659,  1660,  1661,   573,   173,   174,   478,
     479,   480,   481,   482,   177,   580,    84,   178,  1018,   805,
     991,   179,   577,   483,   484,   485,   486,   487,   488,   489,
     490,   154,   155,   491,   230,  1245,  1246,  1247,  1214,   231,
    1219,  1289,   175,   176,  1482,  1483,  1227,  1290,   173,   174,
     515,  1326,  1327,   760,   761,   515,   587,  1293,  1294,   177,
    1296,   588,   178,   589,   590,   232,   179,   591,  1301,   594,
     598,  1302,   156,   157,   158,   159,   595,   599,   601,   603,
     233,   602,   608,   175,   176,   422,   423,   424,   425,   609,
     613,   612,   617,   614,   478,   479,   480,   481,   482,   610,
     177,   620,  1416,   178,   621,   624,   622,   179,   483,   484,
     485,   486,   487,   488,   489,   490,   623,   627,   491,   628,
     478,   479,   480,   481,   482,  1259,  1599,  1600,  1601,  1602,
    1603,  1604,  1605,  1606,   483,   484,   485,   486,   487,   488,
     489,   490,  1268,   629,   491,   235,  1269,  1270,   631,   642,
     635,   646,  1276,   478,   479,   480,   481,   482,  1372,   648,
     647,   998,   650,   652,  1295,   649,   653,   483,   484,   485,
     486,   487,   488,   489,   490,   662,   663,   491,   665,   667,
     236,   672,   668,   237,   669,   670,  -299,   238,   239,   671,
    1041,   241,   242,   673,   675,   676,   685,   243,   687,   689,
     180,   690,  1422,  1350,  1422,   691,   696,   181,   697,  1467,
    1451,  1452,  1453,   698,  1007,   700,   701,   740,  1442,  1443,
     741,   311,  1444,  1445,  1446,   745,   746,   757,   244,   752,
     758,  1328,   759,   245,  1158,   753,   762,  1334,   754,  1336,
     491,   768,   769,   312,   770,   180,  -440,   778,   806,   810,
     820,   847,   181,   844,  1485,  1487,  1431,   860,   845,  1447,
     865,   870,   866,   871,   872,   877,   880,   724,  1519,   882,
     881,   885,   887,  1522,  1523,  1524,   889,  1527,   895,   896,
     898,   897,   900,   725,   914,   160,   180,   161,   162,   163,
     164,   165,   166,   181,   908,   909,   913,   916,   167,   168,
     773,   169,   919,   170,  1308,   492,   493,   494,   495,   496,
     497,   498,   499,   500,  1400,  1401,   920,  1276,  1042,  1043,
    1455,   921,   160,   923,   161,   162,   163,   164,   165,   166,
     926,   311,   929,  1582,   930,   167,   168,   931,   169,   933,
     170,  1592,  1593,  1594,   726,  1596,  1598,   934,   935,   727,
     728,  1612,   945,   958,   961,   962,  1481,   729,  1616,   171,
     963,   965,   966,  1158,  1489,   172,   969,  1618,  1619,   970,
     989,   990,  1518,   971,  1520,   993,   994,  1233,  1467,  1004,
    1467,  1005,  1006,  1012,  1308,   730,  1015,  1017,  1637,  1638,
    1020,  1548,  1549,  1550,  1640,  1013,   171,  1021,  1640,  1023,
    1026,  1035,   172,  1038,  1037,  1432,  1433,  1434,  1027,  1435,
    1050,  1060,  1051,  1053,  1054,  1055,  1056,  1485,  1485,  1485,
    1436,   173,   174,   731,  1058,  1059,  1061,  1666,  1667,  1668,
    1063,  1065,  1067,  1069,  1070,  1071,  1072,  1671,  1567,  1672,
    1584,  1073,  1076,  1077,  1590,  1591,  1078,  1079,  1571,  1572,
    1573,  1574,  1080,  1081,  1082,  1675,   175,   176,   173,   174,
    1083,  1084,  1116,  1124,  1678,  1085,  1086,  1684,  1685,  1129,
    1133,  1687,  1688,   177,  1019,  1104,   178,  1113,  1117,  1118,
     179,  1697,  1134,   160,  1627,   161,   162,   163,   164,   165,
     166,  1044,  1137,   175,   176,  1140,   167,   168,  1331,   169,
    1153,   170,  1142,  1125,  1163,  1126,  1143,  1437,  1144,  1146,
     177,  1181,  1160,   178,  1182,  1198,  1183,   179,  1200,  1708,
    1201,  1709,  1199,   478,   479,   480,   481,   482,  1662,  1202,
    1203,  1711,  1205,  1254,  1206,  1164,  1670,   483,   484,   485,
     486,   487,   488,   489,   490,  1207,  1208,   491,  1209,  1210,
    1211,  1228,  1229,  1221,  1673,  1239,  1242,   171,  1674,  1243,
    1250,  1676,  1251,   172,   160,  1252,   161,   162,   163,   164,
     165,   166,  1165,  1253,  1260,  1686,  1261,   167,   168,  1690,
     169,  1692,   170,   478,   479,   480,   481,   482,  1262,  1266,
    1330,  1280,  1341,  1346,  1351,  1373,  1267,   483,   484,   485,
     486,   487,   488,   489,   490,  1275,  1284,   491,  1349,  1271,
    1385,   478,   479,   480,   481,   482,  1322,  1344,  1297,   173,
     174,  1299,  1323,  1300,  1699,   483,   484,   485,   486,   487,
     488,   489,   490,  1303,  1305,   491,  1324,  1325,   171,  1333,
    1345,  1712,  1353,  1354,   172,  1166,  1167,  1168,  1169,  1170,
    1171,  1172,  1356,  1362,   175,   176,  1380,  1386,  1388,   180,
    1408,   222,  1389,  1393,  1417,  1173,   181,  1458,  1174,  1460,
     234,   177,  1475,  1476,   178,   249,  1477,   250,   179,   289,
    1478,   301,  1479,   306,  1480,   307,  1484,   323,  1488,  1521,
     478,   479,   480,   481,   482,  -435,   180,  1525,  1531,  1546,
     173,   174,  1551,   181,   483,   484,   485,   486,   487,   488,
     489,   490,  1547,  1560,   491,  1562,  1561,  1563,  1568,  1564,
     141,   142,  1575,   478,   479,   480,   481,   482,  1576,  1577,
     143,  1581,  1585,  1595,  1583,   175,   176,   483,   484,   485,
     486,   487,   488,   489,   490,   144,  1589,   491,  1611,  1613,
    1607,  1614,   177,  1615,   145,   178,   146,   147,  1620,   179,
     478,   479,   480,   481,   482,  1617,  1626,  1628,  1629,  1632,
    1630,  1631,  1636,  1634,   483,   484,   485,   486,   487,   488,
     489,   490,  1644,  1311,   491,   478,   479,   480,   481,   482,
    1648,  1689,  1694,  1677,  1679,  1698,  1700,  1701,  1702,   483,
     484,   485,   486,   487,   488,   489,   490,  1707,  1713,   491,
     478,   479,   480,   481,   482,  1703,   809,  1715,   686,  1304,
     148,  1016,   561,  1187,   483,   484,   485,   486,   487,   488,
     489,   490,  1131,  1588,   491,   478,   479,   480,   481,   482,
    1241,  1132,   699,  1279,  1162,   723,   836,  1565,   967,   483,
     484,   485,   486,   487,   488,   489,   490,   180,  1652,   491,
    1010,  1033,  1654,   426,   181,   478,   479,   480,   481,   482,
    1273,  1156,  1014,   442,  1011,  1396,  1407,  1347,  1145,   483,
     484,   485,   486,   487,   488,   489,   490,   149,  1335,   491,
     478,   479,   480,   481,   482,  1194,  1642,  1360,  1621,  1691,
    1693,  1419,  1646,  1255,   483,   484,   485,   486,   487,   488,
     489,   490,  1645,  1130,   491,   478,   479,   480,   481,   482,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   483,
     484,   485,   486,   487,   488,   489,   490,     0,   180,   491,
     478,   479,   480,   481,   482,   181,   443,   444,     0,   445,
     446,     0,     0,     0,   483,   484,   485,   486,   487,   488,
     489,   490,     0,  1256,   491,   478,   479,   480,   481,   482,
       0,     0,     0,     0,   447,     0,     0,     0,     0,   483,
     484,   485,   486,   487,   488,   489,   490,     0,     0,   491,
     150,  1257,   478,   479,   480,   481,   482,     0,   442,     0,
       0,     0,     0,     0,   235,   448,   483,   484,   485,   486,
     487,   488,   489,   490,     0,     0,   491,   478,   479,   480,
     481,   482,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   236,
       0,   491,   237,   235,     0,     0,   238,   239,     0,  1105,
     241,   242,     0,     0,     0,     0,   243,     0,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,     0,     0,
    1263,   443,   444,     0,   445,   446,     0,     0,   236,     0,
       0,   237,     0,     0,     0,   238,   239,   244,   240,   241,
     242,     0,   245,     0,     0,   243,   308,     0,     0,     0,
     235,     0,     0,  1329,     0,     0,     0,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,     0,     0,
       0,   309,     0,     0,   235,     0,   244,     0,     0,  1106,
     448,   245,     0,   467,   468,   236,     0,     0,   237,     0,
    1387,     0,   238,   239,     0,   310,   241,   242,   469,   470,
     471,   472,   243,     0,     0,     0,     0,     0,   235,   236,
     311,     0,   237,     0,     0,  1650,   238,   239,     0,     0,
     241,   242,     0,     0,     0,     0,   243,     0,     0,     0,
       0,     0,   312,   244,   341,     0,     0,     0,   245,     0,
    1655,     0,     0,   236,     0,     0,   237,     0,     0,     0,
     238,   239,     0,     0,   241,   242,     0,   244,     0,     0,
     243,     0,   245,     0,     0,  1656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   342,     0,     0,     0,
     251,     0,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   244,     0,     0,     0,  1657,   245,   473,   474,     0,
       0,     0,     0,   235,     0,     0,   252,     0,   467,   468,
     236,     0,     0,   237,     0,     0,  1090,   238,   239,   253,
    1658,   241,   242,   469,   470,   471,   472,   243,     0,     0,
       0,     0,   254,     0,     0,   255,     0,   256,   236,     0,
       0,   237,     0,  1338,     0,   238,   239,     0,     0,   241,
     242,     0,     0,     0,     0,   243,     0,     0,   244,     0,
       0,     0,     0,   245,   235,     0,  1107,  1108,  1392,     0,
    1109,     0,  1091,     0,     0,     0,     0,   257,     0,   258,
       0,     0,     0,     0,   324,     0,   244,     0,   259,     0,
       0,   245,     0,  1394,     0,     0,     0,     0,  1532,   236,
    1110,     0,   237,     0,     0,     0,   238,   239,   290,   313,
     241,   242,     0,   291,   292,   293,   243,     0,     0,     0,
    1473,     0,   473,   474,   260,     0,     0,  1533,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   246,
       0,   261,     0,     0,     0,  1474,     0,   244,   262,   263,
     294,   264,   245,   265,   266,     0,   267,   268,  1092,   269,
       0,   295,   270,   271,     0,   272,   325,     0,     0,  1534,
       0,     0,   314,   315,   316,     0,  1490,     0,   273,   274,
       0,   317,     0,   275,   235,   276,   277,     0,   278,  1535,
       0,     0,     0,   279,     0,     0,   318,   280,   281,     0,
     282,   283,     0,   284,   285,   286,     0,     0,   331,   332,
     333,  1093,   334,   335,     0,   336,   311,     0,     0,   236,
     296,     0,   237,     0,     0,     0,   238,   239,     0,     0,
     241,   242,     0,     0,     0,  1094,   243,  1095,   312,     0,
       0,     0,     0,  1096,     0,  1097,   708,     0,     0,  1098,
    1099,  1491,     0,     0,   343,     0,     0,     0,     0,     0,
       0,   387,   388,     0,     0,  1492,     0,   244,     0,  1536,
       0,     0,   245,   821,   822,   823,   824,   825,   826,   827,
       0,   828,   829,   830,   831,   832,   326,   709,     0,     0,
       0,     0,     0,     0,   302,   303,     0,     0,   854,  1537,
    1538,     0,     0,  1539,  1540,     0,  1541,     0,     0,     0,
       0,     0,     0,     0,  1542,  1543,     0,  1100,     0,     0,
       0,   287,  1493,   710,     0,  1494,  1495,     0,   711,     0,
       0,     0,     0,     0,     0,   712,   713,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   714,  1544,   304,
     478,   479,   480,   481,   482,     0,   715,   716,   717,   718,
       0,   719,   720,     0,   483,   484,   485,   486,   487,   488,
     489,   490,     0,     0,   491,     0,     0,     0,     0,     0,
       0,     0,  1496,     0,     0,  1497,     4,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1498,     0,  1499,     0,
    1500,  1501,  1502,  1503,  1504,  1505,     0,     0,     5,     6,
     327,  1506,     0,     0,     0,  1507,  1508,     0,     7,  1509,
       0,     0,     0,     0,     0,   821,   822,   823,   824,   825,
     826,   827,  1510,   828,   829,   830,   831,   832,     0,     0,
    1511,     0,     0,     8,     0,     0,   821,   822,   823,   824,
     825,   826,   827,   557,   828,   829,   830,   831,   832,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     9,     0,     0,    10,     0,    11,     0,     0,     0,
       0,     0,     0,    12,     0,    13,     0,     0,     0,     0,
      14,    15,    16,     0,  1030,     0,     0,    17,    18,    19,
       0,     0,  1512,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   477,     0,     0,     0,     0,   478,   479,   480,
     481,   482,     0,  1339,     0,     0,     0,     0,     0,     0,
     337,   483,   484,   485,   486,   487,   488,   489,   490,     0,
       0,   491,   478,   479,   480,   481,   482,     0,     0,     0,
       0,     0,     0,  -441,  -441,  -441,   483,   484,   485,   486,
     487,   488,   489,   490,     0,     0,   491,  -441,  -441,  -441,
    -441,   487,   488,   489,   490,     0,     0,   491,   478,   479,
     480,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   483,   484,   485,   486,   487,   488,   489,   490,
       0,     0,   491
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1438)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-441)))

static const yytype_int16 yycheck[] =
{
      17,   181,   551,   290,   635,   151,   152,    81,   107,   181,
     109,  1004,   111,  1027,   718,     7,   115,    18,   117,    15,
      29,   120,   121,     6,   263,   264,    44,   150,     6,    22,
     845,  1176,    15,    16,    17,    18,    20,    15,    16,    17,
      18,    19,     8,     9,    10,    11,    12,    18,    19,   943,
      18,    19,    87,    18,    19,   203,    22,    23,    24,    25,
      26,    27,    28,    29,    15,    82,    32,     6,    19,    30,
      15,    15,    50,    94,    19,    19,    15,    16,    17,    18,
      19,  1399,    80,   632,    28,    15,    16,    17,    18,    19,
     238,    26,    27,    41,   107,    89,  1399,   121,    35,    35,
    1261,     8,     9,    10,    11,    12,    27,    44,    44,    87,
     140,    50,   103,    19,   262,    22,    23,    24,    25,    26,
      27,    28,    29,   236,    15,    32,  1396,  1177,    19,    15,
      15,   138,   139,    19,    19,    15,    15,    35,     4,    19,
      19,    15,    16,    17,    18,   293,    44,     3,    87,    34,
      35,    36,    37,   170,     3,    34,    35,    36,    37,     0,
     308,    44,  1176,   180,   115,    94,   314,   315,     3,    15,
     244,   604,    94,    19,   138,   139,   124,   125,   126,   325,
     121,   255,   160,   161,   162,   163,   164,   165,   166,    35,
    1361,  1461,    15,    72,  1339,   121,    19,   219,   202,   212,
     213,  1638,   180,   216,   217,   183,   354,   237,   121,   147,
      93,    94,    19,   256,    15,    98,    17,    18,   261,   652,
     103,   160,   161,   162,   163,   164,   165,   166,   341,  1390,
     376,   235,    77,   276,  1128,   115,   234,   311,    19,    15,
     231,   180,   285,    19,   183,    95,   146,  1684,   291,  1420,
     388,   294,  1570,  1267,   392,   378,   543,   380,   381,   220,
     383,   384,     8,     9,    10,    11,    12,  1570,   174,   818,
      15,    16,    17,    18,    19,   269,    22,    23,    24,    25,
      26,    27,    28,    29,   134,   292,    32,  1337,   209,   332,
     146,   334,     8,     9,    10,    11,    12,    19,    20,  1569,
      15,    16,    17,    18,    19,   106,    22,    23,    24,    25,
      26,    27,    28,    29,   252,  1460,    32,    19,   353,     8,
       9,    10,    11,    12,   331,  1339,    84,   210,   292,   214,
     215,    19,  1036,    22,    23,    24,    25,    26,    27,    28,
      29,   580,    44,    32,     8,     9,    10,    11,    12,    15,
      16,    17,    18,   374,   375,   377,   378,    80,    22,    23,
      24,    25,    26,    27,    28,    29,  1181,   391,    32,   517,
     315,   316,   390,   521,   303,   287,   288,   306,   391,   123,
     389,   303,  1396,    19,   306,   402,   353,   287,   216,   111,
     391,   408,   359,    20,   387,  1388,   388,   393,   277,   416,
     417,   418,   419,   420,   387,    19,   390,   555,   391,   387,
     310,   323,   560,   391,   562,   432,   655,   245,   657,    20,
     391,   111,   388,   391,   391,   390,   392,   117,   576,   734,
      57,    58,   737,   507,   739,   674,   387,   585,   386,   587,
     160,   589,   387,   387,   592,   593,  1460,  1461,   387,   393,
      18,    19,   391,   390,   390,   390,    15,   387,     3,    19,
      19,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,    19,    34,    35,    36,    37,   718,
    1184,    19,    20,   631,    44,   392,  1117,    77,     3,   506,
     392,   391,   390,   395,   642,   386,   387,   231,   515,    15,
     386,   387,   387,    19,   743,    43,   310,   387,   387,   390,
     100,   101,   102,   387,   318,   663,    54,   665,    34,    35,
      36,    37,   392,  1242,   672,   395,   260,   261,   571,     8,
       9,    10,    11,    12,   577,   215,   579,    66,    83,   127,
     557,   387,   130,    22,    23,    24,    25,    26,    27,    28,
      29,   594,    19,    32,   234,  1569,   599,     3,   601,    15,
     603,   707,   605,    19,   387,   608,   609,   610,  1561,     8,
       9,    10,    11,    12,   617,   143,   352,   620,    34,    35,
      36,    37,    22,    22,    23,    24,    25,    26,    27,    28,
      29,   271,    32,    32,   742,    42,    19,    20,   778,   779,
       3,   353,   841,  1322,  1323,  1324,  1325,   650,   360,     3,
     897,   387,   784,   736,    61,   738,     8,     9,    10,    11,
      12,    44,     3,    90,   667,   668,    15,    80,    17,    18,
      22,    23,    24,    25,    26,    27,    28,    29,    85,   391,
      32,   389,   387,     3,   392,   222,   392,     3,    93,     3,
       8,     9,    10,    11,    12,     3,   215,   337,    84,   165,
      38,    39,    40,  1212,    22,    23,    24,    25,    26,    27,
      28,    29,   387,    33,    32,   106,   392,   108,   983,   399,
     985,   401,    42,   403,   404,    45,   231,   154,    15,   976,
     838,   978,    19,    15,   120,   982,    56,    19,    19,   390,
     147,   392,   848,   392,   149,   150,   945,    34,    35,    36,
      37,   391,    34,    35,    36,    37,    76,   865,   866,   867,
      80,   387,   228,    83,    80,    85,    86,   106,   392,   108,
      44,    19,    20,    93,   279,    18,    19,   885,   164,   887,
     560,   889,   562,     3,    19,    20,   399,   895,   401,   294,
     403,   404,     3,   770,   260,   772,    44,    19,    20,   204,
     116,   121,   122,   269,   209,   864,   914,   312,   916,    44,
       3,   287,     3,   133,     3,   131,   240,   241,    69,    93,
      94,   326,   327,    74,    98,    28,    29,   143,   936,    32,
       3,     8,     9,    10,    11,    12,   156,  1036,    89,   159,
      18,    19,    20,     3,  1043,    22,    23,    24,    25,    26,
      27,    28,    29,   250,   251,    32,   387,   860,     7,     8,
       9,    10,    29,   922,    19,   295,   209,   870,   387,   387,
      19,   387,   123,   387,   877,   387,    13,   387,    15,    16,
      17,    18,    19,    20,     8,     9,    10,    11,    12,    26,
      27,    28,    29,   320,    31,    50,   131,   132,    22,    23,
      24,    25,    26,    27,    28,    29,   333,   334,    32,   325,
      75,   387,   338,   339,    20,   387,   382,   383,   384,   385,
      15,    13,     3,    15,    16,    17,    18,    19,    20,    22,
      95,    96,    87,   215,    26,    27,   210,    29,   386,    31,
     370,   371,   372,   373,   109,   110,    62,   112,   140,    55,
      87,   390,    19,  1061,    19,    20,    93,    63,    64,    65,
     211,   169,    13,   129,    15,    16,    17,    18,    19,    20,
     106,   387,   391,   392,  1221,    26,    27,   386,    29,   390,
      31,    18,    19,    20,   192,  1184,   135,   136,    59,    60,
    1096,    19,   200,   392,   390,    87,   390,   205,   206,    84,
    1106,    93,    98,  1109,   386,   160,   161,   162,   163,   164,
     165,   166,   149,   150,   386,   992,    59,    60,   995,   996,
     997,  1129,   999,   390,  1001,   180,   390,   278,   183,  1006,
     391,   392,  1009,   363,   364,   365,    87,  1236,  1015,    77,
     392,   386,    93,   391,   392,    75,    98,   184,   185,   186,
     187,   188,   189,  1575,  1576,  1577,   238,   149,   150,     8,
       9,    10,    11,    12,   201,   126,   386,   204,   391,   392,
     388,   208,   276,    22,    23,    24,    25,    26,    27,    28,
      29,   111,   112,    32,   335,  1121,  1122,  1123,  1091,   340,
    1093,  1199,   184,   185,   214,   215,  1099,  1205,   149,   150,
     387,  1252,  1253,   412,   413,   387,    72,  1215,  1216,   201,
    1218,   225,   204,    72,   223,   366,   208,   230,  1226,   234,
     250,  1229,   152,   153,   154,   155,   236,   254,   257,   264,
     381,   259,   234,   184,   185,   186,   187,   188,   189,   272,
     386,   221,    83,   390,     8,     9,    10,    11,    12,   270,
     201,   319,  1351,   204,   386,    80,   390,   208,    22,    23,
      24,    25,    26,    27,    28,    29,   390,   386,    32,   390,
       8,     9,    10,    11,    12,  1152,   295,   296,   297,   298,
     299,   300,   301,   302,    22,    23,    24,    25,    26,    27,
      28,    29,  1169,   390,    32,    45,  1173,  1174,    72,    72,
     390,   386,  1179,     8,     9,    10,    11,    12,  1316,   390,
     386,   388,   312,    80,  1217,   390,   386,    22,    23,    24,
      25,    26,    27,    28,    29,   386,    80,    32,    72,    75,
      80,    72,    77,    83,   386,   386,   391,    87,    88,   386,
      90,    91,    92,    20,   386,   386,     3,    97,     3,     3,
     387,     3,  1358,  1287,  1360,     3,     3,   394,    19,  1399,
    1368,  1369,  1370,     3,   388,     3,     3,     3,   350,   351,
       3,   105,   354,   355,   356,   141,   141,    26,   128,    14,
     209,  1258,    27,   133,  1261,    15,    29,  1264,  1265,  1266,
      32,    19,    15,   127,   392,   387,   388,     7,     3,   386,
     386,    19,   394,   386,  1412,  1413,   140,   104,   387,   391,
      72,    50,    72,   386,   386,   262,   386,     3,  1426,    30,
     386,   143,    72,  1431,  1432,  1433,    72,  1435,    72,   386,
     386,    84,   386,    19,   143,    13,   387,    15,    16,    17,
      18,    19,    20,   394,   386,   386,   386,    98,    26,    27,
      28,    29,    19,    31,  1553,    45,    46,    47,    48,    49,
      50,    51,    52,    53,  1341,  1342,   386,  1344,   218,   219,
    1373,   386,    13,   386,    15,    16,    17,    18,    19,    20,
     386,   105,   386,  1491,   386,    26,    27,   386,    29,   386,
      31,  1499,  1500,  1501,    80,  1503,  1504,   386,   386,    85,
      86,  1509,   228,     3,     3,    19,  1409,    93,  1516,    87,
      15,    19,    19,  1390,  1417,    93,    19,  1525,  1526,     3,
      15,    15,  1425,    20,  1427,   388,    27,  1533,  1568,     7,
    1570,   392,   392,    15,  1633,   121,   387,   386,  1546,  1547,
      20,  1444,  1445,  1446,  1552,    18,    87,   386,  1556,   386,
     386,    27,    93,    99,   392,   289,   290,   291,   390,   293,
     386,    19,   386,   386,   386,   386,   386,  1575,  1576,  1577,
     304,   149,   150,   159,   386,   386,    41,  1585,  1586,  1587,
     386,   386,   386,   386,   386,   386,   386,  1595,  1465,  1597,
    1493,   386,   386,   386,  1497,  1498,   386,   386,  1475,  1476,
    1477,  1478,   386,   386,   386,  1613,   184,   185,   149,   150,
     386,   386,   391,   391,  1622,   386,   386,  1625,  1626,   322,
       3,  1629,  1630,   201,   388,   386,   204,   386,   386,   386,
     208,  1639,     3,    13,  1537,    15,    16,    17,    18,    19,
      20,   391,    15,   184,   185,     3,    26,    27,    28,    29,
     388,    31,     3,   386,    19,   386,   143,   391,   143,    27,
     201,   386,   392,   204,   388,   386,   141,   208,   386,  1677,
     386,  1679,   392,     8,     9,    10,    11,    12,  1581,   386,
     386,  1689,   143,   388,   386,    50,  1589,    22,    23,    24,
      25,    26,    27,    28,    29,   386,   386,    32,   386,   386,
     386,   386,   328,   312,  1607,   386,   386,    87,  1611,    20,
       3,  1614,     3,    93,    13,    15,    15,    16,    17,    18,
      19,    20,    87,    15,   388,  1628,   392,    26,    27,  1632,
      29,  1634,    31,     8,     9,    10,    11,    12,    15,    22,
       7,    15,    22,   143,   221,   272,   387,    22,    23,    24,
      25,    26,    27,    28,    29,   386,   390,    32,    19,   391,
       3,     8,     9,    10,    11,    12,   386,   392,   390,   149,
     150,   390,   386,   390,  1651,    22,    23,    24,    25,    26,
      27,    28,    29,   390,   390,    32,   386,   386,    87,   391,
     386,  1694,   386,   386,    93,   160,   161,   162,   163,   164,
     165,   166,   390,   390,   184,   185,   386,     3,   387,   387,
      15,    90,   388,   388,   218,   180,   394,   388,   183,   182,
      99,   201,   387,   387,   204,   104,   387,   106,   208,   108,
     387,   110,   386,   112,   386,   114,   215,   116,   386,   386,
       8,     9,    10,    11,    12,   386,   387,   236,   386,   353,
     149,   150,   386,   394,    22,    23,    24,    25,    26,    27,
      28,    29,   353,   313,    32,   388,   392,   386,     7,   391,
     111,   112,   216,     8,     9,    10,    11,    12,   216,   216,
     121,   312,   314,   236,   390,   184,   185,    22,    23,    24,
      25,    26,    27,    28,    29,   136,   272,    32,   297,   322,
     330,   295,   201,   386,   145,   204,   147,   148,   341,   208,
       8,     9,    10,    11,    12,   386,   345,   344,    72,   221,
     348,   230,   386,   221,    22,    23,    24,    25,    26,    27,
      28,    29,   386,    20,    32,     8,     9,    10,    11,    12,
     386,    98,   362,   216,   216,   388,   386,   386,   386,    22,
      23,    24,    25,    26,    27,    28,    29,   313,   307,    32,
       8,     9,    10,    11,    12,   386,   510,   386,   350,  1231,
     211,   805,   242,  1037,    22,    23,    24,    25,    26,    27,
      28,    29,   957,  1495,    32,     8,     9,    10,    11,    12,
    1117,   960,   369,  1181,  1026,   376,   529,  1460,   713,    22,
      23,    24,    25,    26,    27,    28,    29,   387,  1568,    32,
     778,   846,  1570,   180,   394,     8,     9,    10,    11,    12,
    1177,  1005,   784,     5,   779,   390,  1344,  1283,   992,    22,
      23,    24,    25,    26,    27,    28,    29,   278,  1265,    32,
       8,     9,    10,    11,    12,  1042,  1553,  1300,  1533,  1633,
    1635,  1355,  1557,   388,    22,    23,    24,    25,    26,    27,
      28,    29,  1556,   947,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,   387,    32,
       8,     9,    10,    11,    12,   394,    78,    79,    -1,    81,
      82,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,   388,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
     381,   388,     8,     9,    10,    11,    12,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    45,   137,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    80,
      -1,    32,    83,    45,    -1,    -1,    87,    88,    -1,    90,
      91,    92,    -1,    -1,    -1,    -1,    97,    -1,   190,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,    -1,    -1,
     388,    78,    79,    -1,    81,    82,    -1,    -1,    80,    -1,
      -1,    83,    -1,    -1,    -1,    87,    88,   128,    90,    91,
      92,    -1,   133,    -1,    -1,    97,    41,    -1,    -1,    -1,
      45,    -1,    -1,   388,    -1,    -1,    -1,   239,   240,   241,
     242,   243,   244,   245,   246,   247,    -1,    -1,    -1,    -1,
      -1,    66,    -1,    -1,    45,    -1,   128,    -1,    -1,   170,
     137,   133,    -1,   265,   266,    80,    -1,    -1,    83,    -1,
     388,    -1,    87,    88,    -1,    90,    91,    92,   280,   281,
     282,   283,    97,    -1,    -1,    -1,    -1,    -1,    45,    80,
     105,    -1,    83,    -1,    -1,   388,    87,    88,    -1,    -1,
      91,    92,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,
      -1,    -1,   127,   128,    71,    -1,    -1,    -1,   133,    -1,
     388,    -1,    -1,    80,    -1,    -1,    83,    -1,    -1,    -1,
      87,    88,    -1,    -1,    91,    92,    -1,   128,    -1,    -1,
      97,    -1,   133,    -1,    -1,   388,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,   113,    -1,    -1,    -1,
      50,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   128,    -1,    -1,    -1,   388,   133,   379,   380,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    76,    -1,   265,   266,
      80,    -1,    -1,    83,    -1,    -1,    90,    87,    88,    89,
     388,    91,    92,   280,   281,   282,   283,    97,    -1,    -1,
      -1,    -1,   102,    -1,    -1,   105,    -1,   107,    80,    -1,
      -1,    83,    -1,   386,    -1,    87,    88,    -1,    -1,    91,
      92,    -1,    -1,    -1,    -1,    97,    -1,    -1,   128,    -1,
      -1,    -1,    -1,   133,    45,    -1,   357,   358,   386,    -1,
     361,    -1,   146,    -1,    -1,    -1,    -1,   147,    -1,   149,
      -1,    -1,    -1,    -1,    65,    -1,   128,    -1,   158,    -1,
      -1,   133,    -1,   386,    -1,    -1,    -1,    -1,   141,    80,
     391,    -1,    83,    -1,    -1,    -1,    87,    88,   279,   304,
      91,    92,    -1,   284,   285,   286,    97,    -1,    -1,    -1,
     386,    -1,   379,   380,   194,    -1,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   391,
      -1,   211,    -1,    -1,    -1,   386,    -1,   128,   218,   219,
     321,   221,   133,   223,   224,    -1,   226,   227,   232,   229,
      -1,   332,   232,   233,    -1,   235,   147,    -1,    -1,   212,
      -1,    -1,   367,   368,   369,    -1,    65,    -1,   248,   249,
      -1,   376,    -1,   253,    45,   255,   256,    -1,   258,   232,
      -1,    -1,    -1,   263,    -1,    -1,   391,   267,   268,    -1,
     270,   271,    -1,   273,   274,   275,    -1,    -1,    69,    70,
      71,   285,    73,    74,    -1,    76,   105,    -1,    -1,    80,
     391,    -1,    83,    -1,    -1,    -1,    87,    88,    -1,    -1,
      91,    92,    -1,    -1,    -1,   309,    97,   311,   127,    -1,
      -1,    -1,    -1,   317,    -1,   319,     3,    -1,    -1,   323,
     324,   140,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    -1,    -1,   154,    -1,   128,    -1,   312,
      -1,    -1,   133,   167,   168,   169,   170,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,   267,    44,    -1,    -1,
      -1,    -1,    -1,    -1,   336,   337,    -1,    -1,    19,   342,
     343,    -1,    -1,   346,   347,    -1,   349,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   357,   358,    -1,   391,    -1,    -1,
      -1,   391,   211,    80,    -1,   214,   215,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   391,   391,
       8,     9,    10,    11,    12,    -1,   113,   114,   115,   116,
      -1,   118,   119,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   271,    -1,    -1,   274,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,    -1,   287,    -1,
     289,   290,   291,   292,   293,   294,    -1,    -1,    67,    68,
     391,   300,    -1,    -1,    -1,   304,   305,    -1,    77,   308,
      -1,    -1,    -1,    -1,    -1,   167,   168,   169,   170,   171,
     172,   173,   321,   175,   176,   177,   178,   179,    -1,    -1,
     329,    -1,    -1,   102,    -1,    -1,   167,   168,   169,   170,
     171,   172,   173,   210,   175,   176,   177,   178,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,    -1,   133,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,   142,    -1,   144,    -1,    -1,    -1,    -1,
     149,   150,   151,    -1,   388,    -1,    -1,   156,   157,   158,
      -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,     8,     9,    10,
      11,    12,    -1,   181,    -1,    -1,    -1,    -1,    -1,    -1,
     391,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,     8,     9,    10,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   397,   398,    45,    67,    68,    77,   102,   130,
     133,   135,   142,   144,   149,   150,   151,   156,   157,   158,
     422,   423,   424,   425,   426,   427,   478,   479,   480,   481,
     483,   484,   485,   488,   491,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   584,   620,   621,   622,
     623,   624,   625,   626,   627,   681,   683,     0,     3,    33,
      42,    45,    56,    76,    80,    83,    85,    86,    93,   121,
     122,   133,   156,   159,   386,   399,   412,   418,   421,   430,
     432,   435,   437,   440,   442,   443,   445,   446,   453,   463,
     464,   519,   521,   531,   570,   573,   585,   586,   587,   588,
     629,   630,   631,   636,   666,   667,   675,   676,   682,   684,
     685,   686,    19,    20,    44,   517,    20,    55,    63,    64,
      65,   428,     3,   517,   517,   131,   132,   517,   517,     3,
     121,   111,   112,   121,   136,   145,   147,   148,   211,   278,
     381,   121,   121,    75,   111,   112,   152,   153,   154,   155,
      13,    15,    16,    17,    18,    19,    20,    26,    27,    29,
      31,    87,    93,   149,   150,   184,   185,   201,   204,   208,
     387,   394,   536,   549,   554,   557,   558,   559,   561,   563,
      35,    44,   390,   506,   517,    19,    19,    20,    43,    54,
     410,   414,   111,   117,    42,    61,    85,   147,   419,   420,
      77,    19,    84,    19,    80,   123,   111,   410,   563,    19,
      19,   447,   447,   390,    69,    74,    89,   123,   211,   278,
     335,   340,   366,   381,   447,    45,    80,    83,    87,    88,
      90,    91,    92,    97,   128,   133,   391,   448,   466,   447,
     447,    50,    76,    89,   102,   105,   107,   147,   149,   158,
     194,   211,   218,   219,   221,   223,   224,   226,   227,   229,
     232,   233,   235,   248,   249,   253,   255,   256,   258,   263,
     267,   268,   270,   271,   273,   274,   275,   391,   448,   447,
     279,   284,   285,   286,   321,   332,   391,   448,   589,   590,
     591,   447,   336,   337,   391,   448,   447,   447,    41,    66,
      90,   105,   127,   304,   367,   368,   369,   376,   391,   448,
     473,   475,   476,   447,    65,   147,   267,   391,   448,   677,
     680,    69,    70,    71,    73,    74,    76,   391,   431,   434,
     448,    71,   113,   391,   433,   448,    35,    44,   390,   467,
     428,     3,     3,   428,    66,   429,     3,     3,   517,   517,
       3,    35,    44,   390,   470,    80,   493,    19,    20,    44,
     518,     3,   146,   489,     3,     3,   486,   492,   222,    19,
      90,   154,   320,   333,   334,   482,   482,    18,    19,   403,
     406,   406,     3,     3,     3,     3,     3,     3,     3,    15,
      19,    28,   387,   393,   553,   555,   561,    29,   387,   209,
      27,   209,    15,   393,   556,   563,   387,   387,   387,   387,
     387,   387,   186,   187,   188,   189,   543,   563,    15,    16,
      17,    19,   387,   536,   537,   541,   544,   545,   547,   549,
     550,   551,     5,    78,    79,    81,    82,   106,   137,   190,
     191,   193,   194,   195,   196,   197,   198,   199,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   265,   266,   280,
     281,   282,   283,   379,   380,   562,   687,     3,     8,     9,
      10,    11,    12,    22,    23,    24,    25,    26,    27,    28,
      29,    32,    45,    46,    47,    48,    49,    50,    51,    52,
      53,   416,   417,    15,   507,     3,    22,    62,   413,    44,
     390,   415,   467,    15,    19,   387,   400,    20,    57,    58,
     386,   140,   129,   441,    15,    17,    18,   106,   436,   520,
      19,   438,   470,   386,   532,   106,   390,   390,   444,   390,
     467,    19,   452,    84,   400,    34,    35,    36,    37,   400,
     402,   465,    44,    93,    94,    98,   103,   210,   449,   528,
      98,   449,    98,   410,   470,   386,   386,   390,   390,   140,
     237,    77,   386,   238,   410,   402,    98,   276,   147,   252,
     126,   402,   386,   400,   403,   143,   403,    72,   225,    72,
     223,   230,   240,   241,   234,   236,   250,   251,   250,   254,
     402,   257,   259,   264,    80,   234,    89,   269,   234,   272,
     270,   402,   221,   386,   390,   436,   402,    83,   400,   402,
     319,   386,   390,   390,    80,   338,   339,   386,   390,   390,
     400,    72,   673,   674,   410,   390,    94,   374,   375,   668,
     400,   400,    72,   219,   377,   378,   386,   386,   390,   390,
     312,   406,    80,   386,   165,   228,   260,   269,   382,   383,
     384,   385,   386,    80,   402,    72,   402,    75,    77,   386,
     386,   386,    72,    20,   411,   386,   386,    75,    95,    96,
     109,   110,   112,   468,   469,     3,   429,     3,   400,     3,
       3,     3,    95,   134,   471,   472,     3,    19,     3,   518,
       3,     3,     3,    80,   116,   131,   143,   490,     3,    44,
      80,    85,    92,    93,   104,   113,   114,   115,   116,   118,
     119,   406,   487,   528,     3,    19,    80,    85,    86,    93,
     121,   159,   482,   482,   482,   628,    44,   482,    44,   482,
       3,     3,    29,   389,   408,   141,   141,   555,   555,   563,
     555,   555,    14,    15,   563,   567,   568,    26,   209,    27,
     556,   556,    29,   563,   563,   563,   563,   563,    19,    15,
     392,   388,   392,    28,   539,   540,   543,   563,     7,   392,
     395,    26,    27,   390,   392,   395,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   169,
     192,   200,   205,   206,   391,   392,     3,   563,   410,   416,
     386,   563,   400,    59,    60,    59,    60,   400,   460,   461,
     386,   167,   168,   169,   170,   171,   172,   173,   175,   176,
     177,   178,   179,   522,   523,   524,   526,   530,    41,   124,
     125,   126,   386,   439,   386,   387,   529,    19,   121,   391,
     436,   454,   457,   458,    19,   526,   527,    35,   400,   451,
     104,   563,   451,   451,   572,    72,    72,    72,   277,   402,
      50,   386,   386,   400,   214,   215,   402,   262,   402,   403,
     386,   386,    30,   404,   400,   143,   400,    72,   400,    72,
     103,   231,   400,   400,   402,    72,   386,    84,   386,   402,
     386,   402,   231,   260,   261,   402,   452,   402,   386,   386,
     402,   402,   402,   386,   143,   402,    98,   402,   592,    19,
     386,   386,   635,   386,   400,   458,   386,   474,   475,   386,
     386,   386,   400,   386,   386,   386,    84,   120,   164,   477,
     402,   452,    20,   403,   403,   228,   678,   679,   400,   400,
     402,   402,   400,   403,   406,   407,   391,   392,     3,   391,
     392,     3,    19,    15,   406,    19,    19,   527,   407,    19,
       3,    20,   619,   619,     3,    19,    83,   231,   279,   294,
     312,   326,   327,   482,   619,   482,   619,   400,   403,    15,
      15,   388,   392,   388,    27,   392,   392,   392,   388,   392,
     388,   392,   563,   563,     7,   392,   392,   388,    18,   387,
     537,   545,    15,    18,   550,   387,   417,   386,   391,   388,
      20,   386,   458,   386,    19,   174,   386,   390,   400,   403,
     388,   523,   525,   530,   406,    27,   456,   392,    99,   450,
     402,    90,   218,   219,   391,   448,   571,   400,   400,   400,
     386,   386,   402,   386,   386,   386,   386,   402,   386,   386,
      19,    41,   405,   386,   400,   386,   400,   386,   400,   386,
     386,   386,   386,   386,   400,   436,   386,   386,   386,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   400,   400,
      90,   146,   232,   285,   309,   311,   317,   319,   323,   324,
     391,   593,   600,   603,   386,    90,   170,   357,   358,   361,
     391,   448,   632,   386,   390,   672,   391,   386,   386,   400,
     106,   108,   106,   108,   391,   386,   386,   404,   403,   322,
     678,   469,   472,     3,     3,   436,   436,    15,   436,   619,
       3,   619,     3,   143,   143,   567,    27,   563,   563,   563,
     563,   563,   392,   388,   539,   563,   540,   542,   563,   563,
     392,   563,   524,    19,    50,    87,   160,   161,   162,   163,
     164,   165,   166,   180,   183,   533,   534,   559,   560,   564,
     569,   386,   388,   141,    20,   407,   455,   457,    77,   100,
     101,   102,   574,   578,   574,   579,   403,   583,   386,   392,
     386,   386,   386,   386,   400,   143,   386,   386,   386,   386,
     386,   386,   612,   618,   402,   287,   288,   323,   287,   402,
     594,   312,   406,   596,   597,   595,   325,   402,   386,   328,
     613,   637,   645,   406,   646,   651,   633,   634,   406,   386,
     671,   474,   386,    20,   409,   409,   409,   409,   404,   400,
       3,     3,    15,    15,   388,   388,   388,   388,   392,   563,
     388,   392,    15,   388,    22,   387,    22,   387,   563,   563,
     563,   391,   569,   562,   687,   386,   563,   565,   566,   525,
      15,   407,   458,   459,   390,   577,    30,   220,   580,   400,
     400,   458,   614,   400,   400,   402,   400,   390,   436,   390,
     390,   400,   400,   390,   459,   390,   650,   390,   403,   652,
     657,    20,   390,   658,   663,   215,   234,   271,   337,   391,
     670,   477,   386,   386,   386,   386,   493,   493,   563,   388,
       7,    28,   542,   391,   563,   568,   563,   559,   386,   181,
     390,    22,    22,    32,   392,   386,   143,   577,   576,    19,
     410,   221,   581,   386,   386,   615,   390,   617,   605,   598,
     605,   601,   390,   644,   649,   648,   653,   659,   138,   139,
     292,   462,   400,   272,   295,   370,   371,   372,   373,   669,
     386,   477,   477,   477,   477,     3,     3,   388,   387,   388,
       7,   388,   386,   388,   386,   687,   390,   535,   569,   552,
     563,   563,    93,   149,   150,   204,   209,   566,    15,   107,
     212,   213,   216,   217,   391,   575,   403,   218,   582,   613,
     616,   391,   406,   606,   607,   146,   287,   310,   391,   599,
     391,   140,   289,   290,   291,   293,   304,   391,   473,   602,
     643,   642,   350,   351,   354,   355,   356,   391,   647,   656,
     662,   400,   400,   400,   215,   402,   539,   542,   388,   533,
     182,     6,    15,    16,    17,   387,   391,   536,   538,   541,
     544,   546,   548,   386,   386,   387,   387,   387,   387,   386,
     386,   402,   214,   215,   215,   400,   401,   400,   386,   402,
      65,   140,   154,   211,   214,   215,   271,   274,   285,   287,
     289,   290,   291,   292,   293,   294,   300,   304,   305,   308,
     321,   329,   391,   473,   604,   310,   318,   608,   402,   400,
     402,   386,   400,   400,   400,   236,   115,   400,    94,   303,
     306,   386,   141,   170,   212,   232,   312,   342,   343,   346,
     347,   349,   357,   358,   391,   638,   353,   353,   402,   402,
     402,   386,   353,   359,   391,   654,   353,   360,   391,   660,
     313,   392,   388,   386,   391,   535,   533,   563,     7,   389,
     392,   563,   563,   563,   563,   216,   216,   216,    38,    39,
      40,   312,   400,   390,   402,   314,   292,   331,   462,   272,
     402,   402,   400,   400,   400,   236,   400,   115,   400,   295,
     296,   297,   298,   299,   300,   301,   302,   330,    94,   303,
     306,   297,   400,   322,   295,   386,   400,   386,   400,   400,
     341,   651,   236,   341,    87,   353,   345,   402,   344,    72,
     348,   230,   221,   639,   221,   640,   386,   400,   400,   352,
     400,   664,   652,   655,   386,   664,   658,   661,   386,   539,
     388,   387,   538,   533,   546,   388,   388,   388,   388,   401,
     401,   401,   402,   609,   315,   316,   400,   400,   400,   215,
     402,   400,   400,   402,   402,   400,   402,   216,   400,   216,
     363,   364,   365,   641,   400,   400,   402,   400,   400,    98,
     402,   657,   402,   663,   362,   665,   665,   400,   388,   563,
     386,   386,   386,   386,    18,   391,   611,   313,   400,   400,
     665,   400,   402,   307,   610,   386
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 739 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 740 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 753 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 763 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 764 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 771 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 772 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 773 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 781 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 782 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 783 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 784 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 785 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 786 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 793 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 800 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 801 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 805 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 806 "cf-parse.y"
    {
     if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 65535)) cf_error("Invalid port number");
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 813 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 821 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 825 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 829 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 836 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 845 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[(1) - (1)].s)).s;
   }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 852 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 853 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 859 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 868 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 869 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 873 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 878 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 879 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 883 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 884 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 888 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 889 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 893 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 894 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 895 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 896 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 897 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 898 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 899 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 900 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 901 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 907 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 908 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 917 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 918 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 919 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 920 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 923 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 924 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 925 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 926 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 927 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 928 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 940 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 943 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 950 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 953 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 956 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 959 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 962 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 967 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 968 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 969 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 977 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 982 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 983 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 987 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 994 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 995 "cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 1001 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 1006 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 1010 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 1024 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1038 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 1039 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 1043 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1045 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1064 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1065 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1066 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1067 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1072 "cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1078 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1079 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 1083 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 1091 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1097 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1111 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1112 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1116 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1122 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1126 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1138 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1142 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1143 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1144 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1145 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1146 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1147 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1148 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1149 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1150 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1151 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1152 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1153 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1157 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1159 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1160 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1164 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1165 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1166 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1167 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1168 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1172 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1178 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1182 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1190 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1191 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1199 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1207 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1208 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1209 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1213 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1214 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1228 "cf-parse.y"
    { iface_patt_check(); }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1230 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1242 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1243 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1249 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1262 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1276 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1277 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1278 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1283 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1287 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1288 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 1289 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1290 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1291 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 1292 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1298 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1299 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1300 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1305 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1309 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1310 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1331 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1349 "cf-parse.y"
    { }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1350 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1351 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1352 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1353 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1354 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 1363 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1366 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 1369 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 1372 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1376 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1380 "cf-parse.y"
    { if_show(); }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1383 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1387 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1390 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1395 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1401 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1408 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1413 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1418 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1423 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1427 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1431 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1435 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1444 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1452 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1456 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1463 "cf-parse.y"
    { (yyval.i) = RSEM_PREEXPORT; }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1464 "cf-parse.y"
    { (yyval.i) = RSEM_EXPORT; }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1465 "cf-parse.y"
    { (yyval.i) = RSEM_NOEXPORT; }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1471 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1474 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1481 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1488 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1492 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1500 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1501 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1502 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1508 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1511 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1514 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1515 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1516 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1517 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1518 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1519 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1520 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1525 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1530 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1539 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1546 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1553 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1561 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1563 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1565 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1567 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1569 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1571 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1573 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1576 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1579 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1585 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1586 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1587 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1591 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1592 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1599 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1601 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1603 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1605 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1607 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1609 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1613 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1617 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1620 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1623 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1624 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1625 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1629 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1630 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1631 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1639 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1640 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1649 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1653 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1654 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1655 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1656 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1657 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1658 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1659 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1660 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1661 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1662 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1663 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1664 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1665 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1686 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1697 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1698 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1705 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1706 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1713 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1722 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1730 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1754 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1755 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1759 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1772 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1775 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1788 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1789 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1792 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1793 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 1797 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 1800 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 1809 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1822 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1823 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 1824 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1825 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1826 "cf-parse.y"
    {
     (yyval.v) = f_eval((yyvsp[(2) - (3)].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1830 "cf-parse.y"
    {
     if (!cf_symbol_is_constant((yyvsp[(1) - (1)].s))) cf_error("%s: constant expected", (yyvsp[(1) - (1)].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[(1) - (1)].s)))) cf_error("%s: set-incompatible type", (yyvsp[(1) - (1)].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[(1) - (1)].s)->def);
   }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1838 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1839 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1840 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1841 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 1842 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 1846 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1849 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1850 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 1851 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 1855 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1858 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1867 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 1870 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 1871 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 1872 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1873 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1877 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 1878 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1879 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1885 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 1886 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1892 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 1893 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 1898 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 1903 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 1907 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 1914 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 1915 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 1916 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 1917 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 1924 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 1925 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 1928 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 1929 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 1936 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 1948 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 1949 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 1953 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 1954 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 1958 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 1959 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 1960 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 1961 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 1962 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 1966 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 1967 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 1968 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 1972 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 1973 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 1974 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 1975 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 1976 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 1977 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 1978 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 1979 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 1980 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 1981 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 1982 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 1986 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 1987 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 2001 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2024 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2038 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2039 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2040 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 2041 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2042 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2045 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2046 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2047 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2051 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2052 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2053 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2054 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2055 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2056 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 2057 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2058 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2059 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2060 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2061 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2062 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2063 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 2064 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2065 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2066 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2068 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2069 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2070 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2072 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2074 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2076 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2078 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2079 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2080 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2081 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2082 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2092 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2093 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2094 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2095 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2096 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2097 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2098 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2100 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2101 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2106 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2129 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2130 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2131 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2132 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2133 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2134 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2138 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2141 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2142 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2143 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2151 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2158 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2167 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2168 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2172 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 2178 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2188 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2197 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2203 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2208 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2215 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2220 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2226 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2227 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2228 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2236 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2237 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2238 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2239 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2240 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2247 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, sizeof(struct bfd_config), (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 2274 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2285 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2286 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2287 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2288 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2289 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2290 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2304 "cf-parse.y"
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2307 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2311 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2312 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2313 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2317 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2318 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2322 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2323 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2327 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 2346 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 2351 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
 }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2377 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2378 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2379 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (8)].a)) != !(yyvsp[(4) - (8)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (8)].a);
     BGP_CFG->iface = (yyvsp[(4) - (8)].iface);
     BGP_CFG->remote_port = ((yyvsp[(5) - (8)].i) > 0) ? (yyvsp[(5) - (8)].i) : BGP_PORT;
     BGP_CFG->remote_as = (yyvsp[(7) - (8)].i);
   }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2390 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 2391 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2392 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2393 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 2394 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 2395 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2396 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2397 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2398 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2399 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2400 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2401 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2402 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 2403 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 2404 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 2405 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 2406 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 2407 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 2408 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 2409 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 2410 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 2411 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 2412 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 2413 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2414 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 2415 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 2416 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2417 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2418 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2419 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2420 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2421 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 2422 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 2423 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 528:
/* Line 1792 of yacc.c  */
#line 2424 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 2429 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 530:
/* Line 1792 of yacc.c  */
#line 2430 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 2431 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 2432 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_RX; }
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 2433 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_TX; }
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 2434 "cf-parse.y"
    { BGP_CFG->add_path = (yyvsp[(4) - (5)].i) ? ADD_PATH_FULL : 0; }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2435 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2436 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2437 "cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); }
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 2438 "cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 2439 "cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2440 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2441 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2442 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2453 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2469 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2470 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2471 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 2472 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 551:
/* Line 1792 of yacc.c  */
#line 2473 "cf-parse.y"
    { OSPF_CFG->merge_external = (yyvsp[(3) - (3)].i); }
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 2474 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 2478 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2493 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2502 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2503 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 2504 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2505 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 2506 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 563:
/* Line 1792 of yacc.c  */
#line 2507 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2508 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2509 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 566:
/* Line 1792 of yacc.c  */
#line 2510 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 2511 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 2512 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 2524 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 2538 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2539 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2540 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 2544 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 2545 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2554 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 2555 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2556 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 2557 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 2558 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 2559 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 2560 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2561 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 2562 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2567 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2588 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2589 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2590 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2591 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2592 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2593 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2594 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2595 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2596 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2597 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2598 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2599 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2600 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2601 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2602 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2603 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2604 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 2605 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 2606 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 2607 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2608 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2609 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2610 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 2612 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2613 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2614 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2615 "cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2616 "cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2617 "cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2618 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 629:
/* Line 1792 of yacc.c  */
#line 2619 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 630:
/* Line 1792 of yacc.c  */
#line 2620 "cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 2621 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 632:
/* Line 1792 of yacc.c  */
#line 2622 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 2623 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 2624 "cf-parse.y"
    { OSPF_PATT->bsd_secondary = (yyvsp[(2) - (2)].i); }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2636 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 2646 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 2647 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2656 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2657 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 2661 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 2670 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 2695 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 2699 "cf-parse.y"
    { if (OSPF_VERSION == 3) iface_patt_check(); }
    break;

  case 657:
/* Line 1792 of yacc.c  */
#line 2713 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 2718 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 660:
/* Line 1792 of yacc.c  */
#line 2724 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 2727 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 2730 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 2735 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 2738 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 2743 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2746 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2750 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2753 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2756 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 2757 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 671:
/* Line 1792 of yacc.c  */
#line 2758 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 672:
/* Line 1792 of yacc.c  */
#line 2759 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 2760 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 2761 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 2762 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 676:
/* Line 1792 of yacc.c  */
#line 2763 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 677:
/* Line 1792 of yacc.c  */
#line 2769 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 2778 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 681:
/* Line 1792 of yacc.c  */
#line 2783 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 2784 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2791 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config), (yyvsp[(1) - (2)].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 2802 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 2803 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 2803 "cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 2804 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 2804 "cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2805 "cf-parse.y"
    {
     RADV_CFG->trigger_prefix = (yyvsp[(2) - (2)].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[(2) - (2)].px).len;
     RADV_CFG->trigger_valid = 1;
   }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 2822 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
}
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 2840 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 2841 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2842 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2843 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2844 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); }
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 2845 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); }
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 2846 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 2847 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2848 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
    break;

  case 705:
/* Line 1792 of yacc.c  */
#line 2849 "cf-parse.y"
    {
     RADV_IFACE->default_lifetime = (yyvsp[(3) - (4)].i);
     if (((yyvsp[(3) - (4)].i) < 0) || ((yyvsp[(3) - (4)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 2854 "cf-parse.y"
    { RADV_IFACE->default_preference = (yyvsp[(3) - (3)].i); }
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 2855 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
    break;

  case 708:
/* Line 1792 of yacc.c  */
#line 2856 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 709:
/* Line 1792 of yacc.c  */
#line 2856 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 2857 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2857 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 2858 "cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); }
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 2859 "cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); }
    break;

  case 714:
/* Line 1792 of yacc.c  */
#line 2863 "cf-parse.y"
    { (yyval.i) = RA_PREF_LOW; }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 2864 "cf-parse.y"
    { (yyval.i) = RA_PREF_MEDIUM; }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 2865 "cf-parse.y"
    { (yyval.i) = RA_PREF_HIGH; }
    break;

  case 717:
/* Line 1792 of yacc.c  */
#line 2868 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
    break;

  case 723:
/* Line 1792 of yacc.c  */
#line 2901 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
    break;

  case 724:
/* Line 1792 of yacc.c  */
#line 2913 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); }
    break;

  case 725:
/* Line 1792 of yacc.c  */
#line 2914 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); }
    break;

  case 726:
/* Line 1792 of yacc.c  */
#line 2915 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); }
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 2916 "cf-parse.y"
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 728:
/* Line 1792 of yacc.c  */
#line 2921 "cf-parse.y"
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 2929 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 2953 "cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 2962 "cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 2969 "cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
    break;

  case 740:
/* Line 1792 of yacc.c  */
#line 2973 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 2997 "cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
    break;

  case 746:
/* Line 1792 of yacc.c  */
#line 3009 "cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 749:
/* Line 1792 of yacc.c  */
#line 3016 "cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
    break;

  case 750:
/* Line 1792 of yacc.c  */
#line 3020 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 3044 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; }
    break;

  case 756:
/* Line 1792 of yacc.c  */
#line 3045 "cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
    break;

  case 757:
/* Line 1792 of yacc.c  */
#line 3049 "cf-parse.y"
    { (yyval.i) = -1; }
    break;

  case 758:
/* Line 1792 of yacc.c  */
#line 3050 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 759:
/* Line 1792 of yacc.c  */
#line 3056 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 3065 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 763:
/* Line 1792 of yacc.c  */
#line 3066 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 3067 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 3068 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 766:
/* Line 1792 of yacc.c  */
#line 3069 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 767:
/* Line 1792 of yacc.c  */
#line 3070 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 3072 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 3073 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 3074 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 773:
/* Line 1792 of yacc.c  */
#line 3079 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 774:
/* Line 1792 of yacc.c  */
#line 3080 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 3081 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 776:
/* Line 1792 of yacc.c  */
#line 3086 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 777:
/* Line 1792 of yacc.c  */
#line 3087 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 778:
/* Line 1792 of yacc.c  */
#line 3088 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 779:
/* Line 1792 of yacc.c  */
#line 3089 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 780:
/* Line 1792 of yacc.c  */
#line 3090 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 782:
/* Line 1792 of yacc.c  */
#line 3094 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 783:
/* Line 1792 of yacc.c  */
#line 3095 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 784:
/* Line 1792 of yacc.c  */
#line 3096 "cf-parse.y"
    { RIP_IPATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 785:
/* Line 1792 of yacc.c  */
#line 3097 "cf-parse.y"
    { RIP_IPATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 786:
/* Line 1792 of yacc.c  */
#line 3098 "cf-parse.y"
    { RIP_IPATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 787:
/* Line 1792 of yacc.c  */
#line 3099 "cf-parse.y"
    { RIP_IPATT->ttl_security = 2; }
    break;

  case 792:
/* Line 1792 of yacc.c  */
#line 3113 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
    break;

  case 794:
/* Line 1792 of yacc.c  */
#line 3132 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 797:
/* Line 1792 of yacc.c  */
#line 3141 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 798:
/* Line 1792 of yacc.c  */
#line 3142 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 800:
/* Line 1792 of yacc.c  */
#line 3146 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 801:
/* Line 1792 of yacc.c  */
#line 3155 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 802:
/* Line 1792 of yacc.c  */
#line 3163 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 803:
/* Line 1792 of yacc.c  */
#line 3170 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 804:
/* Line 1792 of yacc.c  */
#line 3171 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 805:
/* Line 1792 of yacc.c  */
#line 3175 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 806:
/* Line 1792 of yacc.c  */
#line 3180 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 807:
/* Line 1792 of yacc.c  */
#line 3186 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 808:
/* Line 1792 of yacc.c  */
#line 3189 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 809:
/* Line 1792 of yacc.c  */
#line 3194 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 810:
/* Line 1792 of yacc.c  */
#line 3195 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 811:
/* Line 1792 of yacc.c  */
#line 3196 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 812:
/* Line 1792 of yacc.c  */
#line 3197 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 813:
/* Line 1792 of yacc.c  */
#line 3198 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 814:
/* Line 1792 of yacc.c  */
#line 3202 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 880:
/* Line 1792 of yacc.c  */
#line 3210 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 881:
/* Line 1792 of yacc.c  */
#line 3210 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 884:
/* Line 1792 of yacc.c  */
#line 3210 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 893:
/* Line 1792 of yacc.c  */
#line 3213 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 894:
/* Line 1792 of yacc.c  */
#line 3213 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 895:
/* Line 1792 of yacc.c  */
#line 3213 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 896:
/* Line 1792 of yacc.c  */
#line 3213 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 897:
/* Line 1792 of yacc.c  */
#line 3214 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 898:
/* Line 1792 of yacc.c  */
#line 3214 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 899:
/* Line 1792 of yacc.c  */
#line 3215 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 900:
/* Line 1792 of yacc.c  */
#line 3216 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 901:
/* Line 1792 of yacc.c  */
#line 3217 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 902:
/* Line 1792 of yacc.c  */
#line 3218 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 903:
/* Line 1792 of yacc.c  */
#line 3219 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 904:
/* Line 1792 of yacc.c  */
#line 3220 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 905:
/* Line 1792 of yacc.c  */
#line 3221 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 906:
/* Line 1792 of yacc.c  */
#line 3222 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 907:
/* Line 1792 of yacc.c  */
#line 3223 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 908:
/* Line 1792 of yacc.c  */
#line 3224 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 909:
/* Line 1792 of yacc.c  */
#line 3225 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 910:
/* Line 1792 of yacc.c  */
#line 3225 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 911:
/* Line 1792 of yacc.c  */
#line 3225 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 912:
/* Line 1792 of yacc.c  */
#line 3225 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 913:
/* Line 1792 of yacc.c  */
#line 3225 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 914:
/* Line 1792 of yacc.c  */
#line 3225 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 915:
/* Line 1792 of yacc.c  */
#line 3225 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1792 of yacc.c  */
#line 9280 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3227 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

