/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


/* Line 371 of yacc.c  */
#line 597 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     S = 282,
     MS = 283,
     US = 284,
     PORT = 285,
     LOG = 286,
     SYSLOG = 287,
     ALL = 288,
     DEBUG = 289,
     TRACE = 290,
     INFO = 291,
     REMOTE = 292,
     WARNING = 293,
     ERROR = 294,
     AUTH = 295,
     FATAL = 296,
     BUG = 297,
     STDERR = 298,
     SOFT = 299,
     TIMEFORMAT = 300,
     ISO = 301,
     OLD = 302,
     SHORT = 303,
     LONG = 304,
     BASE = 305,
     NAME = 306,
     CONFIRM = 307,
     UNDO = 308,
     CHECK = 309,
     TIMEOUT = 310,
     CONFIGURE = 311,
     DOWN = 312,
     KERNEL = 313,
     PERSIST = 314,
     SCAN = 315,
     TIME = 316,
     LEARN = 317,
     DEVICE = 318,
     ROUTES = 319,
     GRACEFUL = 320,
     RESTART = 321,
     KRT_SOURCE = 322,
     KRT_METRIC = 323,
     TABLE = 324,
     KRT_PREFSRC = 325,
     KRT_REALM = 326,
     ROUTER = 327,
     ID = 328,
     PROTOCOL = 329,
     TEMPLATE = 330,
     PREFERENCE = 331,
     DISABLED = 332,
     DIRECT = 333,
     INTERFACE = 334,
     IMPORT = 335,
     EXPORT = 336,
     FILTER = 337,
     NONE = 338,
     STATES = 339,
     FILTERS = 340,
     RECEIVE = 341,
     LIMIT = 342,
     ACTION = 343,
     WARN = 344,
     BLOCK = 345,
     DISABLE = 346,
     KEEP = 347,
     FILTERED = 348,
     PASSWORD = 349,
     FROM = 350,
     PASSIVE = 351,
     TO = 352,
     EVENTS = 353,
     PACKETS = 354,
     PROTOCOLS = 355,
     INTERFACES = 356,
     PRIMARY = 357,
     STATS = 358,
     COUNT = 359,
     FOR = 360,
     COMMANDS = 361,
     PREEXPORT = 362,
     NOEXPORT = 363,
     GENERATE = 364,
     ROA = 365,
     LISTEN = 366,
     BGP = 367,
     V6ONLY = 368,
     DUAL = 369,
     ADDRESS = 370,
     PASSWORDS = 371,
     DESCRIPTION = 372,
     SORTED = 373,
     RELOAD = 374,
     IN = 375,
     OUT = 376,
     MRTDUMP = 377,
     MESSAGES = 378,
     RESTRICT = 379,
     MEMORY = 380,
     IGP_METRIC = 381,
     CLASS = 382,
     DSCP = 383,
     WAIT = 384,
     MAX = 385,
     FLUSH = 386,
     AS = 387,
     SHOW = 388,
     STATUS = 389,
     SUMMARY = 390,
     ROUTE = 391,
     SYMBOLS = 392,
     ADD = 393,
     DELETE = 394,
     DUMP = 395,
     RESOURCES = 396,
     SOCKETS = 397,
     NEIGHBORS = 398,
     ATTRIBUTES = 399,
     EVAL = 400,
     ECHO = 401,
     ENABLE = 402,
     FUNCTION = 403,
     PRINT = 404,
     PRINTN = 405,
     UNSET = 406,
     RETURN = 407,
     ACCEPT = 408,
     REJECT = 409,
     QUITBIRD = 410,
     INT = 411,
     BOOL = 412,
     IP = 413,
     PREFIX = 414,
     PAIR = 415,
     QUAD = 416,
     EC = 417,
     SET = 418,
     STRING = 419,
     BGPMASK = 420,
     BGPPATH = 421,
     CLIST = 422,
     ECLIST = 423,
     IF = 424,
     THEN = 425,
     ELSE = 426,
     CASE = 427,
     TRUE = 428,
     FALSE = 429,
     RT = 430,
     RO = 431,
     UNKNOWN = 432,
     GENERIC = 433,
     GW = 434,
     NET = 435,
     MASK = 436,
     PROTO = 437,
     SOURCE = 438,
     SCOPE = 439,
     CAST = 440,
     DEST = 441,
     IFNAME = 442,
     IFINDEX = 443,
     LEN = 444,
     DEFINED = 445,
     CONTAINS = 446,
     RESET = 447,
     PREPEND = 448,
     FIRST = 449,
     LAST = 450,
     MATCH = 451,
     ROA_CHECK = 452,
     EMPTY = 453,
     WHERE = 454,
     BFD = 455,
     MIN = 456,
     IDLE = 457,
     RX = 458,
     TX = 459,
     INTERVAL = 460,
     MULTIPLIER = 461,
     MULTIHOP = 462,
     NEIGHBOR = 463,
     DEV = 464,
     LOCAL = 465,
     SESSIONS = 466,
     HOLD = 467,
     CONNECT = 468,
     RETRY = 469,
     KEEPALIVE = 470,
     STARTUP = 471,
     VIA = 472,
     NEXT = 473,
     HOP = 474,
     SELF = 475,
     DEFAULT = 476,
     PATH = 477,
     METRIC = 478,
     START = 479,
     DELAY = 480,
     FORGET = 481,
     AFTER = 482,
     BGP_PATH = 483,
     BGP_LOCAL_PREF = 484,
     BGP_MED = 485,
     BGP_ORIGIN = 486,
     BGP_NEXT_HOP = 487,
     BGP_ATOMIC_AGGR = 488,
     BGP_AGGREGATOR = 489,
     BGP_COMMUNITY = 490,
     BGP_EXT_COMMUNITY = 491,
     RR = 492,
     RS = 493,
     CLIENT = 494,
     CLUSTER = 495,
     AS4 = 496,
     ADVERTISE = 497,
     IPV4 = 498,
     CAPABILITIES = 499,
     PREFER = 500,
     OLDER = 501,
     MISSING = 502,
     LLADDR = 503,
     DROP = 504,
     IGNORE = 505,
     REFRESH = 506,
     INTERPRET = 507,
     COMMUNITIES = 508,
     BGP_ORIGINATOR_ID = 509,
     BGP_CLUSTER_LIST = 510,
     IGP = 511,
     GATEWAY = 512,
     RECURSIVE = 513,
     MED = 514,
     TTL = 515,
     SECURITY = 516,
     DETERMINISTIC = 517,
     SECONDARY = 518,
     ALLOW = 519,
     PATHS = 520,
     AWARE = 521,
     OSPF = 522,
     AREA = 523,
     OSPF_METRIC1 = 524,
     OSPF_METRIC2 = 525,
     OSPF_TAG = 526,
     OSPF_ROUTER_ID = 527,
     RFC1583COMPAT = 528,
     STUB = 529,
     TICK = 530,
     COST = 531,
     COST2 = 532,
     RETRANSMIT = 533,
     HELLO = 534,
     TRANSMIT = 535,
     PRIORITY = 536,
     DEAD = 537,
     TYPE = 538,
     BROADCAST = 539,
     BCAST = 540,
     NONBROADCAST = 541,
     NBMA = 542,
     POINTOPOINT = 543,
     PTP = 544,
     POINTOMULTIPOINT = 545,
     PTMP = 546,
     SIMPLE = 547,
     AUTHENTICATION = 548,
     STRICT = 549,
     CRYPTOGRAPHIC = 550,
     ELIGIBLE = 551,
     POLL = 552,
     NETWORKS = 553,
     HIDDEN = 554,
     VIRTUAL = 555,
     LINK = 556,
     ONLY = 557,
     BUFFER = 558,
     LARGE = 559,
     NORMAL = 560,
     STUBNET = 561,
     TAG = 562,
     EXTERNAL = 563,
     LSADB = 564,
     ECMP = 565,
     WEIGHT = 566,
     NSSA = 567,
     TRANSLATOR = 568,
     STABILITY = 569,
     GLOBAL = 570,
     LSID = 571,
     INSTANCE = 572,
     REAL = 573,
     NETMASK = 574,
     LENGTH = 575,
     MERGE = 576,
     TOPOLOGY = 577,
     STATE = 578,
     PIPE = 579,
     PEER = 580,
     MODE = 581,
     OPAQUE = 582,
     TRANSPARENT = 583,
     RIP = 584,
     INFINITY = 585,
     PERIOD = 586,
     GARBAGE = 587,
     MULTICAST = 588,
     QUIET = 589,
     NOLISTEN = 590,
     VERSION1 = 591,
     PLAINTEXT = 592,
     MD5 = 593,
     HONOR = 594,
     NEVER = 595,
     ALWAYS = 596,
     RIP_METRIC = 597,
     RIP_TAG = 598,
     STATIC = 599,
     PROHIBIT = 600,
     MULTIPATH = 601,
     BLACKHOLE = 602,
     UNREACHABLE = 603
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 525 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 1016 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1044 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2744

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  370
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  257
/* YYNRULES -- Number of rules.  */
#define YYNRULES  838
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1582

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   603

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     361,   362,    28,    26,   366,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   363,   360,
      23,    22,    24,   367,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   368,     2,   369,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   364,     2,   365,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    56,    59,    62,    64,    66,    69,
      72,    74,    76,    78,    80,    81,    86,    89,    90,    92,
      95,    97,    99,   103,   105,   109,   111,   113,   115,   117,
     119,   121,   123,   125,   127,   132,   136,   138,   140,   142,
     144,   147,   152,   156,   160,   164,   168,   172,   177,   183,
     187,   191,   196,   199,   200,   202,   203,   205,   208,   211,
     214,   218,   221,   225,   229,   232,   236,   240,   244,   249,
     255,   257,   259,   261,   266,   267,   270,   273,   276,   278,
     280,   286,   287,   289,   293,   297,   298,   307,   309,   314,
     316,   318,   319,   321,   325,   326,   329,   332,   335,   338,
     341,   344,   348,   352,   356,   361,   364,   368,   371,   374,
     376,   378,   380,   381,   384,   387,   390,   393,   396,   398,
     400,   404,   408,   409,   411,   413,   416,   417,   419,   423,
     425,   429,   431,   432,   435,   438,   441,   444,   448,   452,
     456,   457,   461,   463,   465,   469,   471,   475,   477,   479,
     481,   483,   485,   487,   489,   491,   495,   497,   501,   503,
     505,   510,   512,   513,   517,   522,   524,   527,   528,   534,
     540,   546,   552,   557,   561,   565,   570,   576,   578,   579,
     583,   588,   593,   594,   597,   601,   605,   609,   612,   615,
     618,   621,   625,   629,   632,   635,   637,   639,   641,   646,
     647,   651,   655,   659,   660,   662,   664,   669,   670,   673,
     676,   679,   682,   685,   688,   691,   692,   695,   705,   715,
     720,   724,   728,   732,   736,   740,   744,   748,   752,   757,
     759,   761,   765,   766,   768,   772,   776,   780,   784,   789,
     794,   799,   804,   807,   809,   811,   813,   815,   816,   818,
     819,   824,   827,   829,   831,   833,   835,   837,   839,   841,
     843,   845,   847,   849,   851,   854,   857,   858,   862,   864,
     868,   870,   872,   874,   877,   881,   884,   889,   890,   896,
     897,   899,   901,   904,   906,   910,   912,   914,   916,   918,
     920,   924,   926,   928,   932,   934,   936,   938,   940,   942,
     946,   948,   954,   966,   968,   970,   972,   975,   977,   985,
     995,  1003,  1005,  1007,  1009,  1013,  1015,  1017,  1019,  1023,
    1025,  1029,  1031,  1035,  1039,  1041,  1044,  1047,  1054,  1056,
    1060,  1061,  1066,  1070,  1072,  1076,  1080,  1084,  1087,  1090,
    1093,  1096,  1097,  1100,  1103,  1104,  1106,  1108,  1110,  1112,
    1114,  1116,  1118,  1122,  1126,  1128,  1130,  1136,  1144,  1145,
    1150,  1152,  1154,  1156,  1158,  1160,  1162,  1164,  1166,  1168,
    1170,  1172,  1176,  1180,  1184,  1188,  1192,  1196,  1200,  1204,
    1208,  1212,  1216,  1220,  1224,  1228,  1231,  1236,  1238,  1240,
    1242,  1244,  1247,  1250,  1254,  1258,  1265,  1269,  1273,  1277,
    1281,  1287,  1294,  1301,  1308,  1315,  1320,  1329,  1334,  1336,
    1338,  1340,  1342,  1344,  1346,  1348,  1349,  1351,  1355,  1357,
    1361,  1362,  1364,  1369,  1376,  1381,  1385,  1391,  1397,  1402,
    1409,  1413,  1416,  1422,  1428,  1437,  1446,  1455,  1464,  1467,
    1469,  1472,  1475,  1478,  1479,  1483,  1489,  1490,  1493,  1498,
    1503,  1508,  1511,  1514,  1515,  1519,  1520,  1524,  1528,  1531,
    1532,  1535,  1538,  1539,  1542,  1543,  1546,  1551,  1557,  1560,
    1564,  1568,  1574,  1581,  1590,  1597,  1602,  1607,  1613,  1620,
    1627,  1633,  1637,  1641,  1646,  1652,  1658,  1664,  1670,  1676,
    1681,  1686,  1692,  1698,  1704,  1710,  1716,  1722,  1728,  1734,
    1741,  1748,  1757,  1764,  1771,  1777,  1782,  1788,  1793,  1799,
    1804,  1810,  1815,  1821,  1827,  1833,  1839,  1846,  1852,  1858,
    1865,  1871,  1877,  1882,  1885,  1889,  1893,  1895,  1898,  1902,
    1905,  1910,  1914,  1917,  1919,  1922,  1927,  1928,  1932,  1935,
    1937,  1940,  1944,  1948,  1952,  1956,  1959,  1963,  1964,  1970,
    1971,  1977,  1980,  1983,  1985,  1990,  1992,  1994,  1995,  1999,
    2002,  2005,  2008,  2014,  2017,  2018,  2022,  2023,  2026,  2029,
    2033,  2036,  2039,  2043,  2046,  2049,  2052,  2054,  2058,  2061,
    2064,  2067,  2070,  2073,  2076,  2080,  2083,  2086,  2089,  2092,
    2095,  2098,  2101,  2104,  2108,  2112,  2116,  2119,  2123,  2126,
    2130,  2134,  2139,  2142,  2145,  2148,  2152,  2156,  2160,  2163,
    2167,  2171,  2175,  2180,  2183,  2186,  2188,  2189,  2192,  2196,
    2198,  2199,  2201,  2204,  2205,  2208,  2209,  2211,  2215,  2216,
    2217,  2220,  2221,  2225,  2226,  2230,  2231,  2235,  2239,  2241,
    2242,  2247,  2254,  2261,  2268,  2276,  2283,  2291,  2297,  2298,
    2301,  2305,  2308,  2312,  2316,  2319,  2323,  2326,  2329,  2333,
    2337,  2343,  2348,  2353,  2356,  2360,  2364,  2369,  2374,  2379,
    2385,  2391,  2396,  2400,  2405,  2410,  2415,  2420,  2422,  2424,
    2426,  2428,  2430,  2432,  2434,  2436,  2437,  2440,  2443,  2446,
    2450,  2454,  2459,  2460,  2464,  2465,  2469,  2470,  2474,  2477,
    2481,  2485,  2491,  2497,  2501,  2504,  2508,  2512,  2514,  2517,
    2522,  2526,  2530,  2534,  2537,  2540,  2543,  2546,  2549,  2554,
    2556,  2558,  2560,  2562,  2564,  2566,  2568,  2570,  2572,  2574,
    2576,  2578,  2580,  2582,  2584,  2586,  2588,  2590,  2592,  2594,
    2596,  2598,  2600,  2602,  2604,  2606,  2608,  2610,  2612,  2614,
    2616,  2618,  2620,  2622,  2624,  2626,  2628,  2630,  2632,  2634,
    2636,  2638,  2640,  2642,  2644,  2646,  2648,  2650,  2652,  2654,
    2656,  2658,  2660,  2662,  2664,  2666,  2668,  2670,  2672,  2674,
    2676,  2679,  2682,  2685,  2687,  2690,  2693,  2696,  2699,  2702,
    2706,  2710,  2714,  2718,  2722,  2726,  2730,  2732,  2734,  2736,
    2738,  2740,  2742,  2744,  2746,  2748,  2750,  2752,  2754,  2756,
    2758,  2760,  2762,  2764,  2766,  2768,  2770,  2772,  2774
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     371,     0,    -1,   372,     3,    -1,     4,   622,    -1,    -1,
     372,   621,    -1,    33,    19,    22,   537,   360,    -1,    15,
      -1,   361,   537,   362,    -1,    19,    -1,   374,    38,    -1,
     374,    39,    -1,   374,    40,    -1,   374,    -1,    34,    -1,
      36,    -1,    35,    -1,    37,    -1,    -1,    18,    -1,    19,
      -1,    -1,    30,    19,    -1,    -1,    41,   374,    -1,   377,
     382,    -1,   380,    -1,   377,    -1,    29,   374,    -1,   363,
     377,    -1,    20,    -1,    20,    -1,    19,    -1,    20,    -1,
      -1,    42,   388,   389,   360,    -1,    62,   384,    -1,    -1,
     384,    -1,    43,   387,    -1,    54,    -1,    44,    -1,   364,
     390,   365,    -1,   391,    -1,   390,   366,   391,    -1,    45,
      -1,    46,    -1,    47,    -1,    48,    -1,    49,    -1,    50,
      -1,    51,    -1,    52,    -1,    53,    -1,   133,   111,   444,
     360,    -1,   133,   384,   360,    -1,   147,    -1,    85,    -1,
      61,    -1,    42,    -1,   393,    20,    -1,   393,    20,   374,
      20,    -1,   393,    57,    59,    -1,   393,    57,    60,    -1,
     393,    58,    59,    -1,   393,    58,    60,    -1,    56,   394,
     360,    -1,    67,   402,   403,     3,    -1,    67,    55,   402,
     403,     3,    -1,    67,    63,     3,    -1,    67,    64,     3,
      -1,    67,    65,   402,     3,    -1,    68,     3,    -1,    -1,
      20,    -1,    -1,    66,    -1,    66,   374,    -1,   420,    69,
      -1,    70,   376,    -1,    71,    72,   374,    -1,    73,   376,
      -1,    74,    75,   376,    -1,    76,    77,   376,    -1,   420,
      74,    -1,    71,    72,   374,    -1,   113,   385,   381,    -1,
      69,    80,   374,    -1,    83,    84,   410,   360,    -1,    83,
      84,   106,   435,   360,    -1,    15,    -1,    17,    -1,    18,
      -1,   122,   123,   412,   360,    -1,    -1,   412,   413,    -1,
     126,   377,    -1,    41,   374,    -1,   124,    -1,   125,    -1,
      76,    77,   140,   374,   360,    -1,    -1,   129,    -1,    80,
      19,   415,    -1,   121,    80,    19,    -1,    -1,   418,   121,
     380,   141,    15,   143,    15,   360,    -1,   417,    -1,   417,
     364,   418,   365,    -1,    85,    -1,    86,    -1,    -1,    19,
      -1,    19,   106,    19,    -1,    -1,    87,   374,    -1,    88,
     376,    -1,    45,   441,    -1,   133,   444,    -1,    91,   423,
      -1,    92,   423,    -1,    97,    98,   425,    -1,    91,    98,
     425,    -1,    92,    98,   425,    -1,    91,   103,   104,   376,
      -1,    80,   426,    -1,    83,    84,   410,    -1,   128,   384,
      -1,    93,   501,    -1,   502,    -1,    44,    -1,    94,    -1,
      -1,    99,   100,    -1,    99,   101,    -1,    99,    77,    -1,
      99,   102,    -1,   374,   424,    -1,    35,    -1,    19,    -1,
      45,   111,   441,    -1,    45,   117,   374,    -1,    -1,    20,
      -1,   381,    -1,    20,   381,    -1,    -1,    27,    -1,   428,
     430,   429,    -1,   431,    -1,   432,   366,   431,    -1,   432,
      -1,    -1,   434,   432,    -1,   138,   374,    -1,   139,   374,
      -1,   420,    89,    -1,   437,   421,   364,    -1,   438,   422,
     360,    -1,   438,   440,   360,    -1,    -1,    90,   439,   432,
      -1,    44,    -1,    35,    -1,   364,   442,   365,    -1,   443,
      -1,   442,   366,   443,    -1,    95,    -1,    75,    -1,    96,
      -1,   112,    -1,   109,    -1,   110,    -1,    44,    -1,    35,
      -1,   364,   445,   365,    -1,   446,    -1,   445,   366,   446,
      -1,    95,    -1,   134,    -1,   127,   364,   448,   365,    -1,
     449,    -1,    -1,   449,   360,   448,    -1,   450,   364,   451,
     365,    -1,   450,    -1,   105,   384,    -1,    -1,   120,   106,
     383,   360,   451,    -1,   120,   108,   383,   360,   451,    -1,
     164,   106,   383,   360,   451,    -1,   164,   108,   383,   360,
     451,    -1,    84,   374,   360,   451,    -1,   144,   145,     3,
      -1,   144,   136,     3,    -1,   144,   111,   492,     3,    -1,
     144,   111,    44,   492,     3,    -1,    19,    -1,    -1,   144,
     112,     3,    -1,   144,   112,   146,     3,    -1,   144,   147,
     460,     3,    -1,    -1,   460,   380,    -1,   460,   116,   381,
      -1,   460,    80,    19,    -1,   460,    93,   501,    -1,   460,
     502,    -1,   460,    44,    -1,   460,   113,    -1,   460,   104,
      -1,   460,   461,    19,    -1,   460,    85,    19,    -1,   460,
     114,    -1,   460,   115,    -1,   118,    -1,    92,    -1,   119,
      -1,   144,   121,   463,     3,    -1,    -1,   463,   464,   380,
      -1,   463,   143,    15,    -1,   463,    80,    19,    -1,    -1,
     131,    -1,   116,    -1,   144,   148,   466,     3,    -1,    -1,
     466,    80,    -1,   466,   159,    -1,   466,    93,    -1,   466,
      85,    -1,   466,    86,    -1,   466,   121,    -1,   466,    19,
      -1,    -1,    80,    19,    -1,   149,   121,   380,   141,    15,
     143,    15,   467,     3,    -1,   150,   121,   380,   141,    15,
     143,    15,   467,     3,    -1,   142,   121,   467,     3,    -1,
     151,   152,     3,    -1,   151,   153,     3,    -1,   151,   112,
       3,    -1,   151,   154,     3,    -1,   151,   155,     3,    -1,
     151,    75,     3,    -1,   151,   111,     3,    -1,   156,   537,
       3,    -1,   157,   480,   481,     3,    -1,    44,    -1,    35,
      -1,   364,   390,   365,    -1,    -1,    15,    -1,   102,   491,
       3,    -1,   158,   491,     3,    -1,    77,   491,     3,    -1,
     130,   491,     3,    -1,   130,   131,   491,     3,    -1,   130,
     132,   491,     3,    -1,    45,   491,   441,     3,    -1,   133,
     491,   444,     3,    -1,   135,     3,    -1,    19,    -1,    44,
      -1,    20,    -1,    19,    -1,    -1,    20,    -1,    -1,    93,
      19,   494,   500,    -1,   156,   537,    -1,   167,    -1,   168,
      -1,   169,    -1,   170,    -1,   171,    -1,   172,    -1,   173,
      -1,   175,    -1,   176,    -1,   177,    -1,   178,    -1,   179,
      -1,   496,   174,    -1,   496,    19,    -1,    -1,   497,   360,
     498,    -1,   497,    -1,   497,   360,   499,    -1,   504,    -1,
      19,    -1,   500,    -1,   210,   537,    -1,   361,   499,   362,
      -1,   361,   362,    -1,   498,   364,   507,   365,    -1,    -1,
     159,    19,   506,   503,   504,    -1,    -1,   508,    -1,   543,
      -1,   508,   543,    -1,   543,    -1,   364,   507,   365,    -1,
      18,    -1,    15,    -1,    17,    -1,   510,    -1,    16,    -1,
     361,   537,   362,    -1,    19,    -1,    15,    -1,   361,   537,
     362,    -1,    17,    -1,   510,    -1,    16,    -1,   537,    -1,
     513,    -1,   513,     7,   513,    -1,    28,    -1,   361,   514,
     366,   514,   362,    -1,   361,   514,   366,   514,   362,     7,
     361,   513,   366,   513,   362,    -1,   537,    -1,   186,    -1,
     187,    -1,   188,    15,    -1,   189,    -1,   361,   517,   366,
     516,   366,   516,   362,    -1,   361,   517,   366,   516,   366,
     516,     7,   516,   362,    -1,   361,   517,   366,   516,   366,
      28,   362,    -1,   515,    -1,   518,    -1,   511,    -1,   511,
       7,   511,    -1,   515,    -1,   518,    -1,   512,    -1,   512,
       7,   512,    -1,   519,    -1,   521,   366,   519,    -1,   520,
      -1,   522,   366,   520,    -1,    18,    29,    15,    -1,   523,
      -1,   523,    26,    -1,   523,    27,    -1,   523,   364,    15,
     366,    15,   365,    -1,   524,    -1,   525,   366,   524,    -1,
      -1,   526,   522,   363,   507,    -1,   526,     6,   507,    -1,
     535,    -1,   361,   537,   362,    -1,    13,   529,    14,    -1,
      29,   530,    29,    -1,    15,   529,    -1,    28,   529,    -1,
     367,   529,    -1,   527,   529,    -1,    -1,    15,   530,    -1,
     367,   530,    -1,    -1,    15,    -1,   184,    -1,   185,    -1,
      20,    -1,   510,    -1,   523,    -1,    17,    -1,   368,   521,
     369,    -1,   368,   525,   369,    -1,    16,    -1,   528,    -1,
     361,   537,   366,   537,   362,    -1,   361,   517,   366,   537,
     366,   537,   362,    -1,    -1,    19,   361,   542,   362,    -1,
      19,    -1,   106,    -1,   190,    -1,   191,    -1,   193,    -1,
     194,    -1,   195,    -1,   196,    -1,   197,    -1,   198,    -1,
     199,    -1,   361,   537,   362,    -1,   537,    26,   537,    -1,
     537,    27,   537,    -1,   537,    28,   537,    -1,   537,    29,
     537,    -1,   537,    11,   537,    -1,   537,    12,   537,    -1,
     537,    22,   537,    -1,   537,    10,   537,    -1,   537,    23,
     537,    -1,   537,     9,   537,    -1,   537,    24,   537,    -1,
     537,     8,   537,    -1,   537,    25,   537,    -1,    31,   537,
      -1,   201,   361,   537,   362,    -1,   535,    -1,   531,    -1,
     532,    -1,    87,    -1,   533,   536,    -1,   533,   626,    -1,
     537,    32,   169,    -1,   537,    32,   200,    -1,   537,    32,
     192,   361,   537,   362,    -1,   537,    32,   205,    -1,   537,
      32,   206,    -1,    26,   209,    26,    -1,    27,   209,    27,
      -1,    27,    27,   209,    27,    27,    -1,   204,   361,   537,
     366,   537,   362,    -1,   149,   361,   537,   366,   537,   362,
      -1,   150,   361,   537,   366,   537,   362,    -1,    93,   361,
     537,   366,   537,   362,    -1,   208,   361,    19,   362,    -1,
     208,   361,    19,   366,   537,   366,   537,   362,    -1,    19,
     361,   542,   362,    -1,   166,    -1,   164,    -1,   165,    -1,
      50,    -1,   160,    -1,   161,    -1,   537,    -1,    -1,   539,
      -1,   539,   366,   540,    -1,   537,    -1,   537,   366,   541,
      -1,    -1,   541,    -1,   180,   537,   181,   509,    -1,   180,
     537,   181,   509,   182,   509,    -1,    19,    22,   537,   360,
      -1,   163,   537,   360,    -1,   533,   626,    22,   537,   360,
      -1,   533,   536,    22,   537,   360,    -1,    87,    22,   537,
     360,    -1,   162,   361,   533,   626,   362,   360,    -1,   538,
     540,   360,    -1,   534,   360,    -1,   183,   537,   364,   526,
     365,    -1,   533,   626,    32,   209,   360,    -1,   533,   626,
      32,   204,   361,   537,   362,   360,    -1,   533,   626,    32,
     149,   361,   537,   362,   360,    -1,   533,   626,    32,   150,
     361,   537,   362,   360,    -1,   533,   626,    32,    93,   361,
     537,   362,   360,    -1,   420,   211,    -1,   422,    -1,    90,
     552,    -1,   218,   553,    -1,   219,   557,    -1,    -1,   546,
     545,   360,    -1,   544,   421,   364,   546,   365,    -1,    -1,
     216,   375,    -1,   212,   214,   216,   375,    -1,   212,   215,
     216,   375,    -1,   213,   215,   216,   375,    -1,   217,   374,
      -1,   107,   376,    -1,    -1,   550,   549,   360,    -1,    -1,
     364,   550,   365,    -1,   548,   433,   551,    -1,   548,   551,
      -1,    -1,    30,    19,    -1,   220,   384,    -1,    -1,   221,
     377,    -1,    -1,   218,   376,    -1,   377,   554,   555,   556,
      -1,   144,   211,   222,   456,     3,    -1,   420,   123,    -1,
     559,   421,   364,    -1,   560,   422,   360,    -1,   560,   221,
     143,   374,   360,    -1,   560,   221,   377,   143,   374,   360,
      -1,   560,   219,   377,   378,   379,   143,   374,   360,    -1,
     560,   248,   251,    84,   410,   360,    -1,   560,   248,   250,
     360,    -1,   560,   249,   250,   360,    -1,   560,   223,    72,
     374,   360,    -1,   560,   227,   223,    72,   374,   360,    -1,
     560,   224,   225,    72,   374,   360,    -1,   560,   226,    72,
     374,   360,    -1,   560,    89,   360,    -1,   560,   218,   360,
      -1,   560,   218,   374,   360,    -1,   560,   229,   230,   231,
     360,    -1,   560,   229,   230,   103,   360,    -1,   560,   258,
     259,   231,   360,    -1,   560,   258,   259,   260,   360,    -1,
     560,   258,   259,   261,   360,    -1,   560,   268,    89,   360,
      -1,   560,   268,   269,   360,    -1,   560,   233,   234,   376,
     360,    -1,   560,   270,   234,   376,   360,    -1,   560,   267,
     234,   376,   360,    -1,   560,   256,   257,   376,   360,    -1,
     560,   273,   270,   376,   360,    -1,   560,   232,   241,   374,
     360,    -1,   560,   232,   240,   374,   360,    -1,   560,   194,
     126,   377,   360,    -1,   560,   235,   236,    72,   374,   360,
      -1,   560,    50,   237,    72,   374,   360,    -1,   560,    50,
     140,    72,   374,   366,   374,   360,    -1,   560,   102,   238,
      50,   376,   360,    -1,   560,   158,   147,   262,   376,   360,
      -1,   560,   158,   252,   376,   360,    -1,   560,   255,   376,
     360,    -1,   560,   253,   254,   376,   360,    -1,   560,   105,
     384,   360,    -1,   560,   147,    98,   374,   360,    -1,   560,
     107,   376,   360,    -1,   560,   263,   264,   376,   360,    -1,
     560,   274,   376,   360,    -1,   560,   149,   276,   214,   360,
      -1,   560,   149,   276,   215,   360,    -1,   560,   149,   276,
     376,   360,    -1,   560,   275,   221,   143,   360,    -1,   560,
     275,   221,   143,   374,   360,    -1,   560,    76,    77,   376,
     360,    -1,   560,    76,    77,   277,   360,    -1,   560,    76,
      77,    72,   374,   360,    -1,   560,   267,    80,   426,   360,
      -1,   560,   271,   272,   376,   360,    -1,   560,   211,   376,
     360,    -1,   420,   278,    -1,   561,   421,   364,    -1,   562,
     563,   360,    -1,   422,    -1,   284,   376,    -1,   285,    83,
     376,    -1,   321,   376,    -1,   321,   376,    98,   374,    -1,
     332,   319,   376,    -1,   286,   374,    -1,   565,    -1,   279,
     410,    -1,   564,   364,   566,   365,    -1,    -1,   566,   567,
     360,    -1,   285,   376,    -1,   323,    -1,   146,   376,    -1,
     232,   323,   376,    -1,   232,   287,   374,    -1,   232,   288,
     374,    -1,   285,   287,   374,    -1,   324,   376,    -1,   324,
     325,   374,    -1,    -1,   309,   568,   364,   579,   365,    -1,
      -1,   319,   569,   364,   579,   365,    -1,   317,   570,    -1,
      90,   592,    -1,   574,    -1,   571,   364,   572,   365,    -1,
     571,    -1,   380,    -1,    -1,   572,   573,   360,    -1,   310,
     376,    -1,   146,   376,    -1,   287,   374,    -1,   577,   587,
     364,   575,   365,    -1,   577,   587,    -1,    -1,   575,   576,
     360,    -1,    -1,   290,   374,    -1,   289,   374,    -1,   291,
     236,   374,    -1,   140,   374,    -1,   293,   374,    -1,   293,
     115,   374,    -1,   304,    94,    -1,   304,   303,    -1,   304,
     306,    -1,   447,    -1,   311,   312,   410,    -1,   287,   374,
      -1,   290,   374,    -1,   308,   374,    -1,   289,   374,    -1,
     140,   374,    -1,   293,   374,    -1,   293,   115,   374,    -1,
     294,   295,    -1,   294,   296,    -1,   294,   297,    -1,   294,
     298,    -1,   294,   299,    -1,   294,   300,    -1,   294,   301,
      -1,   294,   302,    -1,   329,   295,   376,    -1,   300,   330,
     376,    -1,   291,   236,   374,    -1,   292,   374,    -1,   305,
     297,   376,    -1,   285,   376,    -1,    65,   312,   376,    -1,
     321,   322,   374,    -1,   154,   364,   583,   365,    -1,   304,
      94,    -1,   304,   303,    -1,   304,   306,    -1,   214,   314,
     316,    -1,   214,   314,   315,    -1,   214,   314,   374,    -1,
     215,   436,    -1,   215,   292,   374,    -1,   215,   331,   374,
      -1,   271,   272,   376,    -1,   271,   272,   215,   313,    -1,
     211,   376,    -1,   274,   376,    -1,   447,    -1,    -1,   579,
     580,    -1,   581,   582,   360,    -1,   380,    -1,    -1,   310,
      -1,   318,   374,    -1,    -1,   583,   585,    -1,    -1,   307,
      -1,    18,   584,   360,    -1,    -1,    -1,   328,   374,    -1,
      -1,   432,   589,   587,    -1,    -1,   590,   578,   360,    -1,
      -1,   364,   590,   365,    -1,   586,   588,   591,    -1,    20,
      -1,    -1,   144,   278,   456,     3,    -1,   144,   278,   154,
     456,   593,     3,    -1,   144,   278,    90,   456,   593,     3,
      -1,   144,   278,   333,   456,   593,     3,    -1,   144,   278,
     333,    44,   456,   593,     3,    -1,   144,   278,   334,   456,
     593,     3,    -1,   144,   278,   334,    44,   456,   593,     3,
      -1,   144,   278,   320,   602,     3,    -1,    -1,   602,   326,
      -1,   602,   279,   410,    -1,   602,   312,    -1,   602,   294,
      15,    -1,   602,   327,   410,    -1,   602,   231,    -1,   602,
      83,   410,    -1,   602,    19,    -1,   420,   335,    -1,   603,
     421,   364,    -1,   604,   422,   360,    -1,   604,   336,    80,
      19,   360,    -1,   604,   337,   338,   360,    -1,   604,   337,
     339,   360,    -1,   420,   340,    -1,   605,   421,   364,    -1,
     606,   422,   360,    -1,   606,   341,   374,   360,    -1,   606,
      41,   374,   360,    -1,   606,   342,   374,   360,    -1,   606,
     343,    72,   374,   360,    -1,   606,    66,    72,   374,   360,
      -1,   606,   304,   607,   360,    -1,   606,   447,   360,    -1,
     606,   350,   352,   360,    -1,   606,   350,   219,   360,    -1,
     606,   350,   351,   360,    -1,   606,    90,   613,   360,    -1,
     348,    -1,   349,    -1,    94,    -1,   295,    -1,   344,    -1,
     345,    -1,   346,    -1,   347,    -1,    -1,   234,   374,    -1,
     337,   608,    -1,   215,   436,    -1,   215,   292,   374,    -1,
     271,   272,   376,    -1,   271,   272,   215,   313,    -1,    -1,
     610,   609,   360,    -1,    -1,   364,   610,   365,    -1,    -1,
     612,   432,   611,    -1,   420,   355,    -1,   614,   421,   364,
      -1,   615,   422,   360,    -1,   615,    65,   312,   376,   360,
      -1,   615,   267,    80,   426,   360,    -1,   615,   619,   360,
      -1,   147,   380,    -1,   228,   377,   378,    -1,   617,   322,
     374,    -1,   617,    -1,   618,   617,    -1,   616,   228,   377,
     378,    -1,   616,   228,    20,    -1,   616,   357,   618,    -1,
     616,   269,   377,    -1,   616,   260,    -1,   616,   165,    -1,
     616,   358,    -1,   616,   359,    -1,   616,   356,    -1,   144,
     355,   456,     3,    -1,   360,    -1,   373,    -1,   386,    -1,
     392,    -1,   395,    -1,   409,    -1,   411,    -1,   414,    -1,
     416,    -1,   419,    -1,   623,    -1,   427,    -1,   493,    -1,
     495,    -1,   505,    -1,   396,    -1,   397,    -1,   398,    -1,
     399,    -1,   400,    -1,   401,    -1,   452,    -1,   453,    -1,
     454,    -1,   455,    -1,   457,    -1,   458,    -1,   459,    -1,
     462,    -1,   465,    -1,   468,    -1,   469,    -1,   470,    -1,
     471,    -1,   472,    -1,   473,    -1,   474,    -1,   475,    -1,
     476,    -1,   477,    -1,   478,    -1,   479,    -1,   482,    -1,
     483,    -1,   484,    -1,   485,    -1,   486,    -1,   487,    -1,
     488,    -1,   489,    -1,   490,    -1,   558,    -1,   594,    -1,
     595,    -1,   596,    -1,   597,    -1,   598,    -1,   599,    -1,
     600,    -1,   601,    -1,   620,    -1,   624,   365,    -1,   625,
     365,    -1,   438,   365,    -1,   547,    -1,   560,   365,    -1,
     562,   365,    -1,   604,   365,    -1,   606,   365,    -1,   615,
     365,    -1,   404,   421,   364,    -1,   624,   422,   360,    -1,
     624,   405,   360,    -1,   624,   408,   360,    -1,   406,   421,
     364,    -1,   625,   422,   360,    -1,   625,   407,   360,    -1,
      78,    -1,    79,    -1,    81,    -1,    82,    -1,   137,    -1,
       5,    -1,   242,    -1,   239,    -1,   243,    -1,   241,    -1,
     240,    -1,   244,    -1,   245,    -1,   246,    -1,   265,    -1,
     266,    -1,   247,    -1,   280,    -1,   281,    -1,   282,    -1,
     283,    -1,   353,    -1,   354,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   714,   714,   715,   718,   720,   728,   737,   738,   739,
     746,   747,   748,   756,   757,   758,   759,   760,   761,   767,
     768,   775,   776,   780,   781,   788,   795,   796,   800,   804,
     811,   819,   820,   827,   828,   834,   843,   844,   848,   853,
     854,   858,   859,   863,   864,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   882,   883,   892,   893,   894,   895,
     898,   899,   900,   901,   902,   903,   907,   914,   917,   924,
     927,   930,   933,   937,   938,   942,   943,   944,   952,   957,
     958,   962,   969,   970,   976,   981,   985,   999,  1013,  1014,
    1018,  1019,  1020,  1031,  1033,  1035,  1039,  1040,  1041,  1042,
    1047,  1053,  1054,  1058,  1066,  1070,  1072,  1078,  1079,  1086,
    1087,  1091,  1097,  1101,  1111,  1113,  1117,  1118,  1119,  1120,
    1121,  1122,  1123,  1124,  1125,  1126,  1127,  1128,  1132,  1133,
    1134,  1135,  1139,  1140,  1141,  1142,  1143,  1147,  1153,  1157,
    1165,  1166,  1174,  1182,  1183,  1184,  1188,  1189,  1193,  1198,
    1199,  1203,  1205,  1213,  1217,  1218,  1224,  1231,  1232,  1233,
    1237,  1245,  1251,  1252,  1253,  1257,  1258,  1262,  1263,  1264,
    1265,  1266,  1267,  1273,  1274,  1275,  1279,  1280,  1284,  1285,
    1291,  1292,  1295,  1297,  1301,  1302,  1306,  1324,  1325,  1326,
    1327,  1328,  1329,  1337,  1340,  1343,  1346,  1350,  1351,  1354,
    1357,  1361,  1365,  1370,  1376,  1383,  1388,  1393,  1398,  1402,
    1406,  1410,  1419,  1427,  1431,  1438,  1439,  1440,  1445,  1449,
    1456,  1463,  1467,  1475,  1476,  1477,  1482,  1486,  1489,  1490,
    1491,  1492,  1493,  1494,  1495,  1500,  1505,  1513,  1520,  1527,
    1535,  1537,  1539,  1541,  1543,  1545,  1547,  1550,  1554,  1560,
    1561,  1562,  1566,  1567,  1573,  1575,  1577,  1579,  1581,  1583,
    1587,  1591,  1594,  1598,  1599,  1600,  1604,  1605,  1606,  1614,
    1614,  1624,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1661,  1672,  1673,  1680,  1681,
    1688,  1697,  1701,  1705,  1729,  1730,  1734,  1747,  1747,  1763,
    1764,  1767,  1768,  1772,  1775,  1784,  1797,  1798,  1799,  1800,
    1801,  1805,  1813,  1814,  1815,  1816,  1817,  1821,  1824,  1825,
    1826,  1830,  1833,  1842,  1845,  1846,  1847,  1848,  1852,  1853,
    1854,  1858,  1859,  1860,  1861,  1865,  1866,  1867,  1868,  1872,
    1873,  1877,  1878,  1882,  1889,  1890,  1891,  1892,  1899,  1900,
    1903,  1904,  1911,  1923,  1924,  1928,  1929,  1933,  1934,  1935,
    1936,  1937,  1941,  1942,  1943,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1961,  1962,  1972,  1976,
    1999,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,
    2035,  2036,  2037,  2038,  2039,  2040,  2041,  2043,  2044,  2045,
    2047,  2049,  2051,  2053,  2054,  2055,  2056,  2057,  2067,  2068,
    2069,  2070,  2071,  2072,  2073,  2075,  2076,  2081,  2104,  2105,
    2106,  2107,  2108,  2109,  2113,  2116,  2117,  2118,  2126,  2133,
    2142,  2143,  2147,  2153,  2163,  2172,  2178,  2183,  2190,  2195,
    2201,  2202,  2203,  2211,  2212,  2213,  2214,  2215,  2221,  2233,
    2234,  2235,  2236,  2239,  2241,  2245,  2249,  2260,  2261,  2262,
    2263,  2264,  2265,  2268,  2270,  2273,  2275,  2278,  2281,  2286,
    2287,  2288,  2292,  2293,  2297,  2298,  2301,  2320,  2326,  2350,
    2351,  2352,  2353,  2354,  2365,  2366,  2367,  2368,  2369,  2370,
    2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,
    2381,  2382,  2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,
    2391,  2392,  2393,  2394,  2395,  2396,  2397,  2398,  2399,  2404,
    2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,  2413,  2414,
    2415,  2416,  2417,  2428,  2438,  2439,  2443,  2444,  2445,  2446,
    2447,  2448,  2449,  2450,  2453,  2468,  2471,  2473,  2477,  2478,
    2479,  2480,  2481,  2482,  2483,  2484,  2485,  2486,  2486,  2487,
    2487,  2488,  2489,  2490,  2494,  2495,  2499,  2507,  2509,  2513,
    2514,  2515,  2519,  2520,  2523,  2525,  2528,  2529,  2530,  2531,
    2532,  2533,  2534,  2535,  2536,  2537,  2538,  2541,  2563,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,
    2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
    2595,  2596,  2597,  2598,  2599,  2600,  2603,  2605,  2608,  2610,
    2619,  2621,  2622,  2625,  2627,  2631,  2632,  2635,  2645,  2668,
    2670,  2674,  2674,  2677,  2679,  2682,  2684,  2688,  2692,  2693,
    2698,  2701,  2704,  2709,  2712,  2717,  2720,  2724,  2728,  2731,
    2732,  2733,  2734,  2735,  2736,  2737,  2738,  2744,  2751,  2752,
    2753,  2758,  2759,  2765,  2772,  2773,  2774,  2775,  2776,  2777,
    2778,  2779,  2780,  2781,  2782,  2783,  2784,  2788,  2789,  2790,
    2795,  2796,  2797,  2798,  2799,  2802,  2803,  2804,  2805,  2806,
    2807,  2808,  2811,  2813,  2816,  2818,  2822,  2834,  2841,  2848,
    2849,  2850,  2851,  2852,  2855,  2864,  2872,  2879,  2880,  2884,
    2889,  2895,  2898,  2903,  2904,  2905,  2906,  2907,  2910,  2917,
    2917,  2917,  2917,  2917,  2917,  2917,  2917,  2917,  2917,  2917,
    2917,  2917,  2917,  2917,  2918,  2918,  2918,  2918,  2918,  2918,
    2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,
    2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,
    2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,
    2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,  2918,
    2919,  2919,  2919,  2919,  2919,  2919,  2919,  2919,  2919,  2920,
    2920,  2920,  2920,  2921,  2921,  2921,  2922,  2922,  2922,  2922,
    2922,  2923,  2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,
    2931,  2932,  2933,  2934,  2934,  2934,  2934,  2934,  2934
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG", "SYSLOG",
  "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH",
  "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT",
  "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ROUTES", "GRACEFUL", "RESTART", "KRT_SOURCE", "KRT_METRIC",
  "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD",
  "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT",
  "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "WAIT",
  "MAX", "FLUSH", "AS", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS", "AWARE",
  "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2",
  "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "LINK", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "MERGE",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RIP", "INFINITY", "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN",
  "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "ipa_port", "prefix", "prefix_or_ipa",
  "pxlen", "datetime", "text", "text_or_none", "log_config", "syslog_name",
  "log_file", "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_mode", "cmd_SHOW_ROA", "roa_args",
  "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_item", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_cfg_start",
  "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
      59,    40,    41,    58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   370,   371,   371,   372,   372,   373,   374,   374,   374,
     375,   375,   375,   376,   376,   376,   376,   376,   376,   377,
     377,   378,   378,   379,   379,   380,   381,   381,   382,   382,
     383,   384,   384,   385,   385,   386,   387,   387,   388,   388,
     388,   389,   389,   390,   390,   391,   391,   391,   391,   391,
     391,   391,   391,   391,   392,   392,   393,   393,   393,   393,
     394,   394,   394,   394,   394,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   402,   403,   403,   403,   404,   405,
     405,   405,   405,   405,   406,   407,   407,   408,   409,   409,
     410,   410,   410,   411,   412,   412,   413,   413,   413,   413,
     414,   415,   415,   416,   417,   418,   418,   419,   419,   420,
     420,   421,   421,   421,   422,   422,   422,   422,   422,   422,
     422,   422,   422,   422,   422,   422,   422,   422,   423,   423,
     423,   423,   424,   424,   424,   424,   424,   425,   425,   426,
     427,   427,   428,   429,   429,   429,   430,   430,   431,   432,
     432,   433,   434,   435,   436,   436,   437,   438,   438,   438,
     439,   440,   441,   441,   441,   442,   442,   443,   443,   443,
     443,   443,   443,   444,   444,   444,   445,   445,   446,   446,
     447,   447,   448,   448,   449,   449,   450,   451,   451,   451,
     451,   451,   451,   452,   453,   454,   455,   456,   456,   457,
     458,   459,   460,   460,   460,   460,   460,   460,   460,   460,
     460,   460,   460,   460,   460,   461,   461,   461,   462,   463,
     463,   463,   463,   464,   464,   464,   465,   466,   466,   466,
     466,   466,   466,   466,   466,   467,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     480,   480,   481,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   491,   491,   492,   492,   492,   494,
     493,   495,   496,   496,   496,   496,   496,   496,   496,   496,
     496,   496,   496,   496,   496,   497,   498,   498,   499,   499,
     500,   501,   501,   502,   503,   503,   504,   506,   505,   507,
     507,   508,   508,   509,   509,   510,   511,   511,   511,   511,
     511,   511,   512,   512,   512,   512,   512,   513,   514,   514,
     514,   515,   515,   516,   517,   517,   517,   517,   518,   518,
     518,   519,   519,   519,   519,   520,   520,   520,   520,   521,
     521,   522,   522,   523,   524,   524,   524,   524,   525,   525,
     526,   526,   526,   527,   527,   528,   528,   529,   529,   529,
     529,   529,   530,   530,   530,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   531,   532,   532,   533,   534,
     535,   536,   536,   536,   536,   536,   536,   536,   536,   536,
     536,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   537,   537,   537,   537,   538,   538,
     538,   538,   538,   538,   539,   540,   540,   540,   541,   541,
     542,   542,   543,   543,   543,   543,   543,   543,   543,   543,
     543,   543,   543,   543,   543,   543,   543,   543,   544,   545,
     545,   545,   545,   546,   546,   547,   548,   549,   549,   549,
     549,   549,   549,   550,   550,   551,   551,   552,   553,   554,
     554,   554,   555,   555,   556,   556,   557,   558,   559,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   561,   562,   562,   563,   563,   563,   563,
     563,   563,   563,   563,   564,   565,   566,   566,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   568,   567,   569,
     567,   567,   567,   567,   570,   570,   571,   572,   572,   573,
     573,   573,   574,   574,   575,   575,   576,   576,   576,   576,
     576,   576,   576,   576,   576,   576,   576,   577,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   579,   579,   580,   581,
     582,   582,   582,   583,   583,   584,   584,   585,   586,   587,
     587,   589,   588,   590,   590,   591,   591,   592,   593,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   603,   604,   604,
     604,   604,   604,   605,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   607,   607,   607,
     608,   608,   608,   608,   608,   609,   609,   609,   609,   609,
     609,   609,   610,   610,   611,   611,   612,   613,   614,   615,
     615,   615,   615,   615,   616,   617,   617,   618,   618,   619,
     619,   619,   619,   619,   619,   619,   619,   619,   620,   621,
     621,   621,   621,   621,   621,   621,   621,   621,   621,   621,
     621,   621,   621,   621,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   624,
     624,   624,   624,   625,   625,   625,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     0,     2,     2,     1,     1,     2,     2,
       1,     1,     1,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     4,     5,     3,
       3,     4,     2,     0,     1,     0,     1,     2,     2,     2,
       3,     2,     3,     3,     2,     3,     3,     3,     4,     5,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     3,     0,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     4,     2,     3,     2,     2,     1,
       1,     1,     0,     2,     2,     2,     2,     2,     1,     1,
       3,     3,     0,     1,     1,     2,     0,     1,     3,     1,
       3,     1,     0,     2,     2,     2,     2,     3,     3,     3,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       4,     1,     0,     3,     4,     1,     2,     0,     5,     5,
       5,     5,     4,     3,     3,     4,     5,     1,     0,     3,
       4,     4,     0,     2,     3,     3,     3,     2,     2,     2,
       2,     3,     3,     2,     2,     1,     1,     1,     4,     0,
       3,     3,     3,     0,     1,     1,     4,     0,     2,     2,
       2,     2,     2,     2,     2,     0,     2,     9,     9,     4,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     1,
       1,     3,     0,     1,     3,     3,     3,     3,     4,     4,
       4,     4,     2,     1,     1,     1,     1,     0,     1,     0,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     3,     1,     3,
       1,     1,     1,     2,     3,     2,     4,     0,     5,     0,
       1,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     5,    11,     1,     1,     1,     2,     1,     7,     9,
       7,     1,     1,     1,     3,     1,     1,     1,     3,     1,
       3,     1,     3,     3,     1,     2,     2,     6,     1,     3,
       0,     4,     3,     1,     3,     3,     3,     2,     2,     2,
       2,     0,     2,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     1,     5,     7,     0,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     4,     1,     1,     1,
       1,     2,     2,     3,     3,     6,     3,     3,     3,     3,
       5,     6,     6,     6,     6,     4,     8,     4,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     1,     3,
       0,     1,     4,     6,     4,     3,     5,     5,     4,     6,
       3,     2,     5,     5,     8,     8,     8,     8,     2,     1,
       2,     2,     2,     0,     3,     5,     0,     2,     4,     4,
       4,     2,     2,     0,     3,     0,     3,     3,     2,     0,
       2,     2,     0,     2,     0,     2,     4,     5,     2,     3,
       3,     5,     6,     8,     6,     4,     4,     5,     6,     6,
       5,     3,     3,     4,     5,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     8,     6,     6,     5,     4,     5,     4,     5,     4,
       5,     4,     5,     5,     5,     5,     6,     5,     5,     6,
       5,     5,     4,     2,     3,     3,     1,     2,     3,     2,
       4,     3,     2,     1,     2,     4,     0,     3,     2,     1,
       2,     3,     3,     3,     3,     2,     3,     0,     5,     0,
       5,     2,     2,     1,     4,     1,     1,     0,     3,     2,
       2,     2,     5,     2,     0,     3,     0,     2,     2,     3,
       2,     2,     3,     2,     2,     2,     1,     3,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     2,     3,     2,     3,
       3,     4,     2,     2,     2,     3,     3,     3,     2,     3,
       3,     3,     4,     2,     2,     1,     0,     2,     3,     1,
       0,     1,     2,     0,     2,     0,     1,     3,     0,     0,
       2,     0,     3,     0,     3,     0,     3,     3,     1,     0,
       4,     6,     6,     6,     7,     6,     7,     5,     0,     2,
       3,     2,     3,     3,     2,     3,     2,     2,     3,     3,
       5,     4,     4,     2,     3,     3,     4,     4,     4,     5,
       5,     4,     3,     4,     4,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     2,     2,     3,
       3,     4,     0,     3,     0,     3,     0,     3,     2,     3,
       3,     5,     5,     3,     2,     3,     3,     1,     2,     4,
       3,     3,     3,     2,     2,     2,     2,     2,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     1,     2,     2,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    73,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   378,     0,     0,
     754,   755,   756,   757,   758,   759,   760,   761,   762,   763,
     764,   765,   766,   767,   768,   769,   770,   771,   772,   773,
     774,   775,   776,   777,   778,   779,   780,   781,   782,   783,
     784,   785,   786,   787,   788,   789,   790,   791,   792,   793,
     794,   795,   796,   797,   798,   799,     3,     1,     2,     0,
       0,     0,     0,     0,     0,     0,   109,   110,     0,     0,
       0,     0,   378,     0,   739,   740,   741,   742,   743,   111,
     111,   744,   745,   746,   747,   107,   748,     0,   750,   111,
     114,   751,   752,   753,   111,   803,   111,   114,   111,   114,
     111,   114,   111,   114,   111,   114,     5,   749,   114,   114,
     263,   265,   264,     0,    74,    73,     0,     0,    73,    75,
      72,     0,     0,     0,     0,     0,     0,   262,   235,   267,
       0,   219,     0,     0,   202,   227,     0,   198,   198,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   361,   365,
     374,   371,   305,   380,   368,     0,     0,   364,   378,   410,
       0,     0,     0,   366,   367,     0,     0,     0,   378,     0,
     369,   370,   375,   408,   409,     0,   407,     0,   250,   249,
       0,   252,     0,     0,    32,    31,    37,    40,    38,     0,
       0,     0,    59,    58,    57,    56,     0,     0,     0,   101,
       0,   269,     0,    94,     0,     0,   271,   297,   112,     0,
       0,   105,    78,    84,   156,   488,   458,   543,   677,   683,
     718,     0,     0,     0,     0,     0,    18,   160,     0,     0,
       0,     0,     0,   802,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,    18,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,   804,     0,     0,     0,    18,     0,
       0,    18,     0,   805,   546,     0,     0,   553,     0,     0,
       0,   806,     0,     0,     0,     0,   716,     0,     0,     0,
       0,     0,     0,     0,   807,     0,     0,   181,   185,     0,
       0,     0,     0,   808,     0,     0,     0,     0,    18,     0,
      18,     0,     0,   800,     0,     0,     0,     0,    34,   801,
       0,     0,   163,   162,     0,     0,    75,    69,    70,     0,
      76,     0,   256,   254,     0,     0,   257,   174,   173,     0,
       0,     0,     0,   266,   268,   267,     0,   199,     0,   223,
     194,   193,     0,     0,   198,   197,   198,   198,   668,   198,
     198,     0,     0,    19,    20,     0,     0,     0,   245,   246,
     242,   240,   241,   243,   244,   361,   380,   361,   378,   361,
     361,     0,   353,     0,   378,     0,     0,     0,   364,   364,
       0,   405,   378,   378,   378,   378,   378,     0,   324,   325,
       0,   327,     0,     0,   306,   309,   307,   311,   378,   308,
     333,   331,   332,   339,     0,   344,   348,     0,   821,   816,
     817,   818,   819,   381,   820,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   823,   826,   825,   822,   824,   827,
     828,   829,   832,   830,   831,   833,   834,   835,   836,   837,
     838,   411,   412,   247,   378,   378,   378,   378,   378,   378,
     378,   378,   378,   378,   378,   378,   378,     0,    45,    46,
      47,    48,    49,    50,    51,    52,    53,     0,    43,   253,
       0,   255,   378,     0,    39,    41,     0,     0,   140,     7,
       9,   378,   141,    60,     0,     0,    66,     0,   102,   103,
      90,    91,    92,   152,     0,   286,   104,     0,     0,    55,
       0,     0,   809,   813,     0,   157,   117,   139,   125,     0,
     115,    14,    16,    15,    17,    13,   116,   142,   130,   286,
     131,     0,     0,   378,   119,   129,     0,   120,     0,   127,
     118,   158,   159,   463,   489,     0,     0,    18,   501,     0,
       0,     0,     0,    18,     0,    18,     0,     0,   502,     0,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,    18,     0,    18,     0,    18,
       0,    18,     0,     0,    18,    18,    18,     0,     0,   490,
     544,   554,   547,    18,   552,   549,    18,   545,   556,   678,
       0,     0,     0,   679,   684,     0,     0,   142,     0,   186,
     182,   699,   697,   698,     0,     0,     0,     0,     0,     0,
       0,   685,   692,   187,   719,    18,   724,     0,   720,   734,
       0,   733,     0,   737,     0,   735,   736,   723,     0,    79,
       0,    81,    18,    18,   811,   812,   810,     0,    33,     0,
     815,   814,   168,   167,   169,   171,   172,   170,     0,   165,
     260,     0,    71,    77,    67,   258,   259,   178,   179,     0,
     176,   261,   236,   239,     0,   195,   200,   218,     0,   225,
     224,     0,     0,   201,   208,     0,     0,   216,   286,   210,
     209,   213,   214,     0,   215,   217,   203,     0,   207,   226,
     234,   228,   231,   232,   230,   233,   229,     0,   659,   659,
       0,   198,   659,   198,   659,   660,   738,     0,     0,    25,
       0,     0,   357,   358,     0,   359,   360,   355,   343,   438,
     441,     0,   418,     0,   419,   362,   363,   356,     0,     0,
       0,     0,     0,     0,   326,   378,   391,   378,   320,   318,
       0,     0,   317,     0,     0,   372,   345,   346,     0,     0,
     373,   403,   401,   399,   396,   397,   398,   400,   402,   404,
     392,   393,   394,   395,   413,     0,   414,   416,   417,   251,
       0,   248,     0,    36,     0,    35,     0,     0,    62,    63,
      64,    65,     0,   142,     0,    88,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,     0,     0,
       0,   270,   290,     0,    98,    99,     0,    93,    95,    54,
       0,   286,   113,     0,   108,   126,   146,   149,   161,   291,
     292,   128,   138,   132,   122,    18,   293,   123,   121,   114,
       0,     0,     0,     0,     0,    18,   527,   529,     0,     0,
       0,     0,    18,     0,     0,   542,   503,     0,    23,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   495,     0,   496,     0,   525,     0,     0,     0,     0,
       0,     0,     0,   509,   510,     0,     0,     0,   531,     0,
     548,     0,   551,     0,     0,   681,   682,   687,     0,   714,
     696,     0,     0,   691,   686,   688,     0,   694,   695,   693,
       0,     0,     0,     0,     0,     0,   730,    21,   732,     0,
     727,   731,    87,    80,    82,    83,    85,    27,    26,    86,
     164,     0,    68,   175,     0,   196,   222,   221,   220,   205,
     212,   206,   204,   211,   487,   658,     0,     0,   667,   676,
       0,   674,     0,     0,   671,   669,     0,   659,     0,   659,
       0,    28,    29,     0,     0,   354,   378,   427,     0,   378,
     378,   378,   406,   378,   425,   378,     0,     0,   378,   378,
     378,   310,   305,   378,   334,   340,     0,     0,   349,   378,
      44,     6,    42,     8,    61,   100,   153,    89,   285,   284,
     286,   378,    97,    96,   295,   288,     0,   298,     0,   147,
       0,   142,     0,   137,   124,   466,   466,     0,   465,   459,
       0,     0,     0,     0,   538,   537,     0,   528,   532,   533,
     534,     0,   524,   518,    22,     0,     0,   491,     0,   497,
       0,   500,     0,   505,   504,   517,   516,   511,     0,     0,
     526,   514,   506,   507,   508,   530,   540,   513,   512,   541,
     515,   535,     0,   550,   648,    18,     0,    18,   567,     0,
       0,   569,   559,    18,   555,     0,   573,   649,   680,   690,
     712,   717,   180,   182,   689,     0,     0,     0,     0,     0,
     184,   721,   722,   729,    21,     0,   728,   166,   177,   662,
     661,   675,   670,   672,   673,     0,   663,     0,   665,     0,
       0,   439,   420,     0,     0,     0,     0,     0,   378,   376,
     319,   317,     0,     0,   323,     0,     0,     0,   287,     0,
     431,     0,   432,   433,     0,   378,   429,   430,   428,   378,
     378,     0,   378,     0,     0,   378,   301,     0,   294,     0,
     143,   144,   148,   150,   135,   133,   134,   136,   142,   460,
     475,   461,   479,   462,   464,     0,   520,   539,   522,   523,
      24,     0,   492,   499,   498,   519,   494,   536,   142,   572,
     560,     0,     0,    18,     0,   558,     0,     0,   576,   571,
     575,     0,     0,   565,   557,     0,   583,   705,   183,   187,
      30,     0,     0,     0,     0,   725,   726,   664,   666,   235,
     235,   424,   422,   423,   421,   378,     0,   321,   378,     0,
     415,   378,   378,   378,   378,     0,     0,     0,   296,   302,
       0,     0,   451,   434,   436,     0,   289,     0,   145,   151,
     475,   473,   478,     0,     0,   482,     0,     0,   651,   655,
     562,   563,   561,   564,   636,   597,   577,   636,   566,   650,
     584,     0,     0,     0,     0,   715,     0,   192,   187,   187,
     187,   187,     0,     0,     0,   377,     0,     0,     0,   347,
       0,     0,     0,     0,   445,   378,   350,   378,   378,     0,
     378,   450,     0,   477,     0,   480,   481,     0,   484,   521,
     493,   649,   653,   657,     0,     0,     0,   586,     0,     0,
       0,   708,   706,    18,   700,   701,   702,   703,   704,   707,
     713,   188,   189,   190,   191,   237,   238,   426,   378,   330,
     378,   328,   444,   379,   448,     0,   378,   442,   303,     0,
       0,     0,     0,     0,     0,     0,     0,   437,     0,    18,
       0,     0,     0,     0,   476,     0,   483,    18,   486,   652,
       0,   568,   639,   637,   640,    18,     0,    18,   574,     0,
     570,     0,     0,     0,     0,     0,     0,   582,   596,     0,
     154,   155,   709,     0,   710,     0,     0,     0,     0,   378,
     378,   312,   316,   314,   378,   452,   315,   337,   335,   336,
     341,     0,   447,   446,   378,   378,   378,   378,   453,   106,
     472,     0,     0,     0,     0,   467,   471,   474,   485,     0,
       0,     0,    18,     0,     0,     0,    18,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   656,   635,     0,   641,     0,     0,   580,   581,   579,
     578,   590,   588,   587,     0,     0,   591,   593,   594,   595,
     585,   711,   378,   329,   449,   304,   443,   352,   317,     0,
     378,     0,     0,     0,     0,     0,     0,     0,     0,    10,
      11,    12,    18,   602,   643,   633,     0,     0,     0,   628,
      18,   634,   618,   598,   601,   599,     0,   616,     0,   603,
     605,   606,   607,   608,   609,   610,   611,   612,    18,   622,
     623,   624,    18,   600,     0,    18,   654,   642,   638,   589,
     592,     0,   313,   378,   338,   351,   342,     0,     0,     0,
       0,   468,   469,   470,   619,     0,   626,   625,   627,   629,
     630,     0,   631,   615,   604,   614,   617,   620,   613,   322,
       0,   457,   455,   456,   454,   645,   621,   644,   632,   646,
       0,   647
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    85,   545,  1435,   546,   385,   878,  1056,
     948,   949,   739,  1221,   198,   669,    86,   504,   199,   507,
     497,   498,    87,   206,   207,    88,    20,    21,    22,    23,
      24,    25,   129,   351,    89,   334,    90,   340,   335,    91,
     524,    92,   527,   838,    93,   519,    94,    95,   534,    96,
      97,   219,   244,   554,  1033,   854,   538,    98,   846,  1172,
    1030,   847,   848,  1260,   813,   814,  1331,    99,   100,   547,
     245,   345,   678,   679,   360,   689,   690,   316,   921,   317,
     318,   933,    26,    27,    28,    29,   381,    30,    31,    32,
     372,   717,    33,   369,   702,    34,   373,   362,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
     191,   500,    47,    48,    49,    50,    51,    52,    53,    54,
      55,   123,   366,   101,   525,   102,   828,   829,   830,  1026,
     850,   851,   555,   841,   832,   103,   530,  1161,  1162,  1357,
     180,   430,  1417,   769,   770,   431,  1143,   771,   432,   433,
    1420,   434,  1421,   181,   436,   437,  1359,   400,   182,   401,
     410,   183,   184,   185,  1164,   186,   471,  1141,  1165,  1254,
    1255,   750,   751,  1166,   104,  1040,   859,   105,  1178,  1375,
    1314,  1262,  1179,  1181,  1265,  1318,  1378,  1183,    56,   106,
     107,   108,   109,   295,   296,   297,   913,  1095,  1206,  1211,
    1209,  1210,  1325,  1389,  1096,  1327,  1399,  1097,  1463,  1324,
    1383,  1384,  1466,  1555,  1580,  1577,  1198,  1216,  1269,  1321,
    1380,  1323,  1199,   966,    57,    58,    59,    60,    61,    62,
      63,    64,   730,   110,   111,   112,   113,   634,  1339,  1286,
    1217,  1101,   627,   628,   114,   115,   325,   940,   941,   326,
      65,   116,    66,   117,   118,   119,   472
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1224
static const yytype_int16 yypact[] =
{
     141,  2515,    80,   595,   459,   694,   190,   459,   459,   487,
     459,   214,   210,   679,   215,   230,   739,  1400,    51,   459,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   352,
     942,   192,   588,   305,   382,   345, -1224, -1224,   395,   362,
     325,   319,  1400,   436, -1224, -1224, -1224, -1224, -1224,   470,
     470, -1224, -1224, -1224, -1224,   106, -1224,  1252, -1224,   470,
    2203, -1224, -1224, -1224,   470, -1224,   470,  2274,   470,  2074,
     470,  2108,   470,  2005,   470,  2059, -1224, -1224,  2339,  2366,
   -1224, -1224, -1224,    85, -1224,   478,   505,   518,   478,   462,
   -1224,   550,   599,   459,   459,   623,   123, -1224,   511,   693,
      76, -1224,   631,   635, -1224, -1224,   424,   485,   644,   457,
     457,   667,   673,   688,   704,   718,   744,   750,    11, -1224,
   -1224, -1224,   668,   425, -1224,   547,    18,    16,  1400, -1224,
     438,   445,   464, -1224, -1224,   468,   491,   498,  1011,    55,
   -1224, -1224, -1224, -1224, -1224,  1984, -1224,  2666, -1224, -1224,
    1191,   773,   897,   879, -1224, -1224,   842, -1224, -1224,   -12,
      85,   171, -1224, -1224, -1224, -1224,   477,   545,   776,   785,
     541, -1224,   900, -1224,   123,   560,  2691, -1224,   826,   570,
     571, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,   582,    85,   929,   874,   171,   774, -1224,   309,   529,
     858,   706,   123, -1224,   600,   606,   607,   615,   100,   893,
     620,   756,   706,   774,   895,   715,    82,   880,   774,    72,
     457,   375,   926,   782,   933,   786,   778,   330,   777,   779,
     533,   760,   759,   774,   761,   758,   768,   107,     0,   787,
     742,   752,   774,   799, -1224,   676,   675,   567,   774,   958,
     171,   774,   724, -1224, -1224,   690,   687, -1224,   696,   972,
     456, -1224,   701,   698,   171,   982, -1224,   706,   705,   -30,
     171,   171,   993,  -163, -1224,   708,   710, -1224,   707,   709,
     766,   457,   992, -1224,   719,   527,   723,  1012,   774,  1022,
     774,  1020,  1019, -1224,   737,   740,   741,  1027,  1082, -1224,
     743,   746, -1224, -1224,   872,  1104,   462, -1224, -1224,  1106,
     171,  1107, -1224, -1224,  1108,  1109, -1224, -1224, -1224,   160,
    1111,  1097,  1114, -1224, -1224,   783,  1115, -1224,  1116,   551,
   -1224, -1224,  2398,  1137,   644, -1224,   644,   644, -1224,   387,
     427,  1133,  1136, -1224, -1224,    26,  1000,  1005, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224,    11, -1224,    11,  1400,    11,
      11,  1140, -1224,  1143,   714,  1129,   950,  1135,    16,    16,
    1142,  1146,  1400,  1400,  1400,  1400,  1400,  1153, -1224, -1224,
    1159, -1224,   809,    90, -1224, -1224, -1224, -1224,   815, -1224,
    1177, -1224, -1224, -1224,  -206,    27, -1224,   127, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224,  1400,  1400,  1400,  1400,  1400,  1400,
    1400,  1400,  1400,  1400,  1400,  1400,  1400,   988, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,   447, -1224, -1224,
    1182, -1224,  1400,   706, -1224, -1224,  1191,   829, -1224, -1224,
   -1224,  1400, -1224,   171,   757,   780, -1224,   171, -1224, -1224,
   -1224, -1224, -1224, -1224,   841,  2565, -1224,    94,   843, -1224,
     844,  1185, -1224, -1224,   -81, -1224, -1224, -1224, -1224,   567,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,  1300,
   -1224,   409,  1105,  1400, -1224, -1224,   409, -1224,   409, -1224,
   -1224, -1224, -1224, -1224, -1224,  1138,  1139,   664, -1224,  1163,
     854,   856,   171,   134,   966,   774,   457,   860, -1224,   869,
    1201,   171,  1089,   171,  1161,   171,  1173,    95,   171,   171,
     774,  1174,   887,  1165,   890,   774,   891,   774,    47,   774,
     929,   774,   892,   896,   774,   774,   774,   899,  1117, -1224,
   -1224, -1224, -1224,   774, -1224,  1166,   774, -1224, -1224, -1224,
    1246,   906,   907, -1224, -1224,   908,   171, -1224,   917, -1224,
    1175, -1224, -1224, -1224,   918,   919,   921,   171,   934,   937,
     938, -1224, -1224,    81, -1224,   774, -1224,   929, -1224, -1224,
     700, -1224,   457, -1224,  1058, -1224, -1224, -1224,   171, -1224,
     171, -1224,   774,   774, -1224, -1224, -1224,   171, -1224,   457,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   483, -1224,
   -1224,  1296, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   496,
   -1224, -1224, -1224, -1224,  1297, -1224, -1224, -1224,  1282, -1224,
   -1224,  1288,   457, -1224, -1224,  1285,  1286, -1224,  1300, -1224,
   -1224, -1224, -1224,   457, -1224, -1224, -1224,  1287, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,  1304,  1293,  1293,
    1030,   644,  1293,   644,  1293, -1224, -1224,   171,   457, -1224,
    1307,  1308, -1224, -1224,   753, -1224, -1224, -1224, -1224,   115,
   -1224,   946, -1224,  1298, -1224, -1224, -1224, -1224,   238,   263,
     288,   846,   515,   120, -1224,  1400, -1224,  1400, -1224,  1321,
     963,   964,   901,    66,    92, -1224, -1224, -1224,  1316,  1314,
   -1224,  1653,  1653,  1653,  2051,  2051,  1653,  1653,  1653,  1653,
     592,   592,  1146,  1146, -1224,   973, -1224, -1224, -1224, -1224,
    1191, -1224,  1877, -1224,   500, -1224,  1141,  1315, -1224, -1224,
   -1224, -1224,   978, -1224,   979, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   109,   980,
     981, -1224, -1224,   171, -1224, -1224,   457, -1224, -1224, -1224,
     955,  2565, -1224,   457, -1224, -1224,  1317, -1224,   997, -1224,
   -1224, -1224, -1224,  1247, -1224,   774,  2691, -1224, -1224,   862,
     171,   171,   171,   987,  1007,   774, -1224, -1224,  1013,  1014,
    1016,  1017,   774,  1021,  1023, -1224, -1224,  1346,  1330,  1024,
     171,  1026,   171,  1033,   171,  1034,  1035,  1042,  1044,  1051,
     171, -1224,   567, -1224,  1052, -1224,  1054,  1061,  1063,  1064,
    1065,  1070,  1077, -1224, -1224,  1078,  1079,  1083, -1224,   131,
   -1224,   171, -1224,  1936,  1084, -1224, -1224, -1224,  1085,    -6,
   -1224,  1090,  1094, -1224, -1224, -1224,  1098, -1224, -1224, -1224,
     171,   544,   579,  1096,  1102,  1120, -1224,  1201, -1224,   457,
    1060,  1058, -1224, -1224, -1224, -1224, -1224,    26, -1224, -1224,
   -1224,   872, -1224, -1224,   160, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224,  1439,  1463, -1224, -1224,
     567, -1224,   567,  1459, -1224, -1224,   567,  1293,  1478,  1293,
    1479, -1224, -1224,  1340,  1343, -1224,  1400, -1224,  1461,  1400,
    1400,  1400, -1224,  1400, -1224,  1400,   540,  1424,  1400,  1256,
    1400, -1224, -1224,  1400, -1224, -1224,  1123,   668, -1224,  1400,
   -1224, -1224, -1224, -1224, -1224, -1224,   997, -1224, -1224, -1224,
    2565,   350, -1224, -1224, -1224,  1130,  1144, -1224,  1350, -1224,
     749, -1224,   721, -1224, -1224, -1224, -1224,   457, -1224, -1224,
    1132,  1134,  1145,  1147, -1224, -1224,  1156, -1224, -1224, -1224,
   -1224,  1157, -1224, -1224, -1224,   171,  1356, -1224,  1164, -1224,
    1167, -1224,  1168, -1224, -1224, -1224, -1224, -1224,  1169,  1171,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224,  1172, -1224, -1224,   774,   258,   222, -1224,  1189,
     457, -1224, -1224,   542, -1224,  1178, -1224,  1176, -1224, -1224,
   -1224, -1224, -1224,  1175, -1224,  1180,  1482,  1482,  1482,  1482,
   -1224, -1224, -1224, -1224,  1201,   171,  1060, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224,  1520, -1224,  1522, -1224,  1518,
    1519, -1224, -1224,  1486,  1536,  1587,  1617,   585,  1400, -1224,
   -1224,  2691,  1179,  1186,  2691,   901,  1527,  1642, -1224,     7,
   -1224,  1513, -1224, -1224,  1190,  1400, -1224, -1224, -1224,  1400,
    1400,  1188,    19,  1984,  1194,  1335, -1224,  2565, -1224,  1540,
     457, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
    1202, -1224,    22, -1224, -1224,   171, -1224, -1224, -1224, -1224,
   -1224,   171, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,   171,   171,   774,   171, -1224,  1203,   567, -1224, -1224,
    1205,  1206,   171, -1224, -1224,   171,  1207,   401, -1224,    81,
   -1224,  1212,  1214,  1215,  1217, -1224, -1224, -1224, -1224,   511,
     511, -1224, -1224, -1224, -1224,  1400,  1682,  1530,  1372,  1213,
   -1224,  1400,   714,  1400, -1224,  1902,  2547,   633, -1224, -1224,
    1557,   451, -1224,  2691,  1216,  1221, -1224,  1440, -1224,   997,
    1202, -1224, -1224,  1567,   706,  1367,  1229,  1230,   997,  1227,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,    38,   171,  1322,   358, -1224,  1233, -1224,    81,    81,
      81,    81,  1597,  1599,  1719, -1224,  1242,  1243,    15, -1224,
    1928,  1244,  1958,  2033, -1224,   925, -1224,  1400,  1400,   727,
    1335, -1224,  1603, -1224,    -2, -1224, -1224,   457,  1402, -1224,
   -1224,  1176, -1224, -1224,     5,    75,    25,   755,   171,   171,
     171, -1224, -1224,   287, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,  1400, -1224,
    1400, -1224, -1224, -1224, -1224,  1259,   350,  1441, -1224,    60,
    1983,  2008,  1261,  1269,  1294,  1295,  1299, -1224,  1312,   774,
     665,  1432,   171,   171, -1224,  1313, -1224,   774, -1224, -1224,
    2320, -1224, -1224, -1224,   -67,   774,   171,   774, -1224,  1323,
   -1224,   171,   171,   171,  1412,    77,   -27, -1224, -1224,  1324,
   -1224, -1224, -1224,  1344, -1224,  1292,  1325,  1326,  1332,   925,
      43, -1224, -1224, -1224,   815, -1224, -1224,  1681, -1224, -1224,
   -1224,   270, -1224, -1224,  1400,  1400,  1400,  1400, -1224, -1224,
   -1224,  1444,  1473,  1483,   798, -1224, -1224, -1224, -1224,  1386,
     171,  1337,   774,  1388,   143,  1428,   774,   774,   171,   171,
     171,  1476,   171,   213,  1336,  1383,   -26,  1418,   171,  1394,
    1422, -1224, -1224,  1358, -1224,   171,  1359, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224,   171,   171, -1224, -1224, -1224, -1224,
   -1224, -1224,  1400, -1224, -1224, -1224, -1224, -1224,  1747,   116,
      43,   139,  1772,  1797,  1827,  1852,   171,   171,   171, -1224,
   -1224, -1224,   774, -1224, -1224, -1224,    31,   171,   171, -1224,
     674, -1224, -1224, -1224, -1224, -1224,   171, -1224,   171, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   774, -1224,
   -1224, -1224,   774, -1224,   171,   774, -1224, -1224, -1224, -1224,
   -1224,  1360, -1224,  1400, -1224, -1224, -1224,  1361,  1363,  1364,
    1365, -1224, -1224, -1224, -1224,    23, -1224, -1224, -1224, -1224,
   -1224,  1407, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
    1747, -1224, -1224, -1224, -1224,  1419, -1224, -1224, -1224, -1224,
    1374, -1224
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1224, -1224, -1224, -1224,  -138,  -558,  -240,  -233,  -789, -1224,
    -147,  -698, -1224,  -120,   -77, -1224, -1224, -1224, -1224, -1224,
    1226,   935, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224,   549,  1390, -1224, -1224, -1224, -1224, -1224, -1224,
    -286, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,  2284,   -99,  1498, -1224,   216,  -346, -1224, -1224, -1224,
   -1224,   722,  -618, -1224, -1224, -1224,   294, -1224, -1224, -1224,
   -1224,   154, -1224,   788,    10, -1224,   795, -1149,   647,  -619,
   -1224,  -702, -1224, -1224, -1224, -1224,  -141, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,  -342, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224,  1048,  1387, -1224, -1224, -1224, -1224,  -793,   734,   593,
    1237,  1055,  1392, -1224,   924, -1224, -1224, -1197, -1224,   357,
    -173,   994,   289,  -981,   789, -1223, -1134,  1607, -1162,  1003,
     296, -1224, -1224,  -174,  1010, -1224, -1224, -1224, -1224,   269,
     488, -1224, -1224, -1000, -1224,   -55,   627,   -17, -1224, -1224,
     481,   806,   561, -1105, -1224, -1224, -1224, -1224,   775, -1224,
   -1224,   552, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,   516,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,   489, -1224, -1224,
   -1224, -1224, -1224,  -538, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1224,   861, -1224, -1224,
   -1224, -1224, -1224, -1224, -1224, -1224, -1069
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -441
static const yytype_int16 yytable[] =
{
     187,   611,   386,   387,   215,   435,   429,   382,   285,   919,
     294,   922,   302,   571,   315,   962,   324,  1140,   577,   336,
     341,  1163,  1350,   383,   384,  -300,   395,   580,   582,  1241,
     396,   408,   505,   596,  -300,  -300,  -300,  -300,  1149,   397,
     843,  1575,   607,   383,   384,   406,   509,  1025,   612,  -299,
     510,   615,  1263,   776,   777,   737,   638,  1249,  -299,  -299,
    -299,  -299,  1149,   512,   631,   216,  1410,  1477,  1529,  1150,
     424,   425,   426,   162,   427,  1411,  1412,  1413,  1002,   367,
      67,   424,   425,   426,  1002,   427,   188,   509,   659,   602,
     661,   510,   509,  1150,  1251,   189,   510,   540,   474,   475,
     476,   477,   478,   402,  1298,  1369,  1151,   424,   425,   426,
    1002,   427,   479,   480,   481,   482,   483,   484,   485,   486,
     342,   579,   487,   474,   475,   476,   477,   478,  1018,   343,
    1151,  1411,  1412,  1413,  1002,   833,  1418,   479,   480,   481,
     482,   483,   484,   485,   486,     1,   509,   487,  1113,   509,
     510,   411,   614,   510,  1411,  1412,  1413,  1002,   357,  1408,
     774,   423,  1163,   775,   559,   930,   625,   358,   541,   542,
     543,   544,   635,   636,   646,   570,  1328,  1329,  1398,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,   509,   600,   639,   640,
     510,   967,  1475,   130,   978,  1016,   980,  1419,   885,  1159,
    1358,   931,  1160,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
    1370,  1371,   683,  1487,  1372,  1373,  1406,   137,   834,   835,
     836,  1385,   368,  1159,   528,   716,  1160,   407,   509,   574,
     629,  1462,   510,   727,  1355,   728,   729,   509,   732,   734,
     565,   510,  1264,  1464,  1303,   932,   474,   475,   476,   477,
     478,  1465,   560,   845,   901,   687,   541,   542,   543,   544,
     479,   480,   481,   482,   483,   484,   485,   486,  1418,   603,
     487,   474,   475,   476,   477,   478,  1478,  1530,   897,  1479,
    1531,  1328,  1329,  1019,   844,   479,   480,   481,   482,   483,
     484,   485,   486,  1545,   688,   487,   474,   475,   476,   477,
     478,   935,   509,   200,  1358,  1163,   510,   898,   899,   201,
     479,   480,   481,   482,   483,   484,   485,   486,   632,   633,
     487,   541,   542,   543,   544,  1225,   886,   864,  1518,  1419,
    1330,   138,  1171,   871,   575,   873,   149,   566,   194,   195,
     402,   601,   402,   874,   402,   402,  1556,  1557,   869,   870,
     889,   150,   506,   548,   508,   894,  1163,   896,  1100,   900,
    1031,   902,  1386,  1374,   905,   906,   907,  1405,  1242,  1149,
    1381,   193,   398,   910,  1025,   807,   912,  1351,   399,   812,
    -300,   744,   208,   409,  -300,  1387,   536,   749,  1576,   738,
    1390,   778,   511,   383,   384,   758,   759,   760,   761,   762,
    1150,   209,   549,   550,  -299,   934,   375,   551,  -299,  1163,
    1163,   772,   552,   853,   211,   190,   428,   937,   853,   938,
     853,  1414,   944,   945,   509,  1415,   803,  1003,   510,   210,
     214,   731,   578,   511,   868,  1507,   947,  1151,   511,  1125,
    1388,  1127,   212,   879,   852,   881,   375,   883,   213,   344,
     887,   888,   766,   428,   837,   217,   767,   781,   782,   783,
     784,   785,   786,   787,   788,   789,   790,   791,   792,   793,
     221,   733,  1258,  1308,  1508,   383,   384,  1543,   120,   121,
     947,   986,   994,  1309,   922,   802,   995,   359,   918,   218,
    1163,  1081,   511,   779,   806,   511,   780,   513,   124,   926,
    1414,  1541,  1403,   122,   375,   982,   120,   121,   347,  1204,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,  1287,   581,   553,
     942,   348,   943,   474,   475,   476,   477,   478,   350,   946,
    1159,   122,   511,  1160,   514,   515,   856,   479,   480,   481,
     482,   483,   484,   485,   486,  1201,  1202,   487,   474,   475,
     476,   477,   478,   352,   697,   958,   520,   509,   521,   522,
    1259,   510,   479,   480,   481,   482,   483,   484,   485,   486,
     588,   589,   487,   548,   511,   376,   541,   542,   543,   544,
    1268,  1203,   520,   511,   521,   522,  1341,  1342,  1343,  1344,
     977,   361,   979,   474,   475,   476,   477,   478,    68,   981,
     429,   429,   353,  1023,   989,   435,  1069,   479,   480,   481,
     482,   483,   484,   485,   486,  1034,  1281,   487,   133,   134,
     485,   486,   549,   550,   487,  1046,   356,   556,    69,   990,
     202,   698,  1051,  1490,   370,  1282,  1491,    70,   371,   377,
      71,   474,   475,   476,   477,   478,   374,   523,   511,   203,
    1106,    72,  1107,  1334,   991,   479,   480,   481,   482,   483,
     484,   485,   486,   375,   742,   487,   743,   699,   745,   746,
     388,    73,  1283,   204,   346,    74,   389,   349,    75,   509,
      76,    77,   700,   510,  1121,  1108,  1122,  1109,    78,   509,
    1124,   390,   649,   510,   701,  1022,  1028,   403,   541,   542,
     543,   544,  1335,  1336,  1337,  1338,  1114,   391,   541,   542,
     543,   544,   363,   364,   124,  -299,    79,    80,   383,   384,
     936,   392,  1041,  1042,  1043,   194,   195,   158,    81,   159,
     160,   161,   162,   163,   164,   205,   862,   365,  1284,   553,
     165,   166,  1058,   167,  1060,   168,  1062,   393,   996,   125,
     997,    82,  1068,   394,    83,   650,   405,   126,   127,   128,
    1039,   474,   475,   476,   477,   478,  1285,   383,   384,  1170,
     511,  1082,   857,  1083,   858,   479,   480,   481,   482,   483,
     484,   485,   486,   592,   593,   487,   404,   651,   499,   509,
     139,   140,  1105,   510,   621,   622,   652,   947,  1174,   412,
     141,   169,   363,   364,  1182,   378,   413,   170,   541,   542,
     543,   544,   799,   800,   151,   142,   808,   809,   379,   380,
    1362,  1175,  1176,  1177,   143,   414,   144,   145,   158,   415,
     159,   160,   161,   162,   163,   164,  1499,  1500,  1501,   810,
     811,   165,   166,   768,   167,  1200,   168,  1205,   950,   951,
     152,   153,   416,  1213,   474,   475,   476,   477,   478,   417,
     307,   953,   954,   171,   172,  1012,   800,  1212,   479,   480,
     481,   482,   483,   484,   485,   486,  1363,  1364,   487,  1431,
    1432,   993,   308,   653,   654,   655,   656,  1292,  1293,  1561,
     146,   154,   155,   156,   157,  1391,   755,   756,   173,   174,
     501,   502,   169,   511,   503,   516,  1138,   232,   170,   474,
     475,   476,   477,   478,   518,   175,   517,  1190,   176,   526,
     529,  1275,   177,   479,   480,   481,   482,   483,   484,   485,
     486,  1365,   531,   487,   532,   533,  1366,   947,  1551,  1552,
    1553,   863,   233,  1208,  1149,   234,   535,   672,   537,   235,
     236,  1235,  1035,   238,   239,    84,   558,   147,   539,   240,
     561,   194,   195,  1272,   171,   172,   562,   673,   674,   749,
     567,   563,  1133,  1134,  1135,  1150,  1136,  1226,  1137,   564,
     568,   675,   676,  1144,   677,   196,  1145,  1222,  1223,  1224,
     241,   573,  1147,   572,   569,   242,   197,  1306,   583,   173,
     174,   418,   419,   420,   421,   585,   576,   584,   587,   586,
     594,   590,  1151,   595,   605,   591,   175,   598,   597,   176,
     608,   604,   606,   177,   158,   511,   159,   160,   161,   162,
     163,   164,   599,   968,   148,   511,   609,   165,   166,   610,
     167,   613,   168,   616,  1392,  1393,  1394,  1266,  1395,   969,
     617,   618,   620,  1267,   626,   131,   132,   135,   136,  1396,
     619,   623,   624,  1270,  1271,   637,  1273,   192,   641,   630,
     642,   643,   647,   644,  1278,   178,  -440,  1279,   645,   648,
    1036,  1037,   179,   657,  1376,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,   658,  1404,   660,   662,   663,   664,   169,   667,
     665,   666,   668,   670,   170,  1159,   671,   680,  1160,   682,
     684,   685,   686,   970,   691,   985,   692,   693,   695,   696,
    1397,  1236,   816,   817,   818,   819,   820,   821,   822,  1430,
     823,   824,   825,   826,   827,   511,   735,  1438,  1245,   736,
     719,   740,  1246,  1247,  1332,  1467,   741,  1469,  1253,   474,
     475,   476,   477,   478,   747,   752,   720,   794,   748,   753,
     171,   172,   754,   479,   480,   481,   482,   483,   484,   485,
     486,   757,   763,   487,   764,   765,   178,  1382,   487,  1382,
     795,   354,   355,   179,   773,   801,  1416,  1316,   796,   805,
    1400,  1401,  1402,   797,   798,   173,   174,   418,   419,   420,
     421,   815,  1505,   839,   842,   840,  1511,  1512,   992,   855,
     860,   861,   175,   865,   866,   176,   867,   721,  1294,   177,
     875,  1144,   722,   723,  1300,   749,  1302,  1038,   872,   876,
     724,   877,   880,   882,  1434,  1436,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   884,   890,   891,  1468,   892,
     893,   895,   903,  1471,  1472,  1473,   904,  1476,   725,   908,
     909,   971,  1554,  1001,   911,   914,   915,   916,   917,   158,
    1562,   159,   160,   161,   162,   163,   164,   920,   923,   924,
     307,   925,   165,   166,   768,   167,   939,   168,  1565,  1356,
    1360,  1361,  1566,  1253,   927,  1568,   726,   928,   929,   952,
     955,   956,  1503,   957,   959,   960,   963,   964,   987,   972,
    1513,  1514,  1515,   965,  1517,  1519,  1416,  1024,  1416,   849,
    1533,   222,   983,   984,   973,   988,   223,  1537,   998,   999,
    1000,  1006,  1007,  1144,  1009,  1014,  1539,  1540,  1015,  1017,
    1020,   224,   974,   169,  1029,  1021,  1032,  1044,   158,   170,
     159,   160,   161,   162,   163,   164,   975,   976,  1434,  1434,
    1434,   165,   166,  1031,   167,  1054,   168,  1045,  1558,  1559,
    1560,  1055,   178,  1047,  1048,   225,  1049,  1050,  1563,   179,
    1564,  1052,  1115,  1053,  1057,   158,  1059,   159,   160,   161,
     162,   163,   164,  1061,  1063,  1064,  1567,  1488,   165,   166,
    1297,   167,  1065,   168,  1066,   171,   172,  1492,  1493,  1494,
    1495,  1067,  1070,   158,  1071,   159,   160,   161,   162,   163,
     164,  1072,   169,  1073,  1074,  1075,   165,   166,   170,   167,
    1076,   168,   474,   475,   476,   477,   478,  1077,  1078,  1079,
     173,   174,  1119,  1080,  1098,  1099,   479,   480,   481,   482,
     483,   484,   485,   486,  1103,  1102,   487,   175,  1104,   169,
     176,  1110,  1111,   226,   177,   170,  1120,   816,   817,   818,
     819,   820,   821,   822,  1123,   823,   824,   825,   826,   827,
    1112,  1126,  1128,  1129,   171,   172,  1130,   169,  1132,  1146,
    1167,  1169,  1184,   170,   474,   475,   476,   477,   478,  1191,
    1185,  1207,  1220,  1013,  1215,  1186,  1168,  1187,   479,   480,
     481,   482,   483,   484,   485,   486,  1188,  1189,   487,   173,
     174,   171,   172,  1227,  1192,  1228,  1570,  1193,  1194,  1195,
     227,  1196,  1197,  1229,  1230,  1243,   175,  1296,  1214,   176,
    1219,  1237,  1239,   177,   474,   475,   476,   477,   478,   171,
     172,  1244,  1238,  1248,  1252,  1257,   173,   174,   479,   480,
     481,   482,   483,   484,   485,   486,  1261,  1274,   487,  1276,
    1277,  1280,  1288,   175,  1289,  1290,   176,  1291,  1299,  1307,
     177,  1311,  1310,  1312,   173,   174,  1315,   228,  1317,  1319,
    1320,  1322,   229,  1340,  1333,   474,   475,   476,   477,   478,
    1345,   175,  1346,  1348,   176,  1349,  1353,   230,   177,   479,
     480,   481,   482,   483,   484,   485,   486,   178,  1368,   487,
    1377,  1407,  1424,  1409,   179,   474,   475,   476,   477,   478,
    1425,  1520,  1521,  1522,  1523,  1524,  1525,  1526,  1527,   479,
     480,   481,   482,   483,   484,   485,   486,  1433,  1474,   487,
     474,   475,   476,   477,   478,  1426,  1427,  1481,  1482,  1428,
    1496,  -441,  -441,  -441,   479,   480,   481,   482,   483,   484,
     485,   486,  1429,  1437,   487,  -441,  -441,  -441,  -441,   483,
     484,   485,   486,  1470,  1480,   487,  1484,  1483,  1489,  1497,
     474,   475,   476,   477,   478,  -435,   178,  1485,  1502,  1498,
    1510,  1504,  1506,   179,   479,   480,   481,   482,   483,   484,
     485,   486,  1516,  1528,   487,  1532,  1534,  1535,  1536,  1538,
    1578,  1571,  1569,  1572,  1573,  1574,  1579,   474,   475,   476,
     477,   478,   804,   178,  1581,  1010,   681,   557,  1509,  1117,
     179,   479,   480,   481,   482,   483,   484,   485,   486,  1118,
    1218,   487,   694,  1173,  1148,   474,   475,   476,   477,   478,
    1256,   178,   831,   961,   718,  1027,  1486,  1004,   179,   479,
     480,   481,   482,   483,   484,   485,   486,  1005,  1544,   487,
     474,   475,   476,   477,   478,   422,  1139,  1546,  1142,  1008,
    1250,  1367,  1131,  1326,   479,   480,   481,   482,   483,   484,
     485,   486,  1116,  1301,   487,   474,   475,   476,   477,   478,
    1379,  1180,  1313,     0,     0,     0,     0,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,     0,     0,   487,
       0,     0,     0,     0,     0,   474,   475,   476,   477,   478,
       0,     0,     0,     0,     0,     0,     0,     0,  1231,   479,
     480,   481,   482,   483,   484,   485,   486,     0,     0,   487,
     474,   475,   476,   477,   478,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,     0,   487,   474,   475,   476,   477,   478,
       0,     0,     0,     0,     0,     0,     0,     0,  1232,   479,
     480,   481,   482,   483,   484,   485,   486,     0,     0,   487,
     474,   475,   476,   477,   478,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,     0,     0,   487,     0,   474,   475,   476,   477,
     478,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
     479,   480,   481,   482,   483,   484,   485,   486,     0,     0,
     487,     0,     0,     0,     0,     0,   474,   475,   476,   477,
     478,     0,     0,     0,     0,     0,     0,     0,     0,  1234,
     479,   480,   481,   482,   483,   484,   485,   486,     0,   438,
     487,   474,   475,   476,   477,   478,     0,     0,     0,     0,
       0,     0,     0,     0,  1240,   479,   480,   481,   482,   483,
     484,   485,   486,     0,     0,   487,   474,   475,   476,   477,
     478,     0,     0,     0,     0,     0,  1084,     0,     0,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   438,     0,
     487,     0,     0,     0,  1295,     0,   304,     0,     0,     0,
     232,     0,     0,     0,     0,     0,     0,     0,     0,   474,
     475,   476,   439,   440,     0,   441,   442,     0,     0,     0,
       0,   305,     0,   479,   480,   481,   482,   483,   484,   485,
     486,  1347,  1085,   487,     0,   233,     0,     0,   234,     0,
     443,     0,   235,   236,     0,   306,   238,   239,     0,     0,
       0,     0,   240,     0,   232,     0,     0,     0,     0,  1542,
     307,   439,   440,     0,   441,   442,     0,     0,     0,   232,
       0,   444,     0,     0,   320,     0,     0,     0,     0,     0,
       0,     0,   308,   241,  1547,     0,     0,     0,   242,   233,
       0,     0,   234,     0,     0,     0,   235,   236,     0,     0,
     238,   239,     0,   232,   233,     0,   240,   234,     0,  1548,
       0,   235,   236,     0,     0,   238,   239,     0,  1086,     0,
     444,   240,     0,     0,   445,   446,     0,   447,   448,   449,
     450,   451,   452,   453,     0,     0,     0,   241,   233,  1549,
       0,   234,   242,     0,     0,   235,   236,     0,     0,   238,
     239,     0,   241,     0,     0,   240,   321,   242,     0,     0,
       0,     0,     0,     0,  1550,     0,     0,     0,     0,     0,
       0,  1087,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,     0,     0,     0,     0,   241,  1011,     0,     0,
       0,   242,     0,     0,     0,  1088,     0,  1089,   232,   463,
     464,     0,     0,  1090,     0,  1091,     0,     0,     0,  1092,
    1093,     0,  1304,     0,   465,   466,   467,   468,     0,     0,
       0,     0,   454,   455,   456,   457,   458,   459,   460,   461,
     462,     0,     0,   233,     0,     0,   234,     0,  1352,     0,
     235,   236,     0,   237,   238,   239,     0,     0,   463,   464,
     240,  1094,     0,     0,     0,     0,     0,     0,     0,   309,
       0,     0,     0,   465,   466,   467,   468,     0,  1354,   232,
       0,     0,     0,     0,   248,     0,   322,     0,     0,     0,
       0,   241,     0,     0,     0,     0,   242,   469,   470,     0,
       0,     0,     0,  1422,     0,     0,   310,   311,   312,     0,
     249,     0,     0,   287,   233,   313,     0,   234,   288,   289,
     290,   235,   236,   250,     0,   238,   239,     0,  1423,     0,
     314,   240,     0,     0,   220,     0,   251,     0,     0,   252,
       0,   253,     0,   231,   232,  1439,   469,   470,   246,     0,
     247,     0,   286,     0,   298,   291,   303,     0,   319,     0,
       0,   703,   241,     0,     0,     0,   292,   242,   327,   328,
     329,   232,   330,   331,     0,   332,   383,   384,     0,   233,
       0,   254,   234,   255,   323,   307,   235,   236,     0,     0,
     238,   239,   256,     0,     0,     0,   240,   337,     0,   293,
       0,     0,   704,     0,   299,   300,   233,   308,     0,   234,
       0,     0,     0,   235,   236,     0,     0,   238,   239,     0,
    1440,     0,     0,   240,     0,     0,     0,   241,   257,     0,
       0,     0,   242,   301,  1441,     0,     0,     0,   705,   338,
       0,     0,     0,   706,     0,   258,     0,     0,     0,     0,
     707,   708,   259,   260,   241,   261,     0,   262,   263,   242,
     264,   265,   709,   266,     0,     0,   267,   268,     0,   269,
       0,   710,   711,   712,   713,     0,   714,   715,     0,     0,
       0,     0,   270,   271,     0,     0,     0,   272,     0,   273,
     274,  1442,   275,     0,  1443,  1444,     0,   276,     0,     0,
       0,   277,   278,     0,   279,   280,     0,   281,   282,   283,
       0,     0,     0,     0,     0,   474,   475,   476,   477,   478,
       4,     0,     0,     0,     0,     0,     0,     0,   243,   479,
     480,   481,   482,   483,   484,   485,   486,     0,     0,   487,
       0,     0,     5,     6,     0,     0,     0,     0,     0,     0,
       0,  1445,     7,     0,  1446,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1447,     0,  1448,   553,  1449,
    1450,  1451,  1452,  1453,  1454,     0,     0,     8,     0,     0,
    1455,     0,     0,     0,  1456,  1457,     0,     0,  1458,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   284,
       0,  1459,     0,     0,     0,     9,     0,     0,    10,  1460,
      11,     0,     0,     0,     0,     0,     0,    12,     0,    13,
       0,     0,     0,     0,    14,    15,    16,     0,     0,   473,
       0,    17,    18,    19,   474,   475,   476,   477,   478,     0,
       0,     0,     0,     0,     0,  1461,     0,     0,   479,   480,
     481,   482,   483,   484,   485,   486,     0,     0,   487,   474,
     475,   476,   477,   478,   333,     0,     0,     0,     0,     0,
       0,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,     0,     0,   487,     0,     0,     0,     0,  1305,     0,
       0,   339,   816,   817,   818,   819,   820,   821,   822,     0,
     823,   824,   825,   826,   827
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1224)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-441)))

static const yytype_int16 yycheck[] =
{
      17,   287,   149,   150,    81,   179,   179,   148,   107,   627,
     109,   630,   111,   253,   113,   713,   115,   998,   258,   118,
     119,  1021,     7,    18,    19,     6,    15,   260,   261,    22,
      19,    15,    44,   273,    15,    16,    17,    18,    19,    28,
     121,    18,   282,    18,    19,    27,    15,   840,   288,     6,
      19,   291,    30,    26,    27,    29,   219,  1162,    15,    16,
      17,    18,    19,   201,    94,    82,     6,    94,    94,    50,
      15,    16,    17,    18,    19,    15,    16,    17,    18,     3,
       0,    15,    16,    17,    18,    19,    35,    15,   328,    89,
     330,    19,    15,    50,  1163,    44,    19,   235,     8,     9,
      10,    11,    12,   158,  1238,   107,    87,    15,    16,    17,
      18,    19,    22,    23,    24,    25,    26,    27,    28,    29,
      35,   259,    32,     8,     9,    10,    11,    12,    19,    44,
      87,    15,    16,    17,    18,    41,  1359,    22,    23,    24,
      25,    26,    27,    28,    29,     4,    15,    32,   937,    15,
      19,   168,   290,    19,    15,    16,    17,    18,    35,  1356,
     366,   178,  1162,   369,   241,    84,   304,    44,    34,    35,
      36,    37,   310,   311,   321,   252,   138,   139,  1327,   160,
     161,   162,   163,   164,   165,   166,    15,    80,   351,   352,
      19,   729,   115,     3,   732,   813,   734,  1359,   103,   180,
    1305,   120,   183,   160,   161,   162,   163,   164,   165,   166,
     212,   213,   350,  1410,   216,   217,  1350,     3,   124,   125,
     126,   146,   146,   180,   214,   372,   183,   209,    15,   147,
     307,  1380,    19,   374,  1303,   376,   377,    15,   379,   380,
     140,    19,   220,   310,  1244,   164,     8,     9,    10,    11,
      12,   318,   242,   539,   600,    95,    34,    35,    36,    37,
      22,    23,    24,    25,    26,    27,    28,    29,  1491,   269,
      32,     8,     9,    10,    11,    12,   303,   303,   231,   306,
     306,   138,   139,   174,   365,    22,    23,    24,    25,    26,
      27,    28,    29,  1490,   134,    32,     8,     9,    10,    11,
      12,   647,    15,   111,  1409,  1305,    19,   260,   261,   117,
      22,    23,    24,    25,    26,    27,    28,    29,   348,   349,
      32,    34,    35,    36,    37,  1114,   231,   567,   115,  1491,
     292,   121,  1030,   573,   252,   575,   121,   237,    19,    20,
     395,   234,   397,   576,   399,   400,   315,   316,   214,   215,
     590,   121,   364,    44,   200,   595,  1356,   597,   364,   599,
     366,   601,   287,   365,   604,   605,   606,  1348,   361,    19,
     365,    19,   361,   613,  1167,   513,   616,   362,   367,   517,
     361,   398,    77,   367,   365,   310,   232,   404,   365,   363,
     365,   364,   361,    18,    19,   412,   413,   414,   415,   416,
      50,    19,    93,    94,   361,   645,    19,    98,   365,  1409,
    1410,   428,   103,   551,    19,   364,   361,   650,   556,   652,
     558,   361,   662,   663,    15,   365,   503,   361,    19,    84,
     111,    44,   360,   361,   572,   292,   669,    87,   361,   977,
     365,   979,    80,   581,    35,   583,    19,   585,   123,   364,
     588,   589,   362,   361,   360,    19,   366,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     364,    44,  1170,    22,   331,    18,    19,   361,    19,    20,
     713,   366,   362,    32,  1103,   502,   366,   364,   626,    19,
    1490,   360,   361,   366,   511,   361,   369,    20,    20,   637,
     361,  1482,   215,    44,    19,   738,    19,    20,     3,   287,
     160,   161,   162,   163,   164,   165,   166,  1219,   143,   210,
     658,     3,   660,     8,     9,    10,    11,    12,    66,   667,
     180,    44,   361,   183,    57,    58,   553,    22,    23,    24,
      25,    26,    27,    28,    29,   287,   288,    32,     8,     9,
      10,    11,    12,     3,     3,   702,    15,    15,    17,    18,
    1178,    19,    22,    23,    24,    25,    26,    27,    28,    29,
     240,   241,    32,    44,   361,    90,    34,    35,    36,    37,
    1198,   323,    15,   361,    17,    18,  1288,  1289,  1290,  1291,
     731,    80,   733,     8,     9,    10,    11,    12,     3,   737,
     773,   774,     3,   836,   366,   779,   892,    22,    23,    24,
      25,    26,    27,    28,    29,   855,   215,    32,   131,   132,
      28,    29,    93,    94,    32,   865,     3,    98,    33,   366,
      42,    80,   872,   363,     3,   234,   366,    42,     3,   154,
      45,     8,     9,    10,    11,    12,   222,   106,   361,    61,
     106,    56,   108,   295,   366,    22,    23,    24,    25,    26,
      27,    28,    29,    19,   395,    32,   397,   116,   399,   400,
       3,    76,   271,    85,   125,    80,     3,   128,    83,    15,
      85,    86,   131,    19,   970,   106,   972,   108,    93,    15,
     976,     3,   165,    19,   143,   833,   843,    29,    34,    35,
      36,    37,   344,   345,   346,   347,   939,     3,    34,    35,
      36,    37,    19,    20,    20,   365,   121,   122,    18,    19,
      20,     3,   860,   861,   862,    19,    20,    13,   133,    15,
      16,    17,    18,    19,    20,   147,    72,    44,   337,   210,
      26,    27,   880,    29,   882,    31,   884,     3,   765,    55,
     767,   156,   890,     3,   159,   228,   209,    63,    64,    65,
     859,     8,     9,    10,    11,    12,   365,    18,    19,    20,
     361,   909,   556,   911,   558,    22,    23,    24,    25,    26,
      27,    28,    29,   250,   251,    32,   361,   260,    15,    15,
     111,   112,   930,    19,   338,   339,   269,  1030,    77,   361,
     121,    87,    19,    20,  1037,   320,   361,    93,    34,    35,
      36,    37,   365,   366,    75,   136,    59,    60,   333,   334,
      93,   100,   101,   102,   145,   361,   147,   148,    13,   361,
      15,    16,    17,    18,    19,    20,    38,    39,    40,    59,
      60,    26,    27,    28,    29,  1085,    31,  1087,   365,   366,
     111,   112,   361,  1093,     8,     9,    10,    11,    12,   361,
     105,   365,   366,   149,   150,   365,   366,   325,    22,    23,
      24,    25,    26,    27,    28,    29,   149,   150,    32,   214,
     215,   366,   127,   356,   357,   358,   359,  1229,  1230,   215,
     211,   152,   153,   154,   155,   140,   408,   409,   184,   185,
       3,    22,    87,   361,    62,   360,   366,    45,    93,     8,
       9,    10,    11,    12,   129,   201,   140,  1055,   204,    19,
     360,  1207,   208,    22,    23,    24,    25,    26,    27,    28,
      29,   204,   106,    32,   364,   364,   209,  1170,  1496,  1497,
    1498,   277,    80,  1090,    19,    83,   364,    75,    19,    87,
      88,   366,    90,    91,    92,   360,    98,   278,    84,    97,
     360,    19,    20,  1203,   149,   150,   360,    95,    96,   986,
      77,   364,   989,   990,   991,    50,   993,  1115,   995,   364,
     360,   109,   110,  1000,   112,    43,  1003,  1107,  1108,  1109,
     128,   276,  1009,    98,   238,   133,    54,   364,    72,   184,
     185,   186,   187,   188,   189,    72,   126,   225,   230,   223,
     250,   234,    87,   254,   272,   236,   201,   259,   257,   204,
     221,   234,   270,   208,    13,   361,    15,    16,    17,    18,
      19,    20,   264,     3,   355,   361,   360,    26,    27,   364,
      29,    83,    31,   319,   289,   290,   291,  1185,   293,    19,
     360,   364,    80,  1191,    72,     7,     8,     9,    10,   304,
     364,   360,   364,  1201,  1202,    72,  1204,    19,   360,   364,
     360,   364,    80,   364,  1212,   361,   362,  1215,   312,   360,
     218,   219,   368,   360,  1317,   160,   161,   162,   163,   164,
     165,   166,    80,  1333,    72,    75,    77,   360,    87,    72,
     360,   360,    20,   360,    93,   180,   360,     3,   183,     3,
       3,     3,     3,    83,     3,   362,    19,     3,     3,     3,
     365,  1138,   167,   168,   169,   170,   171,   172,   173,  1369,
     175,   176,   177,   178,   179,   361,     3,  1377,  1155,     3,
       3,   141,  1159,  1160,  1282,  1385,   141,  1387,  1165,     8,
       9,    10,    11,    12,    14,    26,    19,   169,    15,   209,
     149,   150,    27,    22,    23,    24,    25,    26,    27,    28,
      29,    29,    19,    32,    15,   366,   361,  1324,    32,  1326,
     192,   133,   134,   368,     7,     3,  1359,  1264,   200,   360,
    1328,  1329,  1330,   205,   206,   184,   185,   186,   187,   188,
     189,   360,  1442,   360,    19,   361,  1446,  1447,   362,   104,
      72,    72,   201,    50,   360,   204,   360,    80,  1235,   208,
     360,  1238,    85,    86,  1241,  1242,  1243,   365,   262,   360,
      93,    30,   143,    72,  1372,  1373,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    72,    72,   360,  1386,    84,
     360,   360,   360,  1391,  1392,  1393,   360,  1395,   121,   360,
     143,   231,  1502,   362,    98,    19,   360,   360,   360,    13,
    1510,    15,    16,    17,    18,    19,    20,   360,   360,   360,
     105,   360,    26,    27,    28,    29,   228,    31,  1528,   364,
    1307,  1308,  1532,  1310,   360,  1535,   159,   360,   360,     3,
       3,    19,  1440,    15,    19,    19,    19,     3,   362,   279,
    1448,  1449,  1450,    20,  1452,  1453,  1489,   362,  1491,    19,
    1458,    69,    15,    15,   294,    27,    74,  1465,     7,   366,
     366,    15,    18,  1350,   361,    20,  1474,  1475,   360,   360,
     360,    89,   312,    87,    27,   364,    99,   360,    13,    93,
      15,    16,    17,    18,    19,    20,   326,   327,  1496,  1497,
    1498,    26,    27,   366,    29,    19,    31,   360,  1506,  1507,
    1508,    41,   361,   360,   360,   123,   360,   360,  1516,   368,
    1518,   360,   322,   360,   360,    13,   360,    15,    16,    17,
      18,    19,    20,   360,   360,   360,  1534,  1414,    26,    27,
      28,    29,   360,    31,   360,   149,   150,  1424,  1425,  1426,
    1427,   360,   360,    13,   360,    15,    16,    17,    18,    19,
      20,   360,    87,   360,   360,   360,    26,    27,    93,    29,
     360,    31,     8,     9,    10,    11,    12,   360,   360,   360,
     184,   185,     3,   360,   360,   360,    22,    23,    24,    25,
      26,    27,    28,    29,   360,   365,    32,   201,   360,    87,
     204,   365,   360,   211,   208,    93,     3,   167,   168,   169,
     170,   171,   172,   173,    15,   175,   176,   177,   178,   179,
     360,     3,     3,   143,   149,   150,   143,    87,    27,   366,
     360,   141,   360,    93,     8,     9,    10,    11,    12,   143,
     366,   312,    20,   362,   328,   360,   362,   360,    22,    23,
      24,    25,    26,    27,    28,    29,   360,   360,    32,   184,
     185,   149,   150,     3,   360,     3,  1543,   360,   360,   360,
     278,   360,   360,    15,    15,    22,   201,     7,   360,   204,
     360,   362,    15,   208,     8,     9,    10,    11,    12,   149,
     150,   361,   366,   365,   360,    15,   184,   185,    22,    23,
      24,    25,    26,    27,    28,    29,   364,   364,    32,   364,
     364,   364,   360,   201,   360,   360,   204,   360,   365,    22,
     208,   360,   366,   143,   184,   185,    19,   335,   221,   360,
     360,   364,   340,   360,   272,     8,     9,    10,    11,    12,
       3,   201,     3,   361,   204,   362,   362,   355,   208,    22,
      23,    24,    25,    26,    27,    28,    29,   361,    15,    32,
     218,   362,   361,   182,   368,     8,     9,    10,    11,    12,
     361,   295,   296,   297,   298,   299,   300,   301,   302,    22,
      23,    24,    25,    26,    27,    28,    29,   215,   236,    32,
       8,     9,    10,    11,    12,   361,   361,   313,   366,   360,
     216,     8,     9,    10,    22,    23,    24,    25,    26,    27,
      28,    29,   360,   360,    32,    22,    23,    24,    25,    26,
      27,    28,    29,   360,   360,    32,   360,   362,     7,   216,
       8,     9,    10,    11,    12,   360,   361,   365,   312,   216,
     272,   364,   314,   368,    22,    23,    24,    25,    26,    27,
      28,    29,   236,   330,    32,   297,   322,   295,   360,   360,
     313,   360,   362,   360,   360,   360,   307,     8,     9,    10,
      11,    12,   506,   361,   360,   800,   346,   239,  1444,   951,
     368,    22,    23,    24,    25,    26,    27,    28,    29,   954,
    1103,    32,   365,  1031,  1020,     8,     9,    10,    11,    12,
    1167,   361,   525,   708,   372,   841,  1409,   773,   368,    22,
      23,    24,    25,    26,    27,    28,    29,   774,  1489,    32,
       8,     9,    10,    11,    12,   178,   362,  1491,   999,   779,
    1163,  1310,   986,  1277,    22,    23,    24,    25,    26,    27,
      28,    29,   941,  1242,    32,     8,     9,    10,    11,    12,
    1321,  1036,  1260,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,     5,
      32,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   362,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,     5,    -1,
      32,    -1,    -1,    -1,   362,    -1,    41,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
       9,    10,    78,    79,    -1,    81,    82,    -1,    -1,    -1,
      -1,    66,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,   362,   146,    32,    -1,    80,    -1,    -1,    83,    -1,
     106,    -1,    87,    88,    -1,    90,    91,    92,    -1,    -1,
      -1,    -1,    97,    -1,    45,    -1,    -1,    -1,    -1,   362,
     105,    78,    79,    -1,    81,    82,    -1,    -1,    -1,    45,
      -1,   137,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   127,   128,   362,    -1,    -1,    -1,   133,    80,
      -1,    -1,    83,    -1,    -1,    -1,    87,    88,    -1,    -1,
      91,    92,    -1,    45,    80,    -1,    97,    83,    -1,   362,
      -1,    87,    88,    -1,    -1,    91,    92,    -1,   232,    -1,
     137,    97,    -1,    -1,   190,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,    -1,    -1,    -1,   128,    80,   362,
      -1,    83,   133,    -1,    -1,    87,    88,    -1,    -1,    91,
      92,    -1,   128,    -1,    -1,    97,   147,   133,    -1,    -1,
      -1,    -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,
      -1,   285,    -1,   239,   240,   241,   242,   243,   244,   245,
     246,   247,    -1,    -1,    -1,    -1,   128,   360,    -1,    -1,
      -1,   133,    -1,    -1,    -1,   309,    -1,   311,    45,   265,
     266,    -1,    -1,   317,    -1,   319,    -1,    -1,    -1,   323,
     324,    -1,   360,    -1,   280,   281,   282,   283,    -1,    -1,
      -1,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,    -1,    -1,    80,    -1,    -1,    83,    -1,   360,    -1,
      87,    88,    -1,    90,    91,    92,    -1,    -1,   265,   266,
      97,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
      -1,    -1,    -1,   280,   281,   282,   283,    -1,   360,    45,
      -1,    -1,    -1,    -1,    50,    -1,   267,    -1,    -1,    -1,
      -1,   128,    -1,    -1,    -1,    -1,   133,   353,   354,    -1,
      -1,    -1,    -1,   360,    -1,    -1,   341,   342,   343,    -1,
      76,    -1,    -1,   279,    80,   350,    -1,    83,   284,   285,
     286,    87,    88,    89,    -1,    91,    92,    -1,   360,    -1,
     365,    97,    -1,    -1,    90,    -1,   102,    -1,    -1,   105,
      -1,   107,    -1,    99,    45,    65,   353,   354,   104,    -1,
     106,    -1,   108,    -1,   110,   321,   112,    -1,   114,    -1,
      -1,     3,   128,    -1,    -1,    -1,   332,   133,    69,    70,
      71,    45,    73,    74,    -1,    76,    18,    19,    -1,    80,
      -1,   147,    83,   149,   365,   105,    87,    88,    -1,    -1,
      91,    92,   158,    -1,    -1,    -1,    97,    71,    -1,   365,
      -1,    -1,    44,    -1,   336,   337,    80,   127,    -1,    83,
      -1,    -1,    -1,    87,    88,    -1,    -1,    91,    92,    -1,
     140,    -1,    -1,    97,    -1,    -1,    -1,   128,   194,    -1,
      -1,    -1,   133,   365,   154,    -1,    -1,    -1,    80,   113,
      -1,    -1,    -1,    85,    -1,   211,    -1,    -1,    -1,    -1,
      92,    93,   218,   219,   128,   221,    -1,   223,   224,   133,
     226,   227,   104,   229,    -1,    -1,   232,   233,    -1,   235,
      -1,   113,   114,   115,   116,    -1,   118,   119,    -1,    -1,
      -1,    -1,   248,   249,    -1,    -1,    -1,   253,    -1,   255,
     256,   211,   258,    -1,   214,   215,    -1,   263,    -1,    -1,
      -1,   267,   268,    -1,   270,   271,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   365,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      -1,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   271,    77,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,    -1,   287,   210,   289,
     290,   291,   292,   293,   294,    -1,    -1,   102,    -1,    -1,
     300,    -1,    -1,    -1,   304,   305,    -1,    -1,   308,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   365,
      -1,   321,    -1,    -1,    -1,   130,    -1,    -1,   133,   329,
     135,    -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,   144,
      -1,    -1,    -1,    -1,   149,   150,   151,    -1,    -1,     3,
      -1,   156,   157,   158,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,   365,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,     8,
       9,    10,    11,    12,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,    -1,    -1,    -1,   181,    -1,
      -1,   365,   167,   168,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,   178,   179
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   371,   372,    45,    67,    68,    77,   102,   130,
     133,   135,   142,   144,   149,   150,   151,   156,   157,   158,
     396,   397,   398,   399,   400,   401,   452,   453,   454,   455,
     457,   458,   459,   462,   465,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   558,   594,   595,   596,
     597,   598,   599,   600,   601,   620,   622,     0,     3,    33,
      42,    45,    56,    76,    80,    83,    85,    86,    93,   121,
     122,   133,   156,   159,   360,   373,   386,   392,   395,   404,
     406,   409,   411,   414,   416,   417,   419,   420,   427,   437,
     438,   493,   495,   505,   544,   547,   559,   560,   561,   562,
     603,   604,   605,   606,   614,   615,   621,   623,   624,   625,
      19,    20,    44,   491,    20,    55,    63,    64,    65,   402,
       3,   491,   491,   131,   132,   491,   491,     3,   121,   111,
     112,   121,   136,   145,   147,   148,   211,   278,   355,   121,
     121,    75,   111,   112,   152,   153,   154,   155,    13,    15,
      16,    17,    18,    19,    20,    26,    27,    29,    31,    87,
      93,   149,   150,   184,   185,   201,   204,   208,   361,   368,
     510,   523,   528,   531,   532,   533,   535,   537,    35,    44,
     364,   480,   491,    19,    19,    20,    43,    54,   384,   388,
     111,   117,    42,    61,    85,   147,   393,   394,    77,    19,
      84,    19,    80,   123,   111,   384,   537,    19,    19,   421,
     421,   364,    69,    74,    89,   123,   211,   278,   335,   340,
     355,   421,    45,    80,    83,    87,    88,    90,    91,    92,
      97,   128,   133,   365,   422,   440,   421,   421,    50,    76,
      89,   102,   105,   107,   147,   149,   158,   194,   211,   218,
     219,   221,   223,   224,   226,   227,   229,   232,   233,   235,
     248,   249,   253,   255,   256,   258,   263,   267,   268,   270,
     271,   273,   274,   275,   365,   422,   421,   279,   284,   285,
     286,   321,   332,   365,   422,   563,   564,   565,   421,   336,
     337,   365,   422,   421,    41,    66,    90,   105,   127,   304,
     341,   342,   343,   350,   365,   422,   447,   449,   450,   421,
      65,   147,   267,   365,   422,   616,   619,    69,    70,    71,
      73,    74,    76,   365,   405,   408,   422,    71,   113,   365,
     407,   422,    35,    44,   364,   441,   402,     3,     3,   402,
      66,   403,     3,     3,   491,   491,     3,    35,    44,   364,
     444,    80,   467,    19,    20,    44,   492,     3,   146,   463,
       3,     3,   460,   466,   222,    19,    90,   154,   320,   333,
     334,   456,   456,    18,    19,   377,   380,   380,     3,     3,
       3,     3,     3,     3,     3,    15,    19,    28,   361,   367,
     527,   529,   535,    29,   361,   209,    27,   209,    15,   367,
     530,   537,   361,   361,   361,   361,   361,   361,   186,   187,
     188,   189,   517,   537,    15,    16,    17,    19,   361,   510,
     511,   515,   518,   519,   521,   523,   524,   525,     5,    78,
      79,    81,    82,   106,   137,   190,   191,   193,   194,   195,
     196,   197,   198,   199,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   265,   266,   280,   281,   282,   283,   353,
     354,   536,   626,     3,     8,     9,    10,    11,    12,    22,
      23,    24,    25,    26,    27,    28,    29,    32,    45,    46,
      47,    48,    49,    50,    51,    52,    53,   390,   391,    15,
     481,     3,    22,    62,   387,    44,   364,   389,   441,    15,
      19,   361,   374,    20,    57,    58,   360,   140,   129,   415,
      15,    17,    18,   106,   410,   494,    19,   412,   444,   360,
     506,   106,   364,   364,   418,   364,   441,    19,   426,    84,
     374,    34,    35,    36,    37,   374,   376,   439,    44,    93,
      94,    98,   103,   210,   423,   502,    98,   423,    98,   384,
     444,   360,   360,   364,   364,   140,   237,    77,   360,   238,
     384,   376,    98,   276,   147,   252,   126,   376,   360,   374,
     377,   143,   377,    72,   225,    72,   223,   230,   240,   241,
     234,   236,   250,   251,   250,   254,   376,   257,   259,   264,
      80,   234,    89,   269,   234,   272,   270,   376,   221,   360,
     364,   410,   376,    83,   374,   376,   319,   360,   364,   364,
      80,   338,   339,   360,   364,   374,    72,   612,   613,   384,
     364,    94,   348,   349,   607,   374,   374,    72,   219,   351,
     352,   360,   360,   364,   364,   312,   380,    80,   360,   165,
     228,   260,   269,   356,   357,   358,   359,   360,    80,   376,
      72,   376,    75,    77,   360,   360,   360,    72,    20,   385,
     360,   360,    75,    95,    96,   109,   110,   112,   442,   443,
       3,   403,     3,   374,     3,     3,     3,    95,   134,   445,
     446,     3,    19,     3,   492,     3,     3,     3,    80,   116,
     131,   143,   464,     3,    44,    80,    85,    92,    93,   104,
     113,   114,   115,   116,   118,   119,   380,   461,   502,     3,
      19,    80,    85,    86,    93,   121,   159,   456,   456,   456,
     602,    44,   456,    44,   456,     3,     3,    29,   363,   382,
     141,   141,   529,   529,   537,   529,   529,    14,    15,   537,
     541,   542,    26,   209,    27,   530,   530,    29,   537,   537,
     537,   537,   537,    19,    15,   366,   362,   366,    28,   513,
     514,   517,   537,     7,   366,   369,    26,    27,   364,   366,
     369,   537,   537,   537,   537,   537,   537,   537,   537,   537,
     537,   537,   537,   537,   169,   192,   200,   205,   206,   365,
     366,     3,   537,   384,   390,   360,   537,   374,    59,    60,
      59,    60,   374,   434,   435,   360,   167,   168,   169,   170,
     171,   172,   173,   175,   176,   177,   178,   179,   496,   497,
     498,   500,   504,    41,   124,   125,   126,   360,   413,   360,
     361,   503,    19,   121,   365,   410,   428,   431,   432,    19,
     500,   501,    35,   374,   425,   104,   537,   425,   425,   546,
      72,    72,    72,   277,   376,    50,   360,   360,   374,   214,
     215,   376,   262,   376,   377,   360,   360,    30,   378,   374,
     143,   374,    72,   374,    72,   103,   231,   374,   374,   376,
      72,   360,    84,   360,   376,   360,   376,   231,   260,   261,
     376,   426,   376,   360,   360,   376,   376,   376,   360,   143,
     376,    98,   376,   566,    19,   360,   360,   360,   374,   432,
     360,   448,   449,   360,   360,   360,   374,   360,   360,   360,
      84,   120,   164,   451,   376,   426,    20,   377,   377,   228,
     617,   618,   374,   374,   376,   376,   374,   377,   380,   381,
     365,   366,     3,   365,   366,     3,    19,    15,   380,    19,
      19,   501,   381,    19,     3,    20,   593,   593,     3,    19,
      83,   231,   279,   294,   312,   326,   327,   456,   593,   456,
     593,   374,   377,    15,    15,   362,   366,   362,    27,   366,
     366,   366,   362,   366,   362,   366,   537,   537,     7,   366,
     366,   362,    18,   361,   511,   519,    15,    18,   524,   361,
     391,   360,   365,   362,    20,   360,   432,   360,    19,   174,
     360,   364,   374,   377,   362,   497,   499,   504,   380,    27,
     430,   366,    99,   424,   376,    90,   218,   219,   365,   422,
     545,   374,   374,   374,   360,   360,   376,   360,   360,   360,
     360,   376,   360,   360,    19,    41,   379,   360,   374,   360,
     374,   360,   374,   360,   360,   360,   360,   360,   374,   410,
     360,   360,   360,   360,   360,   360,   360,   360,   360,   360,
     360,   360,   374,   374,    90,   146,   232,   285,   309,   311,
     317,   319,   323,   324,   365,   567,   574,   577,   360,   360,
     364,   611,   365,   360,   360,   374,   106,   108,   106,   108,
     365,   360,   360,   378,   377,   322,   617,   443,   446,     3,
       3,   410,   410,    15,   410,   593,     3,   593,     3,   143,
     143,   541,    27,   537,   537,   537,   537,   537,   366,   362,
     513,   537,   514,   516,   537,   537,   366,   537,   498,    19,
      50,    87,   160,   161,   162,   163,   164,   165,   166,   180,
     183,   507,   508,   533,   534,   538,   543,   360,   362,   141,
      20,   381,   429,   431,    77,   100,   101,   102,   548,   552,
     548,   553,   377,   557,   360,   366,   360,   360,   360,   360,
     374,   143,   360,   360,   360,   360,   360,   360,   586,   592,
     376,   287,   288,   323,   287,   376,   568,   312,   380,   570,
     571,   569,   325,   376,   360,   328,   587,   610,   448,   360,
      20,   383,   383,   383,   383,   378,   374,     3,     3,    15,
      15,   362,   362,   362,   362,   366,   537,   362,   366,    15,
     362,    22,   361,    22,   361,   537,   537,   537,   365,   543,
     536,   626,   360,   537,   539,   540,   499,    15,   381,   432,
     433,   364,   551,    30,   220,   554,   374,   374,   432,   588,
     374,   374,   376,   374,   364,   410,   364,   364,   374,   374,
     364,   215,   234,   271,   337,   365,   609,   451,   360,   360,
     360,   360,   467,   467,   537,   362,     7,    28,   516,   365,
     537,   542,   537,   533,   360,   181,   364,    22,    22,    32,
     366,   360,   143,   551,   550,    19,   384,   221,   555,   360,
     360,   589,   364,   591,   579,   572,   579,   575,   138,   139,
     292,   436,   374,   272,   295,   344,   345,   346,   347,   608,
     360,   451,   451,   451,   451,     3,     3,   362,   361,   362,
       7,   362,   360,   362,   360,   626,   364,   509,   543,   526,
     537,   537,    93,   149,   150,   204,   209,   540,    15,   107,
     212,   213,   216,   217,   365,   549,   377,   218,   556,   587,
     590,   365,   380,   580,   581,   146,   287,   310,   365,   573,
     365,   140,   289,   290,   291,   293,   304,   365,   447,   576,
     374,   374,   374,   215,   376,   513,   516,   362,   507,   182,
       6,    15,    16,    17,   361,   365,   510,   512,   515,   518,
     520,   522,   360,   360,   361,   361,   361,   361,   360,   360,
     376,   214,   215,   215,   374,   375,   374,   360,   376,    65,
     140,   154,   211,   214,   215,   271,   274,   285,   287,   289,
     290,   291,   292,   293,   294,   300,   304,   305,   308,   321,
     329,   365,   447,   578,   310,   318,   582,   376,   374,   376,
     360,   374,   374,   374,   236,   115,   374,    94,   303,   306,
     360,   313,   366,   362,   360,   365,   509,   507,   537,     7,
     363,   366,   537,   537,   537,   537,   216,   216,   216,    38,
      39,    40,   312,   374,   364,   376,   314,   292,   331,   436,
     272,   376,   376,   374,   374,   374,   236,   374,   115,   374,
     295,   296,   297,   298,   299,   300,   301,   302,   330,    94,
     303,   306,   297,   374,   322,   295,   360,   374,   360,   374,
     374,   513,   362,   361,   512,   507,   520,   362,   362,   362,
     362,   375,   375,   375,   376,   583,   315,   316,   374,   374,
     374,   215,   376,   374,   374,   376,   376,   374,   376,   362,
     537,   360,   360,   360,   360,    18,   365,   585,   313,   307,
     584,   360
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 714 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 715 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 728 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 738 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 739 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 746 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 747 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 748 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 756 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 757 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 758 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 759 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 760 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 761 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 768 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 775 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 776 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 780 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 781 "cf-parse.y"
    {
     if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 65535)) cf_error("Invalid port number");
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 788 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 796 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 800 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 804 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 811 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 820 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[(1) - (1)].s)).s;
   }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 827 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 828 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 834 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 843 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 844 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 848 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 853 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 854 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 858 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 859 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 863 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 864 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 868 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 869 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 870 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 871 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 872 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 873 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 874 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 875 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 876 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 882 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 883 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 892 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 893 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 894 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 895 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 898 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 899 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 900 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 901 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 902 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 903 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 915 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 918 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 925 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 928 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 931 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 934 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 937 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 942 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 943 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 944 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 952 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 957 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 958 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 962 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 969 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 970 "cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 976 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 981 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 985 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 999 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1013 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 1014 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 1018 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1020 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1039 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1040 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1041 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1042 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1047 "cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1053 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1054 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 1058 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 1066 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1072 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1086 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1087 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1091 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1097 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1101 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1113 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1117 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1118 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1119 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1120 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1121 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1122 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1123 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1124 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1125 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1126 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1127 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1128 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1132 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1134 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1135 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1139 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1140 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1141 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1142 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1143 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1147 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1153 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1157 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1165 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1166 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1174 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1182 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1183 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1184 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1188 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1189 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1203 "cf-parse.y"
    { iface_patt_check(); }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1205 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1217 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1218 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1224 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1237 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 1251 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1252 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1253 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 1258 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 1262 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 1263 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 1264 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1265 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 1266 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 1267 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1273 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1274 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 1275 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1280 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1284 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1285 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 1306 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1324 "cf-parse.y"
    { }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1325 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1326 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 1327 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 1328 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 1329 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 1338 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 1341 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 1344 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 1347 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1351 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1355 "cf-parse.y"
    { if_show(); }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1358 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1362 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1365 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1370 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1376 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1383 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1388 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1393 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1398 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1402 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1406 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1410 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1419 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1427 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1431 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1438 "cf-parse.y"
    { (yyval.i) = RSEM_PREEXPORT; }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1439 "cf-parse.y"
    { (yyval.i) = RSEM_EXPORT; }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1440 "cf-parse.y"
    { (yyval.i) = RSEM_NOEXPORT; }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1446 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1449 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 1456 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1463 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1467 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1475 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1476 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1477 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1483 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1486 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1489 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1490 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1491 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1492 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1493 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1494 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1495 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1500 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1505 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1514 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1521 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1528 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1536 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1538 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1540 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1542 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1544 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1546 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1548 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1551 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1554 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1560 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1561 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1562 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1566 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1567 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1574 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1576 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1578 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1580 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1582 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1584 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1588 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1592 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1595 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1598 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1599 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1600 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1604 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1605 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1606 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1614 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1615 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1624 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1628 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1629 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1630 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1631 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1632 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1633 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1634 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1635 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1636 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1637 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1638 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1639 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1640 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1661 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1672 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1673 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1680 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1681 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1688 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1697 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1705 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1729 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1730 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1734 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1747 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1750 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1763 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1764 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1767 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1768 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 1772 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 1775 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 1784 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1797 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1798 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 1799 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1800 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1801 "cf-parse.y"
    {
     (yyval.v) = f_eval((yyvsp[(2) - (3)].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1805 "cf-parse.y"
    {
     if (!cf_symbol_is_constant((yyvsp[(1) - (1)].s))) cf_error("%s: constant expected", (yyvsp[(1) - (1)].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[(1) - (1)].s)))) cf_error("%s: set-incompatible type", (yyvsp[(1) - (1)].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[(1) - (1)].s)->def);
   }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1813 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1814 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1815 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1816 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 1817 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 1821 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 1824 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1825 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 1826 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 1830 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1833 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1842 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 1845 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 1846 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 1847 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1848 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1852 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 1853 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1854 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1860 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 1861 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1867 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 1868 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 1873 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 1878 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 1882 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 1889 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 1890 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 1891 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 1892 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 1899 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 1900 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 1903 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 1904 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 1911 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 1923 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 1924 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 1928 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 1929 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 1933 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 1934 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 1936 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 1937 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 1941 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 1942 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 1943 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 1947 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 1948 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 1949 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 1950 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 369:
/* Line 1792 of yacc.c  */
#line 1951 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 370:
/* Line 1792 of yacc.c  */
#line 1952 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 371:
/* Line 1792 of yacc.c  */
#line 1953 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 1954 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 1955 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 374:
/* Line 1792 of yacc.c  */
#line 1956 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 375:
/* Line 1792 of yacc.c  */
#line 1957 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 376:
/* Line 1792 of yacc.c  */
#line 1961 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 1962 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 379:
/* Line 1792 of yacc.c  */
#line 1976 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 1999 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 381:
/* Line 1792 of yacc.c  */
#line 2013 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2014 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2015 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 2016 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2017 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2018 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2019 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2020 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2021 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2022 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2026 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2027 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2028 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2029 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2030 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2031 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 2032 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2033 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2034 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2035 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2036 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2037 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2038 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 2039 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2040 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2041 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2045 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2047 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2049 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2051 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2053 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2054 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2055 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2056 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2057 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2067 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2068 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 420:
/* Line 1792 of yacc.c  */
#line 2069 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2070 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2071 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2072 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2073 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2075 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2076 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2081 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2104 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2105 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2106 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2107 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2108 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2109 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2113 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2116 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2117 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2118 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2126 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2133 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2142 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2143 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2147 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 2153 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2163 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2172 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2178 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2183 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2190 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2195 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2201 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2202 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2203 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2211 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2212 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2213 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2214 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2215 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2222 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, sizeof(struct bfd_config), (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 2249 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2260 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2261 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2262 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2263 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2264 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2265 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2279 "cf-parse.y"
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2282 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2286 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2287 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2288 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2292 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2293 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2297 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2298 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2302 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 2321 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 2326 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
 }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2352 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2353 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2354 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (8)].a)) != !(yyvsp[(4) - (8)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (8)].a);
     BGP_CFG->iface = (yyvsp[(4) - (8)].iface);
     BGP_CFG->remote_port = ((yyvsp[(5) - (8)].i) > 0) ? (yyvsp[(5) - (8)].i) : BGP_PORT;
     BGP_CFG->remote_as = (yyvsp[(7) - (8)].i);
   }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2365 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 2366 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2367 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2368 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 2369 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 2370 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2371 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2372 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2373 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2374 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 504:
/* Line 1792 of yacc.c  */
#line 2375 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 505:
/* Line 1792 of yacc.c  */
#line 2376 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 506:
/* Line 1792 of yacc.c  */
#line 2377 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 507:
/* Line 1792 of yacc.c  */
#line 2378 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 508:
/* Line 1792 of yacc.c  */
#line 2379 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 509:
/* Line 1792 of yacc.c  */
#line 2380 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 510:
/* Line 1792 of yacc.c  */
#line 2381 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 2382 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 2383 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 2384 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 2385 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 2386 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 2387 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 2388 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2389 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 2390 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 2391 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2392 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2393 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2394 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2395 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2396 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 2397 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 527:
/* Line 1792 of yacc.c  */
#line 2398 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 528:
/* Line 1792 of yacc.c  */
#line 2399 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 529:
/* Line 1792 of yacc.c  */
#line 2404 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 530:
/* Line 1792 of yacc.c  */
#line 2405 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 531:
/* Line 1792 of yacc.c  */
#line 2406 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 2407 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_RX; }
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 2408 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_TX; }
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 2409 "cf-parse.y"
    { BGP_CFG->add_path = (yyvsp[(4) - (5)].i) ? ADD_PATH_FULL : 0; }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2410 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2411 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2412 "cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); }
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 2413 "cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 2414 "cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2415 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2416 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2417 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 543:
/* Line 1792 of yacc.c  */
#line 2428 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 547:
/* Line 1792 of yacc.c  */
#line 2444 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2445 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2446 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 550:
/* Line 1792 of yacc.c  */
#line 2447 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 551:
/* Line 1792 of yacc.c  */
#line 2448 "cf-parse.y"
    { OSPF_CFG->merge_external = (yyvsp[(3) - (3)].i); }
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 2449 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 2453 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2468 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2477 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2478 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 2479 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2480 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 2481 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 563:
/* Line 1792 of yacc.c  */
#line 2482 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2483 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2484 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 566:
/* Line 1792 of yacc.c  */
#line 2485 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 2486 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 2487 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 2499 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 2513 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2514 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2515 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 2519 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 2520 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2529 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 2530 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2531 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 2532 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 2533 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 2534 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 2535 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2536 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 2537 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2542 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2563 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2564 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2565 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2566 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2567 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2568 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2569 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2570 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2571 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 607:
/* Line 1792 of yacc.c  */
#line 2572 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 608:
/* Line 1792 of yacc.c  */
#line 2573 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 609:
/* Line 1792 of yacc.c  */
#line 2574 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2575 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2576 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2577 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2578 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2579 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 2580 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 2581 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 617:
/* Line 1792 of yacc.c  */
#line 2582 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2583 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2584 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 620:
/* Line 1792 of yacc.c  */
#line 2585 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 2587 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2588 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2589 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2590 "cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2591 "cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2592 "cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2593 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 629:
/* Line 1792 of yacc.c  */
#line 2594 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 630:
/* Line 1792 of yacc.c  */
#line 2595 "cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 2596 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 632:
/* Line 1792 of yacc.c  */
#line 2597 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 2598 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 634:
/* Line 1792 of yacc.c  */
#line 2599 "cf-parse.y"
    { OSPF_PATT->bsd_secondary = (yyvsp[(2) - (2)].i); }
    break;

  case 639:
/* Line 1792 of yacc.c  */
#line 2611 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 641:
/* Line 1792 of yacc.c  */
#line 2621 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 642:
/* Line 1792 of yacc.c  */
#line 2622 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2631 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2632 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 2636 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 648:
/* Line 1792 of yacc.c  */
#line 2645 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 650:
/* Line 1792 of yacc.c  */
#line 2670 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 2674 "cf-parse.y"
    { if (OSPF_VERSION == 3) iface_patt_check(); }
    break;

  case 657:
/* Line 1792 of yacc.c  */
#line 2688 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 2693 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 660:
/* Line 1792 of yacc.c  */
#line 2699 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 2702 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 2705 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 2710 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 2713 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 2718 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2721 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2725 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2728 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2731 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 2732 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 671:
/* Line 1792 of yacc.c  */
#line 2733 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 672:
/* Line 1792 of yacc.c  */
#line 2734 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 2735 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 2736 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 2737 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 676:
/* Line 1792 of yacc.c  */
#line 2738 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 677:
/* Line 1792 of yacc.c  */
#line 2744 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 2753 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 681:
/* Line 1792 of yacc.c  */
#line 2758 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 2759 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2765 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 686:
/* Line 1792 of yacc.c  */
#line 2774 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 2775 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 2776 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 2777 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 2778 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2779 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 693:
/* Line 1792 of yacc.c  */
#line 2781 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 694:
/* Line 1792 of yacc.c  */
#line 2782 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 2783 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 2788 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2789 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2790 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2795 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 701:
/* Line 1792 of yacc.c  */
#line 2796 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 702:
/* Line 1792 of yacc.c  */
#line 2797 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 703:
/* Line 1792 of yacc.c  */
#line 2798 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2799 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 2803 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 2804 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 708:
/* Line 1792 of yacc.c  */
#line 2805 "cf-parse.y"
    { RIP_IPATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 709:
/* Line 1792 of yacc.c  */
#line 2806 "cf-parse.y"
    { RIP_IPATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 2807 "cf-parse.y"
    { RIP_IPATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2808 "cf-parse.y"
    { RIP_IPATT->ttl_security = 2; }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 2822 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
    break;

  case 718:
/* Line 1792 of yacc.c  */
#line 2841 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 721:
/* Line 1792 of yacc.c  */
#line 2850 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 722:
/* Line 1792 of yacc.c  */
#line 2851 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 724:
/* Line 1792 of yacc.c  */
#line 2855 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 725:
/* Line 1792 of yacc.c  */
#line 2864 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 726:
/* Line 1792 of yacc.c  */
#line 2872 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 2879 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 728:
/* Line 1792 of yacc.c  */
#line 2880 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 2884 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 2889 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 731:
/* Line 1792 of yacc.c  */
#line 2895 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 732:
/* Line 1792 of yacc.c  */
#line 2898 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 2903 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 2904 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 2905 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 2906 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 737:
/* Line 1792 of yacc.c  */
#line 2907 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2911 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 804:
/* Line 1792 of yacc.c  */
#line 2919 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 805:
/* Line 1792 of yacc.c  */
#line 2919 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 807:
/* Line 1792 of yacc.c  */
#line 2919 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 816:
/* Line 1792 of yacc.c  */
#line 2922 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 817:
/* Line 1792 of yacc.c  */
#line 2922 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 818:
/* Line 1792 of yacc.c  */
#line 2922 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 819:
/* Line 1792 of yacc.c  */
#line 2922 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 820:
/* Line 1792 of yacc.c  */
#line 2923 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 821:
/* Line 1792 of yacc.c  */
#line 2923 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 822:
/* Line 1792 of yacc.c  */
#line 2924 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 823:
/* Line 1792 of yacc.c  */
#line 2925 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 824:
/* Line 1792 of yacc.c  */
#line 2926 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 825:
/* Line 1792 of yacc.c  */
#line 2927 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 826:
/* Line 1792 of yacc.c  */
#line 2928 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 827:
/* Line 1792 of yacc.c  */
#line 2929 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 828:
/* Line 1792 of yacc.c  */
#line 2930 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 829:
/* Line 1792 of yacc.c  */
#line 2931 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 830:
/* Line 1792 of yacc.c  */
#line 2932 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 831:
/* Line 1792 of yacc.c  */
#line 2933 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 832:
/* Line 1792 of yacc.c  */
#line 2934 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 833:
/* Line 1792 of yacc.c  */
#line 2934 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 834:
/* Line 1792 of yacc.c  */
#line 2934 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 835:
/* Line 1792 of yacc.c  */
#line 2934 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 836:
/* Line 1792 of yacc.c  */
#line 2934 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 837:
/* Line 1792 of yacc.c  */
#line 2934 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 838:
/* Line 1792 of yacc.c  */
#line 2934 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1792 of yacc.c  */
#line 8690 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 2936 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

